/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "sqlparser.y" /* yacc.c:339  */

/**
 * $Id$
 *
 * sqlparser.y
 *
 * TeamFile で使用するSQL文の構文解析を行う関数
 */
#include "httpd.h"
#include "apr_pools.h"
#include "apr_strings.h"
#include "apr_hash.h"

#include "mod_dav_tf.h"
#include "tf_sqlparser.h"
#include "util_common.h"

/*------------------------------------------------------------------------------
  Define fixed value and macros 
  ----------------------------------------------------------------------------*/

/* キャストしたp_ctx を表すマクロ (ルール部でのみ使用可能) */
#define P_CTX	((divy_sql_parser_ctx *)p_ctx)

/* プール取得用マクロ (ルール部でのみ使用可能) */
#define POOL	(((divy_sql_parser_ctx *)p_ctx)->p)

/* エラーコード設定用マクロ (ルール部でのみ使用可能) */
#define SET_ERRCD(cd)	(((divy_sql_parser_ctx *)p_ctx)->errcd = cd)

/*
 * 構文解析パーサが出力するエラーメッセージから取り除く
 * エラーメッセージパートの文字列とその長さ
 */
#define _REMOVE_ERR_MSG_PART	"parse error,"
#define _REMOVE_ERR_MSG_PART_EN (strlen(_REMOVE_ERR_MSG_PART))

/*
 * 詳細な解析エラーの表示を指示する
 */
#define YYERROR_VERBOSE

/*--------------------------------------------------------------
  Declare private functions
  --------------------------------------------------------------*/
void yyerror(divy_sql_parser_ctx *p_ctx, const char *str);
static divy_sql_elemnode * _makeNode(divy_sql_parser_ctx *p_ctx,
					divy_sql_nodetype type, char *value);
static divy_sql_elemnode * _makeExpr(divy_sql_parser_ctx *p_ctx,
					divy_sql_nodetype type,
					char *op,
					divy_sql_elemnode *lnode,
					divy_sql_elemnode *rnode);
static divy_sql_elemnode * _appendExpr(divy_sql_elemnode *l1,
						divy_sql_elemnode *l2);
static void _incrementSelectColCnt(divy_sql_parser_ctx *p_ctx);
static void _resetSelectColCnt(divy_sql_parser_ctx *p_ctx);
static void _resetMaxSelectColCnt(divy_sql_parser_ctx *p_ctx);
static int _validate_lval(apr_pool_t *p, char *op, divy_sql_elemnode *lnode);
static int _enable_making_expr(char *op, divy_sql_elemnode *lnode,
				divy_sql_elemnode *rnode);


#line 130 "sqlparser.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "sqlparser.h".  */
#ifndef YY_YY_SQLPARSER_H_INCLUDED
# define YY_YY_SQLPARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    ABORT_TRANS = 258,
    ABS = 259,
    ABSOLUTE = 260,
    ACCESS = 261,
    ACOS = 262,
    ACTION = 263,
    ADD = 264,
    ADDMONTHS = 265,
    AFTER = 266,
    AGGREGATE = 267,
    ALL = 268,
    ALTER = 269,
    ANALYSE = 270,
    ANALYZE = 271,
    AND = 272,
    ANY = 273,
    AS = 274,
    ASC = 275,
    ASSERTION = 276,
    ASSIGNMENT = 277,
    AT = 278,
    AUTHORIZATION = 279,
    AVG = 280,
    BACKWARD = 281,
    BEFORE = 282,
    BEGIN_TRANS = 283,
    BETWEEN = 284,
    BIGINT = 285,
    BINARY = 286,
    BIT = 287,
    BIT_LENGTH = 288,
    BLOCK = 289,
    BOOLEAN = 290,
    BOTH = 291,
    BY = 292,
    CACHE = 293,
    CALLED = 294,
    CASCADE = 295,
    CASE = 296,
    CAST = 297,
    CHAIN = 298,
    CHAR_P = 299,
    CHARACTER = 300,
    CHARACTERISTICS = 301,
    CHARACTER_LENGTH = 302,
    CHECK = 303,
    CHECKPOINT = 304,
    CLASS = 305,
    CLOSE = 306,
    CLUSTER = 307,
    COALESCE = 308,
    COLLATE = 309,
    COLUMN = 310,
    COMMENT = 311,
    COMMIT = 312,
    COMMITTED = 313,
    CONNECT = 314,
    CONSTRAINT = 315,
    CONSTRAINTS = 316,
    CONVERSION_P = 317,
    CONVERT = 318,
    COPY = 319,
    COUNT = 320,
    CREATE = 321,
    CREATEDB = 322,
    CREATEUSER = 323,
    CROSS = 324,
    CS = 325,
    CUBE = 326,
    CURRENT_DATE = 327,
    CURRENT_TIME = 328,
    CURRENT_TIMESTAMP = 329,
    CURRENT_USER = 330,
    CURSOR = 331,
    CYCLE = 332,
    DATABASE = 333,
    DATE_P = 334,
    DAY_P = 335,
    DEALLOCATE = 336,
    DEC = 337,
    DECIMAL = 338,
    DECLARE = 339,
    DEFAULT = 340,
    DEFERRABLE = 341,
    DEFERRED = 342,
    DEFINER = 343,
    DELETE_P = 344,
    DELIMITER = 345,
    DELIMITERS = 346,
    DESC = 347,
    DISTINCT = 348,
    DO = 349,
    DOMAIN_P = 350,
    DOUBLE = 351,
    DROP = 352,
    EACH = 353,
    ELSE = 354,
    ENCODING = 355,
    ENCRYPTED = 356,
    END_TRANS = 357,
    ESCAPE = 358,
    EXCEPT = 359,
    EXCLUSIVE = 360,
    EXECUTE = 361,
    EXISTS = 362,
    EXPLAIN = 363,
    EXTERNAL = 364,
    EXTRACT = 365,
    FALSE_P = 366,
    FETCH = 367,
    FIRST = 368,
    FETCH_FIRST = 369,
    FLOAT_P = 370,
    FOR = 371,
    FORCE = 372,
    FOREIGN = 373,
    FORWARD = 374,
    FREEZE = 375,
    FROM = 376,
    FULL = 377,
    FUNCTION = 378,
    GET = 379,
    GLOBAL = 380,
    GRANT = 381,
    GROUP_P = 382,
    GROUPING = 383,
    HANDLER = 384,
    HAVING = 385,
    HOUR_P = 386,
    ILIKE = 387,
    IMMEDIATE = 388,
    IMMUTABLE = 389,
    IMPLICIT_P = 390,
    INCREMENT = 391,
    INDEX = 392,
    INHERITS = 393,
    INITIALLY = 394,
    INNER_P = 395,
    INOUT = 396,
    IN_P = 397,
    INPUT = 398,
    INSENSITIVE = 399,
    INSERT = 400,
    INSTEAD = 401,
    INT = 402,
    INTEGER = 403,
    INTERSECT = 404,
    INTERVAL = 405,
    INTO = 406,
    INVOKER = 407,
    IS = 408,
    ISNULL = 409,
    ISOLATION = 410,
    JOIN = 411,
    KEY = 412,
    LANCOMPILER = 413,
    LANGUAGE = 414,
    LAST = 415,
    LEADING = 416,
    LEFT = 417,
    LEVEL = 418,
    LIKE = 419,
    LIMIT = 420,
    LISTEN = 421,
    LOAD = 422,
    LOCAL = 423,
    LOCALTIME = 424,
    LOCALTIMESTAMP = 425,
    LOCATION = 426,
    LOWER = 427,
    LOCK_P = 428,
    MATCH = 429,
    MAX = 430,
    MAXVALUE = 431,
    MIN = 432,
    MINUS_P = 433,
    MINUTE_P = 434,
    MINVALUE = 435,
    MODE = 436,
    MODULE = 437,
    MONTH_P = 438,
    MOVE = 439,
    NAMES = 440,
    NATIONAL = 441,
    NATURAL = 442,
    NCHAR = 443,
    NEW = 444,
    NEXT = 445,
    NO = 446,
    NOCREATEDB = 447,
    NOCREATEUSER = 448,
    NONE = 449,
    NOT = 450,
    NOTHING = 451,
    NOTIFY = 452,
    NOTNULL = 453,
    NOWAIT = 454,
    NULL_P = 455,
    NULLIF = 456,
    NULLS = 457,
    NUMERIC = 458,
    OCTET_LENGTH = 459,
    OF = 460,
    OFF = 461,
    OFFSET = 462,
    OIDS = 463,
    OLD = 464,
    ON = 465,
    ONLY = 466,
    OPERATOR = 467,
    OPTION = 468,
    OR = 469,
    ORDER = 470,
    OUT_P = 471,
    OUTER_P = 472,
    OVERLAPS = 473,
    OVERLAY = 474,
    OWNER = 475,
    PARTIAL = 476,
    PARTITION = 477,
    PARTITION_DA = 478,
    PASSWORD = 479,
    PATH_P = 480,
    PENDANT = 481,
    PLACING = 482,
    POSITION = 483,
    PRECISION = 484,
    PREPARE = 485,
    PRIMARY = 486,
    PRIOR = 487,
    PRIVILEGES = 488,
    PROCEDURAL = 489,
    PROCEDURE = 490,
    READ = 491,
    REAL = 492,
    RECHECK = 493,
    REFERENCES = 494,
    REINDEX = 495,
    RELATIVE = 496,
    RENAME = 497,
    REPLACE = 498,
    RESET = 499,
    RESTRICT = 500,
    RETURNS = 501,
    REVOKE = 502,
    RIGHT = 503,
    ROLLBACK = 504,
    ROLLUP = 505,
    ROW = 506,
    ROWID = 507,
    ROWNUM = 508,
    ROWS = 509,
    RR = 510,
    RS = 511,
    RULE = 512,
    SAMPLE = 513,
    SAMPLE_BLOCK = 514,
    SAMPLE_DA = 515,
    SCHEMA = 516,
    SCN = 517,
    SCROLL = 518,
    SECOND_P = 519,
    SECURITY = 520,
    SELECT = 521,
    SEQUENCE = 522,
    SERIALIZABLE = 523,
    SESSION = 524,
    SESSION_USER = 525,
    SET = 526,
    SETOF = 527,
    SETS = 528,
    SHARE = 529,
    SHOW = 530,
    SIBLINGS = 531,
    SIMILAR = 532,
    SIMPLE = 533,
    SMALLINT = 534,
    SOME = 535,
    STABLE = 536,
    START = 537,
    STATEMENT = 538,
    STATISTICS = 539,
    STDIN = 540,
    STDOUT = 541,
    STORAGE = 542,
    STRICT = 543,
    SUBPARTITION = 544,
    SUBPARTITION_DA = 545,
    SUBSTRING = 546,
    SUM = 547,
    SYSID = 548,
    TABLE = 549,
    TEMP = 550,
    TEMPLATE = 551,
    TEMPORARY = 552,
    THEN = 553,
    TIME = 554,
    TIMESTAMP = 555,
    TO = 556,
    TOAST = 557,
    TRAILING = 558,
    TRANSLATE = 559,
    TRANSACTION = 560,
    TREAT = 561,
    TRIGGER = 562,
    TRIM = 563,
    TRUE_P = 564,
    TRUNCATE = 565,
    TRUSTED = 566,
    TYPE_P = 567,
    UNENCRYPTED = 568,
    UNION = 569,
    UNION_JOIN = 570,
    UNIQUE = 571,
    UNKNOWN = 572,
    UNLISTEN = 573,
    UNTIL = 574,
    UPDATE = 575,
    UPPER = 576,
    UR = 577,
    USAGE = 578,
    USER = 579,
    USING = 580,
    VACUUM = 581,
    VALID = 582,
    VALIDATOR = 583,
    VALUES = 584,
    VARCHAR = 585,
    VARCHAR2 = 586,
    VARYING = 587,
    VERBOSE = 588,
    VERSION = 589,
    VIEW = 590,
    VOLATILE = 591,
    WAIT = 592,
    WHEN = 593,
    WHERE = 594,
    WITH = 595,
    WITH_CS = 596,
    WITH_RR = 597,
    WITH_RS = 598,
    WITH_UR = 599,
    WITHOUT = 600,
    WORK = 601,
    WRITE = 602,
    YEAR_P = 603,
    ZONE = 604,
    OP_NOTEQ = 605,
    OP_GT = 606,
    OP_LT = 607,
    OP_CONCAT = 608,
    OP = 609,
    IDENT = 610,
    BIND = 611,
    NAMEDBIND = 612,
    S_REQUIREDSQL = 613,
    M_REQUIREDSQL = 614,
    NCONST = 615,
    SCONST = 616,
    EOF_SCONST = 617,
    QT_IDENT = 618,
    EOF_QT_IDENT = 619,
    EOF_COMMENT = 620,
    ST_YYLEX_OK = 621,
    ST_YYLEX_MISSING_ID = 622,
    ST_YYLEX_MISMATCH_ID = 623,
    ST_YYLEX_MISSING_TOKEN = 624,
    LOW_PRIORITY = 625,
    UMINUS = 626,
    TYPECAST = 627
  };
#endif
/* Tokens.  */
#define ABORT_TRANS 258
#define ABS 259
#define ABSOLUTE 260
#define ACCESS 261
#define ACOS 262
#define ACTION 263
#define ADD 264
#define ADDMONTHS 265
#define AFTER 266
#define AGGREGATE 267
#define ALL 268
#define ALTER 269
#define ANALYSE 270
#define ANALYZE 271
#define AND 272
#define ANY 273
#define AS 274
#define ASC 275
#define ASSERTION 276
#define ASSIGNMENT 277
#define AT 278
#define AUTHORIZATION 279
#define AVG 280
#define BACKWARD 281
#define BEFORE 282
#define BEGIN_TRANS 283
#define BETWEEN 284
#define BIGINT 285
#define BINARY 286
#define BIT 287
#define BIT_LENGTH 288
#define BLOCK 289
#define BOOLEAN 290
#define BOTH 291
#define BY 292
#define CACHE 293
#define CALLED 294
#define CASCADE 295
#define CASE 296
#define CAST 297
#define CHAIN 298
#define CHAR_P 299
#define CHARACTER 300
#define CHARACTERISTICS 301
#define CHARACTER_LENGTH 302
#define CHECK 303
#define CHECKPOINT 304
#define CLASS 305
#define CLOSE 306
#define CLUSTER 307
#define COALESCE 308
#define COLLATE 309
#define COLUMN 310
#define COMMENT 311
#define COMMIT 312
#define COMMITTED 313
#define CONNECT 314
#define CONSTRAINT 315
#define CONSTRAINTS 316
#define CONVERSION_P 317
#define CONVERT 318
#define COPY 319
#define COUNT 320
#define CREATE 321
#define CREATEDB 322
#define CREATEUSER 323
#define CROSS 324
#define CS 325
#define CUBE 326
#define CURRENT_DATE 327
#define CURRENT_TIME 328
#define CURRENT_TIMESTAMP 329
#define CURRENT_USER 330
#define CURSOR 331
#define CYCLE 332
#define DATABASE 333
#define DATE_P 334
#define DAY_P 335
#define DEALLOCATE 336
#define DEC 337
#define DECIMAL 338
#define DECLARE 339
#define DEFAULT 340
#define DEFERRABLE 341
#define DEFERRED 342
#define DEFINER 343
#define DELETE_P 344
#define DELIMITER 345
#define DELIMITERS 346
#define DESC 347
#define DISTINCT 348
#define DO 349
#define DOMAIN_P 350
#define DOUBLE 351
#define DROP 352
#define EACH 353
#define ELSE 354
#define ENCODING 355
#define ENCRYPTED 356
#define END_TRANS 357
#define ESCAPE 358
#define EXCEPT 359
#define EXCLUSIVE 360
#define EXECUTE 361
#define EXISTS 362
#define EXPLAIN 363
#define EXTERNAL 364
#define EXTRACT 365
#define FALSE_P 366
#define FETCH 367
#define FIRST 368
#define FETCH_FIRST 369
#define FLOAT_P 370
#define FOR 371
#define FORCE 372
#define FOREIGN 373
#define FORWARD 374
#define FREEZE 375
#define FROM 376
#define FULL 377
#define FUNCTION 378
#define GET 379
#define GLOBAL 380
#define GRANT 381
#define GROUP_P 382
#define GROUPING 383
#define HANDLER 384
#define HAVING 385
#define HOUR_P 386
#define ILIKE 387
#define IMMEDIATE 388
#define IMMUTABLE 389
#define IMPLICIT_P 390
#define INCREMENT 391
#define INDEX 392
#define INHERITS 393
#define INITIALLY 394
#define INNER_P 395
#define INOUT 396
#define IN_P 397
#define INPUT 398
#define INSENSITIVE 399
#define INSERT 400
#define INSTEAD 401
#define INT 402
#define INTEGER 403
#define INTERSECT 404
#define INTERVAL 405
#define INTO 406
#define INVOKER 407
#define IS 408
#define ISNULL 409
#define ISOLATION 410
#define JOIN 411
#define KEY 412
#define LANCOMPILER 413
#define LANGUAGE 414
#define LAST 415
#define LEADING 416
#define LEFT 417
#define LEVEL 418
#define LIKE 419
#define LIMIT 420
#define LISTEN 421
#define LOAD 422
#define LOCAL 423
#define LOCALTIME 424
#define LOCALTIMESTAMP 425
#define LOCATION 426
#define LOWER 427
#define LOCK_P 428
#define MATCH 429
#define MAX 430
#define MAXVALUE 431
#define MIN 432
#define MINUS_P 433
#define MINUTE_P 434
#define MINVALUE 435
#define MODE 436
#define MODULE 437
#define MONTH_P 438
#define MOVE 439
#define NAMES 440
#define NATIONAL 441
#define NATURAL 442
#define NCHAR 443
#define NEW 444
#define NEXT 445
#define NO 446
#define NOCREATEDB 447
#define NOCREATEUSER 448
#define NONE 449
#define NOT 450
#define NOTHING 451
#define NOTIFY 452
#define NOTNULL 453
#define NOWAIT 454
#define NULL_P 455
#define NULLIF 456
#define NULLS 457
#define NUMERIC 458
#define OCTET_LENGTH 459
#define OF 460
#define OFF 461
#define OFFSET 462
#define OIDS 463
#define OLD 464
#define ON 465
#define ONLY 466
#define OPERATOR 467
#define OPTION 468
#define OR 469
#define ORDER 470
#define OUT_P 471
#define OUTER_P 472
#define OVERLAPS 473
#define OVERLAY 474
#define OWNER 475
#define PARTIAL 476
#define PARTITION 477
#define PARTITION_DA 478
#define PASSWORD 479
#define PATH_P 480
#define PENDANT 481
#define PLACING 482
#define POSITION 483
#define PRECISION 484
#define PREPARE 485
#define PRIMARY 486
#define PRIOR 487
#define PRIVILEGES 488
#define PROCEDURAL 489
#define PROCEDURE 490
#define READ 491
#define REAL 492
#define RECHECK 493
#define REFERENCES 494
#define REINDEX 495
#define RELATIVE 496
#define RENAME 497
#define REPLACE 498
#define RESET 499
#define RESTRICT 500
#define RETURNS 501
#define REVOKE 502
#define RIGHT 503
#define ROLLBACK 504
#define ROLLUP 505
#define ROW 506
#define ROWID 507
#define ROWNUM 508
#define ROWS 509
#define RR 510
#define RS 511
#define RULE 512
#define SAMPLE 513
#define SAMPLE_BLOCK 514
#define SAMPLE_DA 515
#define SCHEMA 516
#define SCN 517
#define SCROLL 518
#define SECOND_P 519
#define SECURITY 520
#define SELECT 521
#define SEQUENCE 522
#define SERIALIZABLE 523
#define SESSION 524
#define SESSION_USER 525
#define SET 526
#define SETOF 527
#define SETS 528
#define SHARE 529
#define SHOW 530
#define SIBLINGS 531
#define SIMILAR 532
#define SIMPLE 533
#define SMALLINT 534
#define SOME 535
#define STABLE 536
#define START 537
#define STATEMENT 538
#define STATISTICS 539
#define STDIN 540
#define STDOUT 541
#define STORAGE 542
#define STRICT 543
#define SUBPARTITION 544
#define SUBPARTITION_DA 545
#define SUBSTRING 546
#define SUM 547
#define SYSID 548
#define TABLE 549
#define TEMP 550
#define TEMPLATE 551
#define TEMPORARY 552
#define THEN 553
#define TIME 554
#define TIMESTAMP 555
#define TO 556
#define TOAST 557
#define TRAILING 558
#define TRANSLATE 559
#define TRANSACTION 560
#define TREAT 561
#define TRIGGER 562
#define TRIM 563
#define TRUE_P 564
#define TRUNCATE 565
#define TRUSTED 566
#define TYPE_P 567
#define UNENCRYPTED 568
#define UNION 569
#define UNION_JOIN 570
#define UNIQUE 571
#define UNKNOWN 572
#define UNLISTEN 573
#define UNTIL 574
#define UPDATE 575
#define UPPER 576
#define UR 577
#define USAGE 578
#define USER 579
#define USING 580
#define VACUUM 581
#define VALID 582
#define VALIDATOR 583
#define VALUES 584
#define VARCHAR 585
#define VARCHAR2 586
#define VARYING 587
#define VERBOSE 588
#define VERSION 589
#define VIEW 590
#define VOLATILE 591
#define WAIT 592
#define WHEN 593
#define WHERE 594
#define WITH 595
#define WITH_CS 596
#define WITH_RR 597
#define WITH_RS 598
#define WITH_UR 599
#define WITHOUT 600
#define WORK 601
#define WRITE 602
#define YEAR_P 603
#define ZONE 604
#define OP_NOTEQ 605
#define OP_GT 606
#define OP_LT 607
#define OP_CONCAT 608
#define OP 609
#define IDENT 610
#define BIND 611
#define NAMEDBIND 612
#define S_REQUIREDSQL 613
#define M_REQUIREDSQL 614
#define NCONST 615
#define SCONST 616
#define EOF_SCONST 617
#define QT_IDENT 618
#define EOF_QT_IDENT 619
#define EOF_COMMENT 620
#define ST_YYLEX_OK 621
#define ST_YYLEX_MISSING_ID 622
#define ST_YYLEX_MISMATCH_ID 623
#define ST_YYLEX_MISSING_TOKEN 624
#define LOW_PRIORITY 625
#define UMINUS 626
#define TYPECAST 627

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 93 "sqlparser.y" /* yacc.c:355  */

		char *str;			/* 色々..           */
		char *keyword;			/* SQLキーワード    */
		divy_sql_elemnode *node;	/* 解析途中のノード */
	

#line 921 "sqlparser.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif



int yyparse (divy_sql_parser_ctx *p_ctx);

#endif /* !YY_YY_SQLPARSER_H_INCLUDED  */

/* Copy the second part of user declarations.  */
#line 98 "sqlparser.y" /* yacc.c:358  */

/*------------------------------------------------------------------------------
  Define fixed value and macros for bison
  ----------------------------------------------------------------------------*/
/*
 * yyparse の引数の書き換え
 * (note)
 * 	divy_sql_parser_ctx を引数に渡す
 */
#define YYPARSE_PARAM p_ctx

/*
 * yylex の引数の置き換え
 * (note)
 *      divy_sql_parser_ctx を引数に渡す
 */
#define YYLEX_PARAM p_ctx
/*
 * yylex の置き換え
 * (note)
 *	緩衝ルーチンを使用したyylex を構文解析パーサでは使用する.
 */
#ifndef yylex
#define yylex tf_inter_yylex
#endif	/* yylex */

/* 緩衝ルーチンの外部宣言 */
extern int tf_inter_yylex(YYSTYPE *p_yylval, divy_sql_parser_ctx *p_ctx);


#line 967 "sqlparser.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  214
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   8789

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  388
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  100
/* YYNRULES -- Number of rules.  */
#define YYNRULES  571
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  806

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   627

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   378,     2,     2,
     383,   384,   376,   374,   387,   375,   386,   377,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     371,   370,   372,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   381,     2,   382,   379,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   373,   380,   385
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   327,   327,   331,   335,   343,   352,   360,   376,   378,
     385,   386,   392,   405,   405,   417,   417,   422,   422,   427,
     427,   432,   432,   444,   455,   457,   462,   463,   469,   470,
     471,   472,   473,   478,   479,   487,   488,   494,   500,   509,
     514,   520,   526,   532,   540,   553,   561,   568,   569,   572,
     573,   577,   583,   584,   586,   588,   589,   591,   593,   594,
     598,   602,   606,   610,   613,   614,   616,   617,   619,   621,
     623,   624,   628,   635,   639,   640,   642,   644,   648,   651,
     652,   653,   656,   657,   660,   661,   665,   666,   667,   668,
     678,   680,   682,   684,   688,   689,   690,   691,   694,   695,
     696,   699,   700,   704,   705,   709,   710,   711,   712,   726,
     727,   733,   734,   736,   743,   744,   751,   752,   759,   760,
     762,   770,   773,   774,   778,   779,   780,   782,   786,   787,
     788,   791,   792,   799,   801,   804,   805,   806,   807,   817,
     818,   819,   832,   834,   837,   838,   840,   849,   850,   856,
     857,   858,   859,   860,   867,   875,   882,   883,   884,   885,
     886,   912,   922,   937,   952,   970,   986,   994,  1002,  1027,
    1053,  1080,  1107,  1132,  1157,  1183,  1214,  1215,  1216,  1217,
    1218,  1219,  1220,  1221,  1222,  1223,  1225,  1226,  1228,  1234,
    1235,  1237,  1239,  1240,  1241,  1242,  1243,  1244,  1245,  1246,
    1247,  1249,  1250,  1251,  1252,  1254,  1256,  1257,  1258,  1259,
    1260,  1261,  1262,  1263,  1264,  1265,  1272,  1273,  1274,  1276,
    1278,  1284,  1285,  1290,  1291,  1292,  1293,  1294,  1295,  1296,
    1297,  1298,  1299,  1300,  1301,  1302,  1303,  1304,  1305,  1306,
    1307,  1308,  1309,  1310,  1311,  1312,  1313,  1320,  1321,  1325,
    1326,  1332,  1335,  1338,  1339,  1346,  1350,  1351,  1357,  1361,
    1362,  1363,  1367,  1368,  1369,  1376,  1377,  1378,  1385,  1386,
    1387,  1388,  1390,  1391,  1392,  1393,  1394,  1395,  1403,  1404,
    1405,  1411,  1412,  1419,  1420,  1424,  1425,  1426,  1427,  1428,
    1429,  1430,  1431,  1432,  1433,  1441,  1443,  1445,  1452,  1453,
    1455,  1457,  1458,  1459,  1460,  1463,  1464,  1465,  1466,  1467,
    1468,  1471,  1472,  1473,  1474,  1475,  1476,  1479,  1480,  1483,
    1484,  1485,  1486,  1487,  1488,  1491,  1492,  1493,  1496,  1497,
    1498,  1499,  1500,  1503,  1506,  1507,  1510,  1513,  1514,  1515,
    1516,  1517,  1520,  1521,  1524,  1525,  1526,  1527,  1530,  1531,
    1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,
    1552,  1553,  1554,  1555,  1556,  1557,  1558,  1559,  1560,  1561,
    1562,  1563,  1564,  1565,  1566,  1567,  1568,  1569,  1570,  1571,
    1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,
    1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,
    1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,
    1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,
    1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,  1620,  1621,
    1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,
    1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,
    1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,
    1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,
    1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,
    1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,
    1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,  1690,  1691,
    1692,  1693,  1694,  1695,  1699,  1700,  1701,  1707,  1708,  1714,
    1720,  1727,  1728,  1729,  1737,  1745,  1753,  1770,  1771,  1777,
    1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,  1793,  1794,
    1795,  1796,  1797,  1798,  1810,  1811,  1812,  1813,  1814,  1815,
    1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,
    1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,
    1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,
    1846,  1847
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ABORT_TRANS", "ABS", "ABSOLUTE",
  "ACCESS", "ACOS", "ACTION", "ADD", "ADDMONTHS", "AFTER", "AGGREGATE",
  "ALL", "ALTER", "ANALYSE", "ANALYZE", "AND", "ANY", "AS", "ASC",
  "ASSERTION", "ASSIGNMENT", "AT", "AUTHORIZATION", "AVG", "BACKWARD",
  "BEFORE", "BEGIN_TRANS", "BETWEEN", "BIGINT", "BINARY", "BIT",
  "BIT_LENGTH", "BLOCK", "BOOLEAN", "BOTH", "BY", "CACHE", "CALLED",
  "CASCADE", "CASE", "CAST", "CHAIN", "CHAR_P", "CHARACTER",
  "CHARACTERISTICS", "CHARACTER_LENGTH", "CHECK", "CHECKPOINT", "CLASS",
  "CLOSE", "CLUSTER", "COALESCE", "COLLATE", "COLUMN", "COMMENT", "COMMIT",
  "COMMITTED", "CONNECT", "CONSTRAINT", "CONSTRAINTS", "CONVERSION_P",
  "CONVERT", "COPY", "COUNT", "CREATE", "CREATEDB", "CREATEUSER", "CROSS",
  "CS", "CUBE", "CURRENT_DATE", "CURRENT_TIME", "CURRENT_TIMESTAMP",
  "CURRENT_USER", "CURSOR", "CYCLE", "DATABASE", "DATE_P", "DAY_P",
  "DEALLOCATE", "DEC", "DECIMAL", "DECLARE", "DEFAULT", "DEFERRABLE",
  "DEFERRED", "DEFINER", "DELETE_P", "DELIMITER", "DELIMITERS", "DESC",
  "DISTINCT", "DO", "DOMAIN_P", "DOUBLE", "DROP", "EACH", "ELSE",
  "ENCODING", "ENCRYPTED", "END_TRANS", "ESCAPE", "EXCEPT", "EXCLUSIVE",
  "EXECUTE", "EXISTS", "EXPLAIN", "EXTERNAL", "EXTRACT", "FALSE_P",
  "FETCH", "FIRST", "FETCH_FIRST", "FLOAT_P", "FOR", "FORCE", "FOREIGN",
  "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION", "GET", "GLOBAL",
  "GRANT", "GROUP_P", "GROUPING", "HANDLER", "HAVING", "HOUR_P", "ILIKE",
  "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P", "INCREMENT", "INDEX", "INHERITS",
  "INITIALLY", "INNER_P", "INOUT", "IN_P", "INPUT", "INSENSITIVE",
  "INSERT", "INSTEAD", "INT", "INTEGER", "INTERSECT", "INTERVAL", "INTO",
  "INVOKER", "IS", "ISNULL", "ISOLATION", "JOIN", "KEY", "LANCOMPILER",
  "LANGUAGE", "LAST", "LEADING", "LEFT", "LEVEL", "LIKE", "LIMIT",
  "LISTEN", "LOAD", "LOCAL", "LOCALTIME", "LOCALTIMESTAMP", "LOCATION",
  "LOWER", "LOCK_P", "MATCH", "MAX", "MAXVALUE", "MIN", "MINUS_P",
  "MINUTE_P", "MINVALUE", "MODE", "MODULE", "MONTH_P", "MOVE", "NAMES",
  "NATIONAL", "NATURAL", "NCHAR", "NEW", "NEXT", "NO", "NOCREATEDB",
  "NOCREATEUSER", "NONE", "NOT", "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT",
  "NULL_P", "NULLIF", "NULLS", "NUMERIC", "OCTET_LENGTH", "OF", "OFF",
  "OFFSET", "OIDS", "OLD", "ON", "ONLY", "OPERATOR", "OPTION", "OR",
  "ORDER", "OUT_P", "OUTER_P", "OVERLAPS", "OVERLAY", "OWNER", "PARTIAL",
  "PARTITION", "PARTITION_DA", "PASSWORD", "PATH_P", "PENDANT", "PLACING",
  "POSITION", "PRECISION", "PREPARE", "PRIMARY", "PRIOR", "PRIVILEGES",
  "PROCEDURAL", "PROCEDURE", "READ", "REAL", "RECHECK", "REFERENCES",
  "REINDEX", "RELATIVE", "RENAME", "REPLACE", "RESET", "RESTRICT",
  "RETURNS", "REVOKE", "RIGHT", "ROLLBACK", "ROLLUP", "ROW", "ROWID",
  "ROWNUM", "ROWS", "RR", "RS", "RULE", "SAMPLE", "SAMPLE_BLOCK",
  "SAMPLE_DA", "SCHEMA", "SCN", "SCROLL", "SECOND_P", "SECURITY", "SELECT",
  "SEQUENCE", "SERIALIZABLE", "SESSION", "SESSION_USER", "SET", "SETOF",
  "SETS", "SHARE", "SHOW", "SIBLINGS", "SIMILAR", "SIMPLE", "SMALLINT",
  "SOME", "STABLE", "START", "STATEMENT", "STATISTICS", "STDIN", "STDOUT",
  "STORAGE", "STRICT", "SUBPARTITION", "SUBPARTITION_DA", "SUBSTRING",
  "SUM", "SYSID", "TABLE", "TEMP", "TEMPLATE", "TEMPORARY", "THEN", "TIME",
  "TIMESTAMP", "TO", "TOAST", "TRAILING", "TRANSLATE", "TRANSACTION",
  "TREAT", "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P",
  "UNENCRYPTED", "UNION", "UNION_JOIN", "UNIQUE", "UNKNOWN", "UNLISTEN",
  "UNTIL", "UPDATE", "UPPER", "UR", "USAGE", "USER", "USING", "VACUUM",
  "VALID", "VALIDATOR", "VALUES", "VARCHAR", "VARCHAR2", "VARYING",
  "VERBOSE", "VERSION", "VIEW", "VOLATILE", "WAIT", "WHEN", "WHERE",
  "WITH", "WITH_CS", "WITH_RR", "WITH_RS", "WITH_UR", "WITHOUT", "WORK",
  "WRITE", "YEAR_P", "ZONE", "OP_NOTEQ", "OP_GT", "OP_LT", "OP_CONCAT",
  "OP", "IDENT", "BIND", "NAMEDBIND", "S_REQUIREDSQL", "M_REQUIREDSQL",
  "NCONST", "SCONST", "EOF_SCONST", "QT_IDENT", "EOF_QT_IDENT",
  "EOF_COMMENT", "ST_YYLEX_OK", "ST_YYLEX_MISSING_ID",
  "ST_YYLEX_MISMATCH_ID", "ST_YYLEX_MISSING_TOKEN", "'='", "'<'", "'>'",
  "LOW_PRIORITY", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS",
  "'['", "']'", "'('", "')'", "TYPECAST", "'.'", "','", "$accept", "sql",
  "select_sentence", "select_with_parens", "select_no_parens",
  "select_stmt", "$@1", "$@2", "$@3", "$@4", "$@5",
  "subquery_factoring_clause", "subquery_factoring_list",
  "subquery_factoring_sub_list", "set_quantifier", "opt_query_append",
  "select_stmt_set", "select_col_list", "select_col_sub_list",
  "into_clause", "from_clause", "from_list", "from_sub_list",
  "table_reference", "tablename", "sample_clause", "partition_clause",
  "table_function", "table_alias_name", "column_alias_list_with_parens",
  "column_alias_list", "column_alias_sub_list", "joined_table",
  "join_type", "outer_join_type", "join_specification", "join_column_list",
  "join_column_sub_list", "where_clause", "hierachical_query_clause",
  "groupby_clause", "having_clause", "orderby_clause", "orderby_list",
  "orderby_sub_list", "opt_orderby", "opt_orderby_nulls", "limit_clause",
  "opt_limit", "opt_offset", "fetch_first_clause", "opt_fetch_first",
  "fetch_first_row", "with_clause", "forupdate_clause", "a_expr",
  "simple_expr", "compound_expr", "function_expr", "funcname",
  "reserved_funcname", "case_expr", "simple_case_expr",
  "searched_case_expr", "simple_when_list", "simple_when_sub_list",
  "searched_case_list", "searched_case_sub_list", "else_expr",
  "result_expr", "in_expr", "between_expr", "expr_list", "rval_list_expr",
  "rval_expr", "cast_target_expr", "character_string_type",
  "national_character_string_type", "bit_string_type", "numeric_type",
  "scale_numeric_type", "datetime_type", "interval_type",
  "interval_qualifier", "start_field", "non_second_datetime_field",
  "end_field", "single_datetime_field", "paren_length",
  "unreserved_query_keyword", "sub_type", "single_reqsql_expr",
  "multi_reqsql_expr", "bind_expr", "colname_expr", "eof_idents",
  "all_symbol_op", "math_symbol_op", "separate_op", "restricted_sentence", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
      61,    60,    62,   625,    43,    45,    42,    47,    37,    94,
     626,    91,    93,    40,    41,   627,    46,    44
};
# endif

#define YYPACT_NINF -586

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-586)))

#define YYTABLE_NINF -345

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-345)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     535,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  7830,  -586,  -586,  -235,    29,  -586,    36,  -586,   -65,
    -235,   -66,  -586,    -4,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,    28,  -320,
    -586,    69,  -274,  -257,  -586,    15,   -50,  -586,  -586,  -586,
    -586,  -586,  -586,   -59,  -586,  1606,  -250,  7830,  -221,  -586,
    -586,  -586,  2737,   127,     2,    60,   159,   159,   159,   159,
    -207,  -586,  -586,  -586,  -586,  -586,  1983,  -197,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -195,  -586,  -586,  -586,  -586,
    2737,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  2737,  -188,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  2737,  2737,  -586,  2737,  2737,  2360,
    -586,  -141,  -586,   316,  -586,  -586,  -586,  -186,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -235,  -586,  -235,  -185,
    -586,  5123,  2737,  -586,  -586,  -586,    30,  -586,    12,  -159,
    -586,  -235,  -235,  -235,  -235,  2737,  -136,  5174,    58,    99,
    -103,  -586,  2737,  -586,  8266,   281,  -586,  -586,  -134,  -586,
     -98,    13,  -586,  1606,   122,  2737,  4912,  3114,  -326,  -100,
    -586,  2737,   -12,  -586,  2737,   -54,  -586,  -586,  -586,  2737,
    2737,  -586,  -586,  -586,  2737,  2737,  2737,  2737,  2737,  2737,
    1229,   859,  -586,  -125,  -118,  2737,  -586,  -586,   -79,   123,
      66,  -586,  -185,    17,  -586,  -586,   -48,  -586,  -586,  -586,
    -586,  -586,   154,  -586,  -108,  -586,  -586,  -108,  5290,  -161,
     -14,   -29,   -11,  -586,  -301,  -586,  -301,  -586,  -586,  5187,
    -586,  -586,  3476,    -7,  8266,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -188,  -586,  -586,  -586,  -586,    39,  -586,  -586,
    -586,  -586,  -586,  2360,  -586,  -586,  -586,  -586,   -89,  -586,
    -586,  -586,    97,  3114,  -326,  2737,    33,  5430,  2737,   281,
     281,  -164,  -164,  -134,  -134,  -134,  -586,  -586,  -586,  -586,
     -77,  -195,  3828,   -32,  3828,  -586,  -586,  -586,  -586,  -586,
     -38,  -586,   -31,  -154,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,   144,    37,  -586,  -586,  2737,  -202,
      61,  -586,  -586,  -586,  -586,   254,   258,   460,   -25,  7500,
    -191,  5805,   -18,  -586,    96,  6150,  6495,  -586,  -586,   -91,
    2737,    88,  -586,  3114,  -153,  -586,  -586,  -586,  -586,    10,
     100,  -586,  8348,  2737,  8403,  -586,  -586,  -131,  2737,  -130,
    -586,  3828,  -586,  3828,  -586,  -586,  5290,  -586,  -586,  -586,
    -586,  -202,  -586,  -586,  -304,  -279,  -277,  -586,  -586,  -586,
    -586,  -586,   -60,    95,  -269,  -586,  -586,    -2,    -2,    -1,
       3,    -8,   334,  -586,  -586,  -586,    16,  -586,  -586,  8160,
     -91,  6840,    18,    20,    21,    24,  -586,  -586,  7170,  -586,
    -586,    25,  -586,  3476,   242,  -586,   244,  -586,  -586,   174,
    -586,  3476,  3476,  -132,  7170,    25,  7170,    25,  -586,  -586,
    5290,    74,   282,  -586,  -586,  -586,  -586,  3114,    54,  8410,
      56,  -586,  5226,  -586,  -105,  -586,  -586,    35,    59,  -586,
      40,  -586,    42,  -586,  -586,  -586,  -586,  -586,    44,  -586,
    -586,   115,    -2,  -586,  -259,  -254,    46,  -586,    86,    90,
      68,    71,  -586,   161,    77,  -586,  -586,  7170,    25,    83,
      79,    80,    91,    25,  4194,  -586,  -586,  3476,  -586,  3476,
    -586,   280,  -586,   285,    25,  -586,    25,  -586,  2737,   416,
     324,  -586,  -586,    94,  -586,   460,  -586,   103,    73,   104,
     106,   108,   -45,    75,    98,  -586,   102,  -586,   118,   184,
     187,   107,   119,   132,  -338,    25,  -586,   125,   126,   128,
     133,  -586,  -586,  -586,   -69,  -586,  -586,  -586,  -586,  -586,
     280,  2737,   124,  -586,  -586,  -586,  -586,  5239,  2737,  2737,
    -586,  -586,   135,   136,  -586,   137,   138,   -68,    -2,  -586,
    -586,   146,   163,   140,   176,   177,  -586,  -586,  -586,  -586,
     167,  -586,    45,  -586,  -586,    45,  -586,  4194,  -586,  5290,
    4553,   495,   147,  5290,  -586,  -586,  -586,  -586,  -586,   175,
    -586,   153,   156,  -586,  -586,  -586,   157,  -586,  -586,  -586,
    -586,   -34,  -586,  -586,  -586,  -586,  2737,   160,  -586,  -586,
    -586,  -586,  4553,  5290,  -586,  -586
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     7,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,    13,   565,   566,   567,   568,   569,   570,
     571,     0,     5,     6,     0,     0,     2,    36,     8,   121,
       0,     0,     4,    32,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     377,   376,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   464,   463,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,     0,    23,
      24,     0,    36,     0,     1,     0,   134,     3,    17,    19,
      21,    15,    29,    28,    30,     0,     0,     0,     0,    11,
      10,   120,     0,     0,     0,   143,    34,    34,    34,    34,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,   233,   234,     0,   235,   236,   237,   238,
       0,   181,   239,   240,   242,   179,   180,   241,   243,   244,
     245,   246,     0,   511,   510,   507,   508,   509,   178,   177,
     514,   512,   515,   516,     0,     0,    44,     0,     0,     0,
     185,    46,    37,    39,   156,   157,   159,     0,   222,   158,
     513,   183,   184,   182,   176,   188,     0,    25,     0,   118,
     122,   124,     0,   138,   137,   135,     0,   136,     0,   153,
      33,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     252,   256,     0,   186,   203,   205,   190,   191,   192,   193,
     185,     0,    45,     0,    48,     0,     0,     0,     0,     0,
     207,     0,     0,   209,     0,     0,   528,   529,   530,     0,
       0,   533,   531,   532,     0,     0,     0,     0,     0,     0,
       0,     0,    36,    35,    35,     0,   128,   129,     0,     0,
     125,   126,   119,     0,   146,   144,     0,   145,   151,   149,
     150,   152,   155,    35,    18,    20,    22,    16,   281,     0,
       0,     0,   251,   253,     0,   247,     0,   249,   257,     0,
     189,    38,     0,   110,   201,    43,    40,    41,    42,   272,
     273,   274,   268,   269,   270,   278,   279,     0,   271,   276,
     277,   275,   280,     0,   265,   162,   267,   214,     0,   206,
     212,   210,   168,     0,     0,     0,     0,   202,     0,   200,
     204,   196,   197,   194,   195,   198,   199,   504,   506,   505,
     160,     0,     0,     0,     0,   288,   289,   290,   286,   287,
     291,   216,     0,     0,   283,   293,   294,   292,   285,   297,
      26,    27,   123,   131,   132,   517,   527,   525,   526,   519,
     520,   521,   522,   523,   524,   130,   518,   127,   141,   139,
     133,   140,   147,   148,     0,     0,    12,    31,     0,     0,
       0,   254,   259,   260,   261,     0,     0,     0,     0,     0,
      64,     0,    47,    49,    51,    52,    58,    63,    78,    65,
       0,   113,   166,     0,     0,   215,   208,   213,   211,     0,
       0,   163,   170,     0,   172,   161,   291,     0,     0,     0,
     217,     0,   218,     0,   142,   154,   282,   262,   263,   264,
     258,     0,   248,   250,   349,   349,   349,   328,   327,   326,
     323,   322,     0,     0,   349,   325,   324,   349,   349,     0,
       0,     0,   298,   300,   301,   302,   319,   303,   304,     0,
      64,    55,     0,     0,     0,     0,    66,    68,     0,    79,
      80,    83,    81,     0,     0,   100,     0,    94,    98,     0,
      99,     0,     0,     0,     0,    83,     0,    83,    67,    69,
     109,     0,   115,   164,   266,   169,   167,     0,     0,   174,
       0,   219,     0,   220,     0,   284,   255,     0,     0,   317,
       0,   306,     0,   305,   339,   340,   341,   338,   345,   337,
     333,     0,   349,   335,   349,   349,     0,   313,   329,   331,
       0,     0,   187,     0,     0,    70,    71,     0,    83,     0,
       0,     0,     0,    83,     0,    61,    50,     0,    95,     0,
      91,     0,    96,     0,    83,    53,    83,    59,     0,     0,
     117,   165,   171,     0,   173,     0,   295,     0,     0,     0,
       0,     0,     0,   336,     0,   312,     0,   311,     0,     0,
       0,     0,     0,     0,     0,    83,    56,     0,     0,     0,
       0,    62,    89,   511,     0,    84,    87,    88,    86,    90,
       0,     0,     0,    92,    97,    54,    60,   111,     0,     0,
      14,   175,     0,     0,   348,     0,     0,     0,   349,   342,
     334,     0,     0,     0,     0,     0,   309,   310,   299,   320,
       0,    57,    74,    73,    72,    75,    82,     0,    93,   101,
       0,     0,   114,   116,   296,   318,   308,   307,   346,     0,
     343,     0,     0,   316,   330,   332,     0,    76,    77,    85,
     108,     0,   103,   106,   107,   105,     0,     0,   315,   314,
     321,   102,     0,   112,   347,   104
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -586,  -586,   500,     0,    43,    72,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,   326,  -586,    55,    19,  -586,   213,  -586,
    -586,  -586,   -46,  -585,    48,  -524,    41,  -586,  -435,  -155,
    -586,  -205,  -586,   -44,  -586,  -166,  -586,  -234,  -586,  -586,
    -586,  -586,  -586,   257,   196,  -586,   192,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -223,  -586,  -586,  -340,  -284,
    -586,  -586,  -586,  -586,  -586,   179,  -586,   246,   172,    22,
     141,  -398,  -425,  -443,    47,  -113,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -114,  -586,  -586,   -19,   -37,
    -586,  -346,  -273,  -222,  -357,  -289,  -586,  -586,  -586,  -586
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    45,    46,   290,   213,    49,    53,   239,   236,   237,
     238,    50,   209,   210,   225,   321,    51,   291,   292,   344,
     413,   522,   523,   524,   525,   596,   597,   526,   601,   675,
     724,   725,   527,   612,   613,   733,   791,   792,   531,   622,
     690,   740,   216,   309,   310,   380,   381,   235,   316,   500,
     319,   386,   504,   392,   506,   311,   294,   295,   296,   297,
     298,   299,   328,   329,   402,   403,   330,   331,   515,   560,
     435,   427,   399,   473,   474,   581,   582,   583,   584,   585,
     586,   587,   588,   650,   651,   652,   750,   653,   639,   300,
     461,   301,   302,   303,   304,   305,   495,   496,   370,    52
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      47,   429,   293,   313,   211,   618,   -36,   426,   534,   222,
     342,   437,   317,   384,   478,   314,   231,   443,   498,   547,
     644,   549,   535,   327,   682,   475,   680,   681,   637,   214,
     345,    33,   592,   277,   483,   644,    -9,   334,   218,   -35,
     532,   219,   347,    48,   212,   540,   759,   226,   760,   335,
      47,   -36,   232,   640,   512,   642,   533,   433,   432,   513,
     514,   336,   337,   656,   338,   339,   341,   227,   593,   594,
     220,   645,   528,   704,   430,   436,   349,   350,   706,   638,
     -36,   484,   479,   219,   -35,   683,   645,   472,   228,   223,
     615,   617,   729,    48,   730,   438,   387,   429,   476,   595,
     439,   626,   398,   426,   638,   478,   638,   478,   634,   409,
     229,   536,   220,   -35,   638,   234,   475,   627,   475,   646,
     293,   353,   414,   647,   638,   431,   347,   230,   442,   638,
     444,   447,   592,   306,   646,   623,   449,   450,   647,   654,
     655,   451,   452,   453,   454,   455,   456,   460,    44,   477,
     215,   240,   445,   557,   432,   348,   668,   404,   558,   559,
     405,   501,   308,   673,   312,   604,   349,   350,   593,   594,
     430,   436,   320,   479,   318,   479,   325,   351,   472,   684,
     472,   686,   388,   389,   390,   391,   332,   429,    44,   476,
     211,   476,  -221,   426,   478,  -221,   478,   371,   406,   595,
     539,   407,   375,   502,   648,   475,   503,   475,   352,   440,
     398,   353,   366,   367,   368,   369,   -36,   441,   605,   748,
     537,   431,   542,   507,   400,   544,   508,   354,   538,   691,
     552,   624,   715,   553,   508,   326,   606,   383,   787,   348,
     477,   788,   477,   412,   432,   369,   343,   448,   221,   -35,
     349,   350,   607,   631,   633,   333,   553,   553,   608,   480,
     430,  -345,   479,   528,   479,   446,   481,   472,   378,   472,
     505,   528,   528,   356,   357,   358,   359,   360,   476,   696,
     476,   429,   553,   609,   509,   556,   229,   426,   649,   340,
     355,   233,   322,   323,   324,   353,   605,   364,   365,   366,
     367,   368,   369,   649,   593,   594,   372,   620,   372,   418,
     428,   431,   224,   772,   606,   766,   778,   728,   767,   779,
     629,   372,   372,   372,   372,   632,   510,   401,   726,   477,
     607,   477,   530,   345,   543,   346,   608,   528,   432,   528,
     394,   395,   396,   397,   610,   347,   550,   425,   434,   604,
     801,   548,   551,   802,   430,   554,   562,   555,   274,   561,
     563,   589,   315,   356,   357,   358,   359,   360,   274,   603,
     621,   625,   385,   274,  -345,   529,   662,   499,   373,   663,
     374,   638,   660,   361,   362,   363,   661,   364,   365,   366,
     367,   368,   369,   393,   393,   393,   393,   410,   677,   664,
     678,   669,   605,   670,   671,   431,   428,   672,   674,   689,
     728,   611,   521,   795,   688,   692,   702,   694,   697,   698,
     606,   726,   610,   699,   793,   700,   709,   701,   711,   708,
     710,   712,   713,   340,   349,   350,   607,   714,   717,   718,
     719,   734,   608,   425,   434,   795,   720,   356,   357,   358,
     359,   360,   727,   738,   739,   741,   793,   744,   348,  -344,
     685,   545,   687,   743,   745,   737,   746,   609,   747,   349,
     350,   364,   365,   366,   367,   368,   369,   485,   753,   353,
     351,   751,   529,   754,   602,   752,   755,   758,   602,   602,
     731,   756,   564,   486,   487,   488,   428,   489,   490,   491,
     492,   493,   494,   757,   565,   566,   781,   770,   769,   762,
     763,   352,   764,   716,   353,   398,   773,   765,   721,   774,
     775,   776,   777,   782,   783,   784,   785,   786,   610,   735,
     354,   736,   796,   425,   508,   797,     1,   798,     2,   567,
     799,   800,   568,   569,   804,   727,   641,   643,   794,     3,
     217,     4,   666,   307,   602,   657,   411,   676,   658,   659,
     761,   602,   789,     5,   768,   679,   529,   591,   805,   382,
     619,   482,   497,   803,   529,   529,   408,   602,   516,   602,
     794,   511,   742,   636,     6,   541,     7,     8,   749,     0,
     428,     9,    10,   355,     0,   611,     0,     0,     0,    11,
     635,    12,     0,   521,     0,   732,     0,   570,   571,     0,
     572,   521,   521,     0,     0,     0,    13,     0,     0,    14,
       0,     0,     0,     0,    15,     0,     0,   425,     0,     0,
     602,     0,    16,   703,     0,   705,   707,    17,     0,     0,
     529,    18,   529,    19,     0,     0,   573,    20,   574,     0,
       0,     0,     0,     0,     0,   364,   365,   366,   367,   368,
     369,    21,     0,   575,     0,     0,   356,   357,   358,   359,
     360,     0,     0,     0,     0,     0,     0,   521,     0,   521,
      22,     0,     0,     0,     0,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,   369,     0,     0,     0,     0,
       0,    23,    24,     0,     0,     0,     0,     0,    25,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    26,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   780,
       0,     0,    27,     0,     0,     0,     0,     0,     0,   576,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   577,
     578,     0,     0,     0,     0,    28,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    29,     0,     0,     0,    30,
       0,     0,    31,     0,    32,     0,     0,     0,     0,     0,
     579,   580,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    33,     0,     0,     0,     0,    34,     0,     0,     0,
      35,     0,     0,     0,     0,     0,     0,    36,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,    38,     0,    39,     0,     0,     0,     0,
       0,    40,     0,   241,    54,     0,   242,    55,    56,   243,
      57,    58,   462,     0,     0,    41,     0,     0,     0,     0,
       0,    59,    60,     0,   244,    61,    62,     0,     0,     0,
      42,     0,   245,    63,     0,     0,    64,     0,    65,    66,
      43,   463,    67,     0,     0,    68,   248,     0,    69,    70,
      71,    72,     0,   249,     0,    73,    74,    75,    44,     0,
      76,     0,   250,    77,   251,     0,    78,    79,     0,    80,
      81,   252,   253,   254,     0,    82,     0,     0,     0,    83,
       0,     0,     0,    84,     0,     0,    85,    86,    87,    88,
      89,     0,   464,     0,    90,    91,    92,    93,     0,     0,
      94,     0,    95,     0,     0,    96,     0,     0,    97,   256,
       0,    98,    99,     0,     0,     0,     0,     0,   100,     0,
       0,     0,   101,   102,   103,     0,     0,   104,   105,     0,
     106,     0,   107,   108,     0,     0,     0,   109,     0,     0,
     110,     0,   111,   112,   113,   114,     0,     0,     0,     0,
       0,   115,     0,     0,   116,     0,   117,     0,     0,   118,
       0,     0,   119,     0,     0,     0,     0,   120,     0,     0,
       0,   257,     0,   121,   258,     0,   259,     0,   122,     0,
       0,     0,   123,   124,   125,   126,     0,     0,     0,   127,
     128,   129,   130,     0,     0,   131,   132,     0,     0,   465,
       0,   133,     0,   262,   134,     0,     0,   135,     0,     0,
       0,   136,   137,     0,     0,   138,     0,     0,     0,     0,
     139,   140,     0,   141,   142,   143,     0,   263,   144,     0,
       0,   145,   146,     0,   147,   148,     0,   149,     0,     0,
     150,     0,   264,   151,   152,   153,   154,     0,     0,   155,
     156,   466,   467,   157,   158,   159,   160,   161,     0,     0,
     162,   163,   164,   165,   166,     0,     0,   167,   168,     0,
     169,     0,   170,     0,   171,   172,     0,   173,     0,     0,
     174,     0,   175,   176,   177,   178,   179,   180,   181,     0,
     267,   268,   182,     0,   183,     0,   184,     0,     0,     0,
       0,   185,     0,   269,   186,     0,   187,   270,     0,   188,
       0,   189,   190,     0,     0,     0,   191,     0,   192,   193,
     271,   194,   195,     0,     0,   196,   197,     0,   198,     0,
       0,   199,     0,   200,     0,   201,   202,     0,     0,   203,
       0,     0,     0,     0,   204,     0,   205,   206,   207,     0,
       0,     0,     0,     0,   273,   274,   275,   276,   277,   468,
     469,   280,   281,   282,   283,     0,     0,     0,     0,     0,
       0,     0,     0,   241,    54,   470,   242,    55,    56,   243,
      57,    58,   457,   471,     0,     0,     0,   458,     0,     0,
       0,    59,    60,     0,   244,    61,    62,     0,     0,     0,
       0,     0,   245,    63,     0,     0,    64,     0,    65,    66,
     246,   247,    67,     0,     0,    68,   248,     0,    69,    70,
      71,    72,     0,   249,     0,    73,    74,    75,     0,     0,
      76,     0,   250,    77,   251,     0,    78,    79,     0,    80,
      81,   252,   253,   254,     0,    82,     0,     0,     0,    83,
       0,     0,     0,    84,     0,     0,    85,    86,    87,    88,
      89,     0,     0,     0,    90,    91,    92,    93,     0,     0,
      94,     0,    95,     0,     0,    96,   255,     0,    97,   256,
       0,    98,    99,     0,     0,     0,     0,     0,   100,     0,
       0,     0,   101,   102,   103,     0,     0,   104,   105,     0,
     106,     0,   107,   108,     0,     0,     0,   109,     0,     0,
     110,     0,   111,   112,   113,   114,     0,     0,     0,     0,
       0,   115,     0,     0,   116,     0,   117,     0,     0,   118,
       0,     0,   119,     0,     0,     0,     0,   120,     0,     0,
       0,   257,     0,   121,   258,     0,   259,     0,   122,     0,
       0,     0,   123,   124,   125,   126,     0,     0,     0,   127,
     128,   129,   130,     0,   260,   131,   132,     0,     0,   261,
       0,   133,     0,   262,   134,     0,     0,   135,     0,     0,
       0,   136,   137,     0,     0,   138,     0,     0,     0,     0,
     139,   140,     0,   141,   142,   143,     0,   263,   144,     0,
       0,   145,   146,     0,   147,   148,     0,   149,     0,     0,
     150,     0,   264,   151,   152,   153,   154,     0,     0,   155,
     156,   265,   266,   157,   158,   159,   160,   161,     0,     0,
     162,   163,   164,   165,   166,     0,     0,   167,   168,     0,
     169,     0,   170,     0,   171,   172,     0,   173,     0,   459,
     174,     0,   175,   176,   177,   178,   179,   180,   181,     0,
     267,   268,   182,     0,   183,     0,   184,     0,     0,     0,
       0,   185,     0,   269,   186,     0,   187,   270,     0,   188,
       0,   189,   190,     0,     0,     0,   191,     0,   192,   193,
     271,   194,   195,     0,     0,   196,   197,     0,   198,     0,
       0,   199,     0,   200,     0,   201,   202,     0,     0,   203,
       0,     0,     0,     0,   204,     0,   205,   206,   207,     0,
       0,     0,     0,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,     0,     0,     0,     0,     0,
       0,     0,     0,   284,   285,     0,     0,   287,   288,     0,
     241,    54,   289,   242,    55,    56,   243,    57,    58,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    59,    60,
       0,   244,    61,    62,     0,     0,     0,     0,     0,   245,
      63,     0,     0,    64,     0,    65,    66,   246,   247,    67,
       0,     0,    68,   248,     0,    69,    70,    71,    72,     0,
     249,     0,    73,    74,    75,     0,     0,    76,     0,   250,
      77,   251,     0,    78,    79,     0,    80,    81,   252,   253,
     254,     0,    82,     0,     0,     0,    83,     0,     0,     0,
      84,     0,     0,    85,    86,    87,    88,    89,     0,     0,
       0,    90,    91,    92,    93,     0,     0,    94,     0,    95,
       0,     0,    96,   255,     0,    97,   256,     0,    98,    99,
       0,     0,     0,     0,     0,   100,     0,     0,     0,   101,
     102,   103,     0,     0,   104,   105,     0,   106,     0,   107,
     108,     0,     0,     0,   109,     0,     0,   110,     0,   111,
     112,   113,   114,     0,     0,     0,     0,     0,   115,     0,
       0,   116,     0,   117,     0,     0,   118,     0,     0,   119,
       0,     0,     0,     0,   120,     0,     0,     0,   257,     0,
     121,   258,     0,   259,     0,   122,     0,     0,     0,   123,
     124,   125,   126,     0,     0,     0,   127,   128,   129,   130,
       0,   260,   131,   132,     0,     0,   261,     0,   133,     0,
     262,   134,     0,     0,   135,     0,     0,     0,   136,   137,
       0,     0,   138,     0,     0,     0,     0,   139,   140,     0,
     141,   142,   143,     0,   263,   144,     0,     0,   145,   146,
       0,   147,   148,     0,   149,     0,     0,   150,     0,   264,
     151,   152,   153,   154,     0,     0,   155,   156,   265,   266,
     157,   158,   159,   160,   161,     0,     0,   162,   163,   164,
     165,   166,     0,     0,   167,   168,     0,   169,     0,   170,
       0,   171,   172,     0,   173,     0,     0,   174,     0,   175,
     176,   177,   178,   179,   180,   181,     0,   267,   268,   182,
       0,   183,     0,   184,     0,     0,     0,     0,   185,     0,
     269,   186,     0,   187,   270,     0,   188,     0,   189,   190,
       0,     0,     0,   191,     0,   192,   193,   271,   194,   195,
       0,     0,   196,   197,     0,   198,     0,     0,   199,     0,
     200,     0,   201,   202,     0,     0,   203,     0,     0,     0,
       0,   204,     0,   205,   206,   207,     0,     0,     0,     0,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,     0,     0,     0,     0,     0,     0,     0,
     284,   285,   286,     0,   287,   288,     0,   241,    54,   289,
     242,    55,    56,   243,    57,    58,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    59,    60,     0,   244,    61,
      62,     0,     0,     0,     0,     0,   245,    63,     0,     0,
      64,     0,    65,    66,   246,   247,    67,     0,     0,    68,
     248,     0,    69,    70,    71,    72,     0,   249,     0,    73,
      74,    75,     0,     0,    76,     0,   250,    77,   251,     0,
      78,    79,     0,    80,    81,   252,   253,   254,     0,    82,
       0,     0,     0,    83,     0,     0,     0,    84,     0,     0,
      85,    86,    87,    88,    89,     0,     0,     0,    90,    91,
      92,    93,     0,     0,    94,     0,    95,     0,     0,    96,
     255,     0,    97,   256,     0,    98,    99,     0,     0,     0,
       0,     0,   100,     0,     0,     0,   101,   102,   103,     0,
       0,   104,   105,     0,   106,     0,   107,   108,     0,     0,
       0,   109,     0,     0,   110,     0,   111,   112,   113,   114,
       0,     0,     0,     0,     0,   115,     0,     0,   116,     0,
     117,     0,     0,   118,     0,     0,   119,     0,     0,     0,
       0,   120,     0,     0,     0,   257,     0,   121,   258,     0,
     259,     0,   122,     0,     0,     0,   123,   124,   125,   126,
       0,     0,     0,   127,   128,   129,   130,     0,   260,   131,
     132,     0,     0,   261,     0,   133,     0,   262,   134,     0,
       0,   135,     0,     0,     0,   136,   137,     0,     0,   138,
       0,     0,     0,     0,   139,   140,     0,   141,   142,   143,
       0,   263,   144,     0,     0,   145,   146,     0,   147,   148,
       0,   149,     0,     0,   150,     0,   264,   151,   152,   153,
     154,     0,     0,   155,   156,   265,   266,   157,   158,   159,
     160,   161,     0,     0,   162,   163,   164,   165,   166,     0,
       0,   167,   168,     0,   169,     0,   170,     0,   171,   172,
       0,   173,     0,     0,   174,     0,   175,   176,   177,   178,
     179,   180,   181,     0,   267,   268,   182,     0,   183,     0,
     184,     0,     0,     0,     0,   185,     0,   269,   186,     0,
     187,   270,     0,   188,     0,   189,   190,     0,     0,     0,
     191,     0,   192,   193,   271,   194,   195,     0,     0,   196,
     197,     0,   198,     0,     0,   199,     0,   200,     0,   201,
     202,   326,     0,   203,     0,     0,     0,     0,   204,     0,
     205,   206,   207,     0,     0,     0,     0,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,     0,
       0,     0,     0,     0,     0,     0,     0,   284,   285,     0,
       0,   287,   288,     0,   241,    54,   289,   242,    55,    56,
     243,    57,    58,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    59,    60,     0,   244,    61,    62,     0,     0,
       0,     0,     0,   245,    63,     0,     0,    64,     0,    65,
      66,   246,   247,    67,     0,     0,    68,   248,     0,    69,
      70,    71,    72,     0,   249,     0,    73,    74,    75,     0,
       0,    76,     0,   250,    77,   251,     0,    78,    79,     0,
      80,    81,   252,   253,   254,     0,    82,     0,     0,     0,
      83,     0,     0,     0,    84,     0,     0,    85,    86,    87,
      88,    89,     0,     0,     0,    90,    91,    92,    93,     0,
       0,    94,     0,    95,     0,     0,    96,   255,     0,    97,
     256,     0,    98,    99,     0,     0,     0,     0,     0,   100,
       0,     0,     0,   101,   102,   103,     0,     0,   104,   105,
       0,   106,     0,   107,   108,     0,     0,     0,   109,     0,
       0,   110,     0,   111,   112,   113,   114,     0,     0,     0,
       0,     0,   115,     0,     0,   116,     0,   117,     0,     0,
     118,     0,     0,   119,     0,     0,     0,     0,   120,     0,
       0,     0,   257,     0,   121,   258,     0,   259,     0,   122,
       0,     0,     0,   123,   124,   125,   126,     0,     0,     0,
     127,   128,   129,   130,     0,   260,   131,   132,     0,     0,
     261,     0,   133,     0,   262,   134,     0,     0,   135,     0,
       0,     0,   136,   137,     0,     0,   138,     0,     0,     0,
       0,   139,   140,     0,   141,   142,   143,     0,   263,   144,
       0,     0,   145,   146,     0,   147,   148,     0,   149,     0,
       0,   150,     0,   264,   151,   152,   153,   154,     0,     0,
     155,   156,   265,   266,   157,   158,   159,   160,   161,     0,
       0,   162,   163,   164,   165,   166,    33,     0,   167,   168,
       0,   169,     0,   170,     0,   171,   172,     0,   173,     0,
       0,   174,     0,   175,   176,   177,   178,   179,   180,   181,
       0,   267,   268,   182,     0,   183,     0,   184,     0,     0,
       0,     0,   185,     0,   269,   186,     0,   187,   270,     0,
     188,     0,   189,   190,     0,     0,     0,   191,     0,   192,
     193,   271,   194,   195,     0,     0,   196,   197,     0,   198,
       0,     0,   199,     0,   200,     0,   201,   202,     0,     0,
     203,     0,     0,     0,     0,   204,     0,   205,   206,   207,
       0,     0,     0,     0,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,     0,     0,     0,     0,
       0,     0,     0,     0,   284,   285,     0,     0,   287,   288,
       0,   241,    54,   289,   242,    55,    56,   243,    57,    58,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    59,
      60,     0,   244,    61,    62,     0,     0,     0,     0,     0,
     245,    63,     0,     0,    64,     0,    65,    66,   246,   247,
      67,     0,     0,    68,   248,     0,    69,    70,    71,    72,
       0,   249,     0,    73,    74,    75,     0,     0,    76,     0,
     250,    77,   251,     0,    78,    79,     0,    80,    81,   252,
     253,   254,     0,    82,     0,     0,     0,    83,     0,     0,
       0,    84,     0,     0,    85,    86,    87,    88,    89,     0,
       0,     0,    90,    91,    92,    93,     0,     0,    94,     0,
      95,     0,     0,    96,   255,     0,    97,   256,     0,    98,
      99,     0,     0,     0,     0,     0,   100,     0,     0,     0,
     101,   102,   103,     0,     0,   104,   105,     0,   106,     0,
     107,   108,     0,     0,     0,   109,     0,     0,   110,     0,
     111,   112,   113,   114,     0,     0,     0,     0,     0,   115,
       0,     0,   116,     0,   117,     0,     0,   118,     0,     0,
     119,     0,     0,     0,     0,   120,     0,     0,     0,   257,
       0,   121,   258,     0,   259,     0,   122,     0,     0,     0,
     123,   124,   125,   126,     0,     0,     0,   127,   128,   129,
     130,     0,   260,   131,   132,     0,     0,   261,     0,   133,
       0,   262,   134,     0,     0,   135,     0,     0,     0,   136,
     137,     0,     0,   138,     0,     0,     0,     0,   139,   140,
       0,   141,   142,   143,     0,   263,   144,     0,     0,   145,
     146,     0,   147,   148,     0,   149,     0,     0,   150,     0,
     264,   151,   152,   153,   154,     0,     0,   155,   156,   265,
     266,   157,   158,   159,   160,   161,     0,     0,   162,   163,
     164,   165,   166,     0,     0,   167,   168,     0,   169,     0,
     170,     0,   171,   172,     0,   173,     0,     0,   174,     0,
     175,   176,   177,   178,   179,   180,   181,     0,   267,   268,
     182,     0,   183,     0,   184,     0,     0,     0,     0,   185,
       0,   269,   186,     0,   187,   270,     0,   188,     0,   189,
     190,     0,     0,     0,   191,     0,   192,   193,   271,   194,
     195,     0,     0,   196,   197,     0,   198,     0,     0,   199,
       0,   200,     0,   201,   202,     0,     0,   203,     0,     0,
       0,     0,   204,     0,   205,   206,   207,     0,     0,     0,
       0,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,     0,     0,     0,     0,     0,     0,     0,
       0,   284,   285,     0,     0,   287,   288,     0,   241,    54,
     289,   242,    55,    56,   243,    57,    58,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    59,    60,     0,   244,
      61,    62,     0,     0,     0,     0,     0,   245,    63,     0,
       0,    64,     0,    65,    66,     0,     0,    67,     0,     0,
      68,   248,     0,    69,    70,    71,    72,     0,   249,     0,
      73,    74,    75,     0,     0,    76,     0,   250,    77,   251,
       0,    78,    79,     0,    80,    81,   252,   253,   254,     0,
      82,     0,     0,     0,    83,     0,     0,     0,    84,     0,
       0,    85,    86,    87,    88,    89,     0,     0,     0,    90,
      91,    92,    93,     0,     0,    94,     0,    95,     0,     0,
      96,     0,     0,    97,   256,     0,    98,    99,     0,     0,
       0,     0,     0,   100,     0,     0,     0,   101,   102,   103,
       0,     0,   104,   105,     0,   106,     0,   107,   108,     0,
       0,     0,   109,     0,     0,   110,     0,   111,   112,   113,
     114,     0,     0,     0,     0,     0,   115,     0,     0,   116,
       0,   117,     0,     0,   118,     0,     0,   119,     0,     0,
       0,     0,   120,     0,     0,     0,   257,     0,   121,   258,
       0,   259,     0,   122,     0,     0,     0,   123,   124,   125,
     126,     0,     0,     0,   127,   128,   129,   130,     0,     0,
     131,   132,     0,     0,   419,     0,   133,     0,   262,   134,
       0,     0,   135,     0,     0,     0,   136,   137,     0,     0,
     138,     0,     0,     0,     0,   139,   140,     0,   141,   142,
     143,     0,   263,   144,     0,     0,   145,   146,     0,   147,
     148,     0,   149,     0,     0,   150,     0,   264,   151,   152,
     153,   154,     0,     0,   155,   156,   420,   421,   157,   158,
     159,   160,   161,     0,     0,   162,   163,   164,   165,   166,
       0,     0,   167,   168,     0,   169,     0,   170,     0,   171,
     172,     0,   173,     0,     0,   174,     0,   175,   176,   177,
     178,   179,   180,   181,     0,   267,   268,   182,     0,   183,
       0,   184,     0,     0,     0,     0,   185,     0,   269,   186,
       0,   187,   270,     0,   188,     0,   189,   190,     0,     0,
       0,   191,     0,   192,   193,   271,   194,   195,     0,     0,
     196,   197,     0,   198,     0,     0,   199,     0,   200,     0,
     201,   202,     0,     0,   203,     0,     0,     0,     0,   204,
       0,   205,   206,   207,     0,     0,     0,     0,     0,   422,
     274,   275,   276,   277,   423,   424,   280,     0,   282,   283,
     241,    54,     0,   242,    55,    56,   243,    57,    58,     0,
       0,     0,     0,     0,     0,     0,     0,    44,    59,    60,
       0,   244,    61,    62,     0,     0,     0,     0,     0,   245,
      63,     0,     0,    64,     0,    65,    66,     0,     0,    67,
       0,     0,    68,   248,     0,    69,    70,    71,    72,     0,
     249,     0,    73,    74,    75,     0,     0,    76,     0,   250,
      77,   251,     0,    78,    79,     0,    80,    81,   252,   253,
     254,     0,    82,     0,     0,     0,    83,     0,     0,     0,
      84,     0,     0,    85,    86,    87,    88,    89,     0,     0,
       0,    90,    91,    92,    93,     0,     0,    94,     0,    95,
       0,     0,    96,     0,     0,    97,   256,     0,    98,    99,
       0,     0,     0,     0,     0,   100,     0,     0,     0,   101,
     102,   103,     0,     0,   104,   105,     0,   106,     0,   107,
     108,     0,     0,     0,   109,     0,     0,   110,     0,   111,
     112,   113,   114,     0,     0,     0,     0,     0,   115,     0,
       0,   116,     0,   117,     0,     0,   118,     0,     0,   119,
       0,     0,     0,     0,   120,     0,     0,     0,   257,     0,
     121,   258,     0,   259,     0,   122,     0,     0,   518,   123,
     124,   125,   126,     0,     0,     0,   127,   128,   129,   130,
       0,     0,   131,   132,     0,     0,     0,     0,   133,     0,
     262,   134,     0,     0,   135,     0,     0,   519,   136,   137,
       0,     0,   138,     0,     0,     0,     0,   139,   140,     0,
     141,   142,   143,     0,   263,   144,     0,     0,   145,   146,
       0,   147,   148,     0,   149,     0,     0,   150,     0,   264,
     151,   152,   153,   154,     0,     0,   155,   156,     0,     0,
     157,   158,   159,   160,   161,     0,     0,   162,   163,   164,
     165,   166,     0,     0,   167,   168,     0,   169,     0,   170,
       0,   171,   172,     0,   173,     0,     0,   174,     0,   175,
     176,   177,   178,   179,   180,   181,     0,   267,   268,   182,
       0,   183,     0,   184,     0,     0,     0,     0,   185,     0,
     269,   186,     0,   187,   270,     0,   188,     0,   189,   190,
       0,     0,     0,   191,     0,   192,   193,   271,   194,   195,
       0,     0,   196,   197,     0,   198,     0,     0,   199,     0,
     200,     0,   201,   202,     0,     0,   203,     0,     0,     0,
       0,   204,     0,   205,   206,   207,     0,     0,     0,     0,
       0,   520,   241,    54,     0,   242,    55,    56,   243,    57,
      58,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      59,    60,     0,   244,    61,    62,     0,     0,     0,    44,
       0,   245,    63,     0,     0,    64,     0,    65,    66,     0,
     463,    67,     0,     0,    68,   248,     0,    69,    70,    71,
      72,     0,   249,     0,    73,    74,    75,     0,     0,    76,
       0,   250,    77,   251,     0,    78,    79,     0,    80,    81,
     252,   253,   254,     0,    82,     0,     0,     0,    83,     0,
       0,     0,    84,     0,     0,    85,    86,    87,    88,    89,
       0,     0,     0,    90,    91,    92,    93,     0,     0,    94,
       0,    95,     0,     0,    96,     0,     0,    97,   256,     0,
      98,    99,     0,     0,     0,     0,     0,   100,     0,     0,
       0,   101,   102,   103,     0,     0,   104,   105,     0,   106,
       0,   107,   108,     0,     0,     0,   109,     0,     0,   110,
       0,   111,   112,   113,   114,     0,     0,     0,     0,     0,
     115,     0,     0,   116,     0,   117,     0,     0,   118,     0,
       0,   119,     0,     0,     0,     0,   120,     0,     0,     0,
     257,     0,   121,   258,     0,   259,     0,   122,     0,     0,
       0,   123,   124,   125,   126,     0,     0,     0,   127,   128,
     129,   130,     0,     0,   131,   132,     0,     0,   465,     0,
     133,     0,   262,   134,     0,     0,   135,     0,     0,     0,
     136,   137,     0,     0,   138,     0,     0,     0,     0,   139,
     140,     0,   141,   142,   143,     0,   263,   144,     0,     0,
     145,   146,     0,   147,   148,     0,   149,     0,     0,   150,
       0,   264,   151,   152,   153,   154,     0,     0,   155,   156,
     466,   467,   157,   158,   159,   160,   161,     0,     0,   162,
     163,   164,   165,   166,     0,     0,   167,   168,     0,   169,
       0,   170,     0,   171,   172,     0,   173,     0,     0,   174,
       0,   175,   176,   177,   178,   179,   180,   181,     0,   267,
     268,   182,     0,   183,     0,   184,     0,     0,     0,     0,
     185,     0,   269,   186,     0,   187,   270,     0,   188,     0,
     189,   190,     0,     0,     0,   191,     0,   192,   193,   271,
     194,   195,     0,     0,   196,   197,     0,   198,     0,     0,
     199,     0,   200,     0,   201,   202,     0,     0,   203,     0,
       0,     0,     0,   204,     0,   205,   206,   207,     0,     0,
       0,     0,     0,   273,   274,   275,   276,   277,   468,   469,
     280,   281,   282,   283,     0,   722,     0,     0,     0,    54,
       0,     0,    55,    56,   546,    57,    58,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    59,    60,     0,     0,
      61,    62,     0,     0,     0,     0,     0,     0,    63,     0,
       0,    64,     0,    65,    66,     0,     0,    67,     0,     0,
      68,     0,     0,    69,    70,    71,    72,     0,     0,     0,
      73,    74,    75,     0,     0,    76,     0,     0,    77,     0,
       0,    78,    79,     0,    80,    81,     0,     0,     0,     0,
      82,     0,     0,     0,    83,     0,     0,     0,    84,     0,
       0,    85,    86,    87,    88,    89,     0,     0,     0,    90,
      91,    92,    93,     0,     0,    94,     0,    95,     0,     0,
      96,     0,     0,    97,     0,     0,    98,    99,     0,     0,
       0,     0,     0,   100,     0,     0,     0,   101,   102,   103,
       0,     0,   104,   105,     0,   106,     0,   107,   108,     0,
       0,     0,   109,     0,     0,   110,     0,   111,   112,   113,
     114,     0,     0,     0,     0,     0,   115,     0,     0,   116,
       0,   117,     0,     0,   118,     0,     0,   119,     0,     0,
       0,     0,   120,     0,     0,     0,     0,     0,   121,     0,
       0,     0,     0,   122,     0,     0,     0,   123,   124,   125,
     126,     0,     0,     0,   127,   128,   129,   130,     0,     0,
     131,   132,     0,     0,     0,     0,   133,     0,     0,   134,
       0,     0,   135,     0,     0,     0,   136,   137,     0,     0,
     138,     0,     0,     0,     0,   139,   140,     0,   141,   142,
     143,     0,     0,   144,     0,     0,   145,   146,     0,   147,
     148,     0,   149,     0,     0,   150,     0,     0,   151,   152,
     153,   154,     0,     0,   155,   156,     0,     0,   157,   158,
     159,   160,   161,     0,     0,   162,   163,   164,   165,   166,
       0,     0,   167,   168,     0,   169,     0,   170,     0,   171,
     172,     0,   173,     0,     0,   174,     0,   175,   176,   177,
     178,   179,   180,   181,     0,     0,     0,   182,     0,   183,
       0,   184,     0,     0,     0,     0,   185,     0,     0,   186,
       0,   187,     0,     0,   188,     0,   189,   190,     0,     0,
       0,   191,     0,   192,   193,     0,   194,   195,     0,     0,
     196,   197,     0,   198,     0,     0,   199,     0,   200,     0,
     201,   202,     0,     0,   203,     0,     0,     0,     0,   204,
       0,   205,   206,   207,     0,     0,     0,     0,     0,   723,
     274,   275,   276,     0,   790,     0,     0,   281,    54,     0,
       0,    55,    56,     0,    57,    58,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    59,    60,     0,     0,    61,
      62,     0,     0,     0,     0,     0,     0,    63,     0,     0,
      64,     0,    65,    66,     0,     0,    67,     0,     0,    68,
       0,     0,    69,    70,    71,    72,     0,     0,     0,    73,
      74,    75,     0,     0,    76,     0,     0,    77,     0,     0,
      78,    79,     0,    80,    81,     0,     0,     0,     0,    82,
       0,     0,     0,    83,     0,     0,     0,    84,     0,     0,
      85,    86,    87,    88,    89,     0,     0,     0,    90,    91,
      92,    93,     0,     0,    94,     0,    95,     0,     0,    96,
       0,     0,    97,     0,     0,    98,    99,     0,     0,     0,
       0,     0,   100,     0,     0,     0,   101,   102,   103,     0,
       0,   104,   105,     0,   106,     0,   107,   108,     0,     0,
       0,   109,     0,     0,   110,     0,   111,   112,   113,   114,
       0,     0,     0,     0,     0,   115,     0,     0,   116,     0,
     117,     0,     0,   118,     0,     0,   119,     0,     0,     0,
       0,   120,     0,     0,     0,     0,     0,   121,     0,     0,
       0,     0,   122,     0,     0,     0,   123,   124,   125,   126,
       0,     0,     0,   127,   128,   129,   130,     0,     0,   131,
     132,     0,     0,     0,     0,   133,     0,     0,   134,     0,
       0,   135,     0,     0,     0,   136,   137,     0,     0,   138,
       0,     0,     0,     0,   139,   140,     0,   141,   142,   143,
       0,     0,   144,     0,     0,   145,   146,     0,   147,   148,
       0,   149,     0,     0,   150,     0,     0,   151,   152,   153,
     154,     0,     0,   155,   156,     0,     0,   157,   158,   159,
     160,   161,     0,     0,   162,   163,   164,   165,   166,     0,
       0,   167,   168,     0,   169,     0,   170,     0,   171,   172,
       0,   173,     0,     0,   174,     0,   175,   176,   177,   178,
     179,   180,   181,     0,     0,     0,   182,     0,   183,     0,
     184,     0,     0,     0,     0,   185,     0,     0,   186,     0,
     187,     0,     0,   188,     0,   189,   190,     0,     0,     0,
     191,     0,   192,   193,     0,   194,   195,     0,     0,   196,
     197,     0,   198,     0,     0,   199,     0,   200,     0,   201,
     202,     0,     0,   203,     0,     0,     0,     0,   204,     0,
     205,   206,   207,     0,     0,     0,     0,     0,   723,   274,
     275,   276,     0,   415,     0,     0,   281,    54,     0,     0,
      55,    56,     0,    57,    58,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    59,    60,     0,     0,    61,    62,
       0,     0,     0,     0,     0,     0,    63,     0,     0,    64,
       0,    65,    66,     0,     0,    67,     0,     0,    68,     0,
       0,    69,    70,    71,    72,     0,     0,     0,    73,    74,
      75,     0,     0,    76,     0,     0,    77,     0,     0,    78,
      79,     0,    80,    81,     0,     0,     0,     0,    82,     0,
       0,     0,    83,     0,     0,     0,    84,     0,     0,    85,
      86,    87,    88,    89,     0,     0,     0,    90,    91,    92,
      93,     0,     0,    94,     0,    95,     0,     0,    96,     0,
       0,    97,     0,     0,    98,    99,     0,     0,     0,     0,
       0,   100,     0,     0,     0,   101,   102,   103,     0,     0,
     104,   105,     0,   106,     0,   107,   108,     0,     0,     0,
     109,     0,     0,   110,     0,   111,   112,   113,   114,     0,
       0,     0,     0,     0,   115,     0,     0,   116,     0,   117,
       0,     0,   118,     0,     0,   119,     0,     0,     0,     0,
     120,     0,     0,     0,     0,     0,   121,     0,     0,     0,
       0,   122,     0,     0,     0,   123,   124,   125,   126,     0,
       0,     0,   127,   128,   129,   130,     0,     0,   131,   132,
       0,     0,     0,     0,   133,     0,     0,   134,     0,     0,
     135,     0,     0,     0,   136,   137,     0,     0,   138,     0,
       0,     0,     0,   139,   140,     0,   141,   142,   143,     0,
     345,   144,     0,   376,   145,   146,     0,   147,   148,     0,
     149,     0,   347,   150,     0,     0,   151,   152,   153,   154,
       0,     0,   155,   156,     0,     0,   157,   158,   159,   160,
     161,     0,     0,   162,   163,   164,   165,   166,     0,     0,
     167,   168,     0,   169,     0,   170,     0,   171,   172,     0,
     173,   345,     0,   174,     0,   175,   176,   177,   178,   179,
     180,   181,     0,   347,   345,   182,   517,   183,     0,   184,
       0,     0,     0,     0,   185,   377,   347,   186,     0,   187,
       0,     0,   188,     0,   189,   190,     0,     0,     0,   191,
       0,   192,   193,     0,   194,   195,     0,     0,   196,   197,
       0,   198,     0,   345,   199,   695,   200,     0,   201,   202,
       0,     0,   203,     0,     0,   347,   345,   204,     0,   205,
     206,   207,     0,     0,     0,   348,     0,   416,   347,     0,
       0,     0,     0,     0,     0,   417,   349,   350,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   351,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   771,     0,
       0,     0,     0,     0,     0,     0,     0,   345,     0,     0,
       0,     0,     0,     0,     0,     0,   348,     0,   352,   347,
       0,   353,     0,     0,     0,   378,     0,   349,   350,   348,
       0,     0,     0,     0,     0,     0,     0,   354,   351,     0,
     349,   350,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   351,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   348,   352,
       0,     0,   353,     0,     0,     0,     0,     0,     0,   349,
     350,   348,   352,     0,     0,   353,     0,     0,   354,     0,
     351,     0,   349,   350,     0,     0,     0,     0,     0,     0,
     355,   354,     0,   351,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   352,     0,     0,   353,     0,     0,     0,     0,     0,
       0,     0,   348,     0,   352,     0,     0,   353,     0,     0,
     354,     0,     0,   349,   350,     0,     0,   345,   379,     0,
       0,   355,     0,   354,   351,     0,     0,     0,     0,   347,
       0,     0,     0,     0,   355,     0,     0,     0,     0,     0,
       0,     0,     0,   356,   357,   358,   359,   360,     0,     0,
       0,     0,     0,     0,     0,   352,     0,     0,   353,     0,
       0,     0,     0,   361,   362,   363,     0,   364,   365,   366,
     367,   368,   369,   355,   354,     0,     0,     0,     0,     0,
       0,     0,   401,     0,     0,     0,   355,     0,     0,     0,
       0,     0,     0,     0,   356,   357,   358,   359,   360,     0,
       0,     0,     0,     0,     0,     0,     0,   356,   357,   358,
     359,   360,     0,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,   369,     0,     0,     0,   361,   362,   363,
       0,   364,   365,   366,   367,   368,   369,   355,     0,     0,
       0,     0,   348,     0,     0,     0,   356,   357,   358,   359,
     360,     0,     0,   349,   350,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   351,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,   369,     0,     0,     0,   361,
     362,   363,     0,   364,   365,   366,   367,   368,   369,     0,
       0,     0,     0,     0,     0,   352,     0,     0,   353,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     356,   357,   358,   359,   360,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     361,   362,   363,     0,   364,   365,   366,   367,   368,   369,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   355,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     356,   357,   358,   359,   360,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     361,   362,   363,     0,   364,   365,   366,   367,   368,   369,
      54,     0,     0,    55,    56,     0,    57,    58,     0,     0,
       0,     0,     0,     0,   598,     0,     0,    59,    60,     0,
       0,    61,    62,     0,     0,     0,     0,     0,     0,    63,
       0,     0,    64,     0,    65,    66,     0,     0,    67,     0,
       0,    68,     0,     0,    69,    70,    71,    72,     0,     0,
       0,    73,    74,    75,     0,     0,    76,     0,     0,    77,
       0,     0,    78,    79,     0,    80,    81,     0,     0,     0,
       0,    82,     0,     0,     0,    83,     0,     0,     0,    84,
       0,     0,    85,    86,    87,    88,    89,     0,     0,     0,
      90,    91,    92,    93,     0,     0,    94,     0,    95,     0,
       0,    96,     0,     0,    97,     0,     0,    98,    99,     0,
       0,     0,     0,     0,   100,     0,     0,     0,   101,   102,
     103,     0,     0,   104,   105,     0,   106,     0,   107,   108,
       0,     0,     0,   109,     0,     0,   110,     0,   111,   112,
     113,   114,     0,     0,     0,     0,     0,   115,     0,     0,
     116,     0,   117,     0,     0,   118,     0,     0,   119,     0,
       0,     0,     0,   120,     0,     0,     0,     0,     0,   121,
       0,     0,     0,     0,   122,     0,     0,     0,   123,   124,
     125,   126,     0,     0,     0,   127,   128,   129,   130,     0,
       0,   131,   132,     0,     0,     0,     0,   133,     0,     0,
     134,     0,     0,   135,     0,     0,     0,   136,   137,     0,
       0,   138,     0,     0,     0,     0,   139,   140,     0,   141,
     142,   143,     0,     0,   144,     0,     0,   145,   146,     0,
     147,   148,     0,   149,     0,     0,   150,     0,     0,   151,
     152,   153,   154,     0,     0,   155,   156,     0,     0,   157,
     158,   159,   160,   161,     0,     0,   162,   163,   164,   165,
     166,     0,     0,   167,   168,     0,   169,     0,   170,     0,
     171,   172,     0,   173,     0,     0,   174,     0,   175,   176,
     177,   178,   179,   180,   181,     0,     0,     0,   182,     0,
     183,     0,   184,     0,     0,     0,     0,   185,     0,     0,
     186,     0,   187,     0,     0,   188,     0,   189,   190,     0,
       0,     0,   191,     0,   192,   193,     0,   194,   195,     0,
       0,   196,   197,     0,   198,     0,     0,   199,     0,   200,
       0,   201,   202,     0,     0,   203,     0,     0,     0,     0,
     204,     0,   205,   206,   207,    54,     0,     0,    55,    56,
     599,    57,    58,     0,     0,     0,     0,     0,   600,   614,
       0,     0,    59,    60,     0,     0,    61,    62,     0,     0,
       0,     0,     0,     0,    63,     0,     0,    64,     0,    65,
      66,     0,     0,    67,     0,     0,    68,     0,     0,    69,
      70,    71,    72,     0,     0,     0,    73,    74,    75,     0,
       0,    76,     0,     0,    77,     0,     0,    78,    79,     0,
      80,    81,     0,     0,     0,     0,    82,     0,     0,     0,
      83,     0,     0,     0,    84,     0,     0,    85,    86,    87,
      88,    89,     0,     0,     0,    90,    91,    92,    93,     0,
       0,    94,     0,    95,     0,     0,    96,     0,     0,    97,
       0,     0,    98,    99,     0,     0,     0,     0,     0,   100,
       0,     0,     0,   101,   102,   103,     0,     0,   104,   105,
       0,   106,     0,   107,   108,     0,     0,     0,   109,     0,
       0,   110,     0,   111,   112,   113,   114,     0,     0,     0,
       0,     0,   115,     0,     0,   116,     0,   117,     0,     0,
     118,     0,     0,   119,     0,     0,     0,     0,   120,     0,
       0,     0,     0,     0,   121,     0,     0,     0,     0,   122,
       0,     0,     0,   123,   124,   125,   126,     0,     0,     0,
     127,   128,   129,   130,     0,     0,   131,   132,     0,     0,
       0,     0,   133,     0,     0,   134,     0,     0,   135,     0,
       0,     0,   136,   137,     0,     0,   138,     0,     0,     0,
       0,   139,   140,     0,   141,   142,   143,     0,     0,   144,
       0,     0,   145,   146,     0,   147,   148,     0,   149,     0,
       0,   150,     0,     0,   151,   152,   153,   154,     0,     0,
     155,   156,     0,     0,   157,   158,   159,   160,   161,     0,
       0,   162,   163,   164,   165,   166,     0,     0,   167,   168,
       0,   169,     0,   170,     0,   171,   172,     0,   173,     0,
       0,   174,     0,   175,   176,   177,   178,   179,   180,   181,
       0,     0,     0,   182,     0,   183,     0,   184,     0,     0,
       0,     0,   185,     0,     0,   186,     0,   187,     0,     0,
     188,     0,   189,   190,     0,     0,     0,   191,     0,   192,
     193,     0,   194,   195,     0,     0,   196,   197,     0,   198,
       0,     0,   199,     0,   200,     0,   201,   202,     0,     0,
     203,     0,     0,     0,     0,   204,     0,   205,   206,   207,
      54,     0,     0,    55,    56,   599,    57,    58,     0,     0,
       0,     0,     0,   600,   616,     0,     0,    59,    60,     0,
       0,    61,    62,     0,     0,     0,     0,     0,     0,    63,
       0,     0,    64,     0,    65,    66,     0,     0,    67,     0,
       0,    68,     0,     0,    69,    70,    71,    72,     0,     0,
       0,    73,    74,    75,     0,     0,    76,     0,     0,    77,
       0,     0,    78,    79,     0,    80,    81,     0,     0,     0,
       0,    82,     0,     0,     0,    83,     0,     0,     0,    84,
       0,     0,    85,    86,    87,    88,    89,     0,     0,     0,
      90,    91,    92,    93,     0,     0,    94,     0,    95,     0,
       0,    96,     0,     0,    97,     0,     0,    98,    99,     0,
       0,     0,     0,     0,   100,     0,     0,     0,   101,   102,
     103,     0,     0,   104,   105,     0,   106,     0,   107,   108,
       0,     0,     0,   109,     0,     0,   110,     0,   111,   112,
     113,   114,     0,     0,     0,     0,     0,   115,     0,     0,
     116,     0,   117,     0,     0,   118,     0,     0,   119,     0,
       0,     0,     0,   120,     0,     0,     0,     0,     0,   121,
       0,     0,     0,     0,   122,     0,     0,     0,   123,   124,
     125,   126,     0,     0,     0,   127,   128,   129,   130,     0,
       0,   131,   132,     0,     0,     0,     0,   133,     0,     0,
     134,     0,     0,   135,     0,     0,     0,   136,   137,     0,
       0,   138,     0,     0,     0,     0,   139,   140,     0,   141,
     142,   143,     0,     0,   144,     0,     0,   145,   146,     0,
     147,   148,     0,   149,     0,     0,   150,     0,     0,   151,
     152,   153,   154,     0,     0,   155,   156,     0,     0,   157,
     158,   159,   160,   161,     0,     0,   162,   163,   164,   165,
     166,     0,     0,   167,   168,     0,   169,     0,   170,     0,
     171,   172,     0,   173,     0,     0,   174,     0,   175,   176,
     177,   178,   179,   180,   181,     0,     0,     0,   182,     0,
     183,     0,   184,     0,     0,     0,     0,   185,     0,     0,
     186,     0,   187,     0,     0,   188,     0,   189,   190,     0,
       0,     0,   191,     0,   192,   193,     0,   194,   195,     0,
       0,   196,   197,     0,   198,     0,     0,   199,     0,   200,
       0,   201,   202,     0,     0,   203,     0,     0,     0,     0,
     204,     0,   205,   206,   207,    54,     0,     0,    55,    56,
     599,    57,    58,     0,     0,     0,     0,     0,   600,   667,
       0,     0,    59,    60,     0,     0,    61,    62,     0,     0,
       0,     0,     0,     0,    63,     0,     0,    64,     0,    65,
      66,     0,     0,    67,     0,     0,    68,     0,     0,    69,
      70,    71,    72,     0,     0,     0,    73,    74,    75,     0,
       0,    76,     0,     0,    77,     0,     0,    78,    79,     0,
      80,    81,     0,     0,     0,     0,    82,     0,     0,     0,
      83,     0,     0,     0,    84,     0,     0,    85,    86,    87,
      88,    89,     0,     0,     0,    90,    91,    92,    93,     0,
       0,    94,     0,    95,     0,     0,    96,     0,     0,    97,
       0,     0,    98,    99,     0,     0,     0,     0,     0,   100,
       0,     0,     0,   101,   102,   103,     0,     0,   104,   105,
       0,   106,     0,   107,   108,     0,     0,     0,   109,     0,
       0,   110,     0,   111,   112,   113,   114,     0,     0,     0,
       0,     0,   115,     0,     0,   116,     0,   117,     0,     0,
     118,     0,     0,   119,     0,     0,     0,     0,   120,     0,
       0,     0,     0,     0,   121,     0,     0,     0,     0,   122,
       0,     0,     0,   123,   124,   125,   126,     0,     0,     0,
     127,   128,   129,   130,     0,     0,   131,   132,     0,     0,
       0,     0,   133,     0,     0,   134,     0,     0,   135,     0,
       0,     0,   136,   137,     0,     0,   138,     0,     0,     0,
       0,   139,   140,     0,   141,   142,   143,     0,     0,   144,
       0,     0,   145,   146,     0,   147,   148,     0,   149,     0,
       0,   150,     0,     0,   151,   152,   153,   154,     0,     0,
     155,   156,     0,     0,   157,   158,   159,   160,   161,     0,
       0,   162,   163,   164,   165,   166,     0,     0,   167,   168,
       0,   169,     0,   170,     0,   171,   172,     0,   173,     0,
       0,   174,     0,   175,   176,   177,   178,   179,   180,   181,
       0,     0,     0,   182,     0,   183,     0,   184,     0,     0,
       0,     0,   185,     0,     0,   186,     0,   187,     0,     0,
     188,     0,   189,   190,     0,     0,     0,   191,     0,   192,
     193,     0,   194,   195,     0,     0,   196,   197,     0,   198,
       0,     0,   199,     0,   200,    54,   201,   202,    55,    56,
     203,    57,    58,     0,     0,   204,     0,   205,   206,   207,
       0,     0,    59,    60,     0,   599,    61,    62,     0,     0,
       0,     0,     0,   600,    63,     0,     0,    64,     0,    65,
      66,     0,     0,    67,     0,     0,    68,     0,     0,    69,
      70,    71,    72,     0,     0,     0,    73,    74,    75,     0,
       0,    76,     0,     0,    77,     0,     0,    78,    79,     0,
      80,    81,     0,     0,     0,     0,    82,     0,     0,     0,
      83,     0,     0,     0,    84,     0,     0,    85,    86,    87,
      88,    89,     0,     0,     0,    90,    91,    92,    93,     0,
       0,    94,     0,    95,     0,     0,    96,     0,     0,    97,
       0,     0,    98,    99,     0,     0,     0,     0,     0,   100,
       0,     0,     0,   101,   102,   103,     0,     0,   104,   105,
       0,   106,     0,   107,   108,     0,     0,     0,   109,     0,
       0,   110,     0,   111,   112,   113,   114,     0,     0,     0,
       0,     0,   115,     0,     0,   116,     0,   117,     0,     0,
     118,     0,     0,   119,     0,     0,     0,     0,   120,     0,
       0,     0,     0,     0,   121,     0,     0,     0,     0,   122,
       0,     0,     0,   123,   124,   125,   126,     0,     0,     0,
     127,   128,   129,   130,     0,     0,   131,   132,     0,     0,
       0,     0,   133,     0,     0,   134,     0,     0,   135,     0,
       0,     0,   136,   137,     0,     0,   138,     0,     0,     0,
       0,   139,   140,     0,   141,   142,   143,     0,     0,   144,
       0,     0,   145,   146,     0,   147,   148,     0,   149,     0,
       0,   150,     0,     0,   151,   152,   153,   154,     0,     0,
     155,   156,     0,     0,   157,   158,   159,   160,   161,     0,
       0,   162,   163,   164,   165,   166,     0,     0,   167,   168,
       0,   169,     0,   170,     0,   171,   172,     0,   173,     0,
       0,   174,     0,   175,   176,   177,   178,   179,   180,   181,
       0,     0,     0,   182,     0,   183,     0,   184,     0,     0,
       0,     0,   185,     0,     0,   186,     0,   187,     0,     0,
     188,     0,   189,   190,     0,     0,     0,   191,     0,   192,
     193,     0,   194,   195,     0,     0,   196,   197,     0,   198,
       0,     0,   199,     0,   200,    54,   201,   202,    55,    56,
     203,    57,    58,     0,     0,   204,     0,   205,   206,   207,
       0,     0,    59,    60,     0,   599,    61,    62,     0,     0,
       0,     0,     0,   600,    63,     0,     0,    64,     0,    65,
      66,     0,     0,    67,     0,     0,    68,     0,     0,    69,
      70,    71,    72,     0,     0,     0,    73,    74,    75,     0,
       0,    76,     0,     0,    77,     0,     0,    78,    79,     0,
      80,    81,     0,     0,     0,     0,    82,     0,     0,     0,
      83,     0,     0,     0,    84,     0,     0,    85,    86,    87,
      88,    89,     0,     0,     0,    90,    91,    92,    93,     0,
       0,    94,     0,    95,     0,     0,    96,     0,     0,    97,
       0,     0,    98,    99,     0,     0,     0,     0,     0,   100,
       0,     0,     0,   101,   102,   103,     0,     0,   104,   105,
       0,   106,     0,   107,   108,     0,     0,     0,   109,     0,
       0,   110,     0,   111,   112,   113,   114,     0,     0,     0,
       0,     0,   115,     0,     0,   116,     0,   117,     0,     0,
     118,     0,     0,   119,     0,     0,     0,     0,   120,     0,
       0,     0,     0,     0,   121,     0,     0,     0,     0,   122,
       0,     0,   518,   123,   124,   125,   126,     0,     0,     0,
     127,   128,   129,   130,     0,     0,   131,   132,     0,     0,
       0,     0,   133,     0,     0,   134,     0,     0,   135,     0,
       0,     0,   136,   137,     0,     0,   138,     0,     0,     0,
       0,   139,   140,     0,   141,   142,   143,     0,     0,   144,
       0,     0,   145,   146,     0,   147,   148,     0,   149,     0,
       0,   150,     0,     0,   151,   152,   153,   154,     0,     0,
     155,   156,     0,     0,   157,   158,   159,   160,   161,     0,
       0,   162,   163,   164,   165,   166,     0,     0,   167,   168,
       0,   169,     0,   170,     0,   171,   172,     0,   173,     0,
       0,   174,     0,   175,   176,   177,   178,   179,   180,   181,
       0,     0,     0,   182,     0,   183,     0,   184,     0,     0,
       0,     0,   185,     0,     0,   186,     0,   187,     0,     0,
     188,     0,   189,   190,     0,     0,     0,   191,     0,   192,
     193,     0,   194,   195,     0,     0,   196,   197,     0,   198,
       0,     0,   199,     0,   200,    54,   201,   202,    55,    56,
     203,    57,    58,     0,     0,   204,     0,   205,   206,   207,
       0,     0,    59,    60,     0,   590,    61,    62,     0,     0,
       0,     0,     0,     0,    63,     0,     0,    64,     0,    65,
      66,     0,     0,    67,     0,     0,    68,     0,     0,    69,
      70,    71,    72,     0,     0,     0,    73,    74,    75,     0,
       0,    76,     0,     0,    77,     0,     0,    78,    79,     0,
      80,    81,     0,     0,     0,     0,    82,     0,     0,     0,
      83,     0,     0,     0,    84,     0,     0,    85,    86,    87,
      88,    89,     0,     0,     0,    90,    91,    92,    93,     0,
       0,    94,     0,    95,     0,     0,    96,     0,     0,    97,
       0,     0,    98,    99,     0,     0,     0,     0,     0,   100,
       0,     0,     0,   101,   102,   103,     0,     0,   104,   105,
       0,   106,     0,   107,   108,     0,     0,     0,   109,     0,
       0,   110,     0,   111,   112,   113,   114,     0,     0,     0,
       0,     0,   115,     0,     0,   116,     0,   117,     0,     0,
     118,     0,     0,   119,     0,     0,     0,     0,   120,     0,
       0,     0,     0,     0,   121,     0,     0,     0,     0,   122,
       0,     0,     0,   123,   124,   125,   126,     0,     0,     0,
     127,   128,   129,   130,     0,     0,   131,   132,     0,     0,
       0,     0,   133,     0,     0,   134,     0,     0,   135,     0,
       0,     0,   136,   137,     0,     0,   138,     0,     0,     0,
       0,   139,   140,     0,   141,   142,   143,     0,     0,   144,
       0,     0,   145,   146,     0,   147,   148,     0,   149,     0,
       0,   150,     0,     0,   151,   152,   153,   154,     0,     0,
     155,   156,     0,     0,   157,   158,   159,   160,   161,     0,
       0,   162,   163,   164,   165,   166,     0,     0,   167,   168,
       0,   169,     0,   170,     0,   171,   172,     0,   173,     0,
       0,   174,     0,   175,   176,   177,   178,   179,   180,   181,
       0,     0,     0,   182,     0,   183,     0,   184,     0,     0,
       0,     0,   185,     0,     0,   186,     0,   187,     0,     0,
     188,     0,   189,   190,     0,     0,     0,   191,     0,   192,
     193,     0,   194,   195,     0,     0,   196,   197,     0,   198,
       0,     0,   199,     0,   200,    54,   201,   202,    55,    56,
     203,    57,    58,     0,     0,   204,     0,   205,   206,   207,
       0,     0,    59,    60,     0,   208,    61,    62,     0,     0,
       0,     0,     0,     0,    63,     0,     0,    64,     0,    65,
      66,     0,     0,    67,     0,     0,    68,     0,     0,    69,
      70,    71,    72,     0,     0,     0,    73,    74,    75,     0,
       0,    76,     0,     0,    77,     0,     0,    78,    79,     0,
      80,    81,     0,     0,     0,     0,    82,     0,     0,     0,
      83,     0,     0,     0,    84,     0,     0,    85,    86,    87,
      88,    89,     0,     0,     0,    90,    91,    92,    93,     0,
       0,    94,     0,    95,     0,     0,    96,     0,     0,    97,
       0,     0,    98,    99,     0,     0,     0,     0,     0,   100,
       0,     0,     0,   101,   102,   103,     0,     0,   104,   105,
       0,   106,     0,   107,   108,   347,     0,     0,   109,     0,
       0,   110,     0,   111,   112,   113,   114,     0,     0,     0,
       0,     0,   115,     0,     0,   116,     0,   117,     0,     0,
     118,     0,     0,   119,     0,     0,     0,     0,   120,     0,
       0,     0,     0,     0,   121,     0,     0,     0,     0,   122,
       0,     0,     0,   123,   124,   125,   126,     0,     0,     0,
     127,   128,   129,   130,     0,     0,   131,   132,     0,     0,
       0,     0,   133,     0,     0,   134,     0,     0,   135,     0,
       0,     0,   136,   137,     0,     0,   138,   347,     0,     0,
       0,   139,   140,     0,   141,   142,   143,     0,     0,   144,
       0,     0,   145,   146,     0,   147,   148,     0,   149,     0,
       0,   150,     0,     0,   151,   152,   153,   154,   348,     0,
     155,   156,     0,     0,   157,   158,   159,   160,   161,   349,
     350,   162,   163,   164,   165,   166,     0,     0,   167,   168,
     351,   169,   347,   170,     0,   171,   172,     0,   173,   347,
       0,   174,     0,   175,   176,   177,   178,   179,   180,   181,
       0,   628,     0,   182,     0,   183,     0,   184,     0,     0,
       0,   352,   185,     0,   353,   186,     0,   187,     0,     0,
     188,     0,   189,   190,     0,     0,     0,   191,     0,   192,
     193,     0,   194,   195,     0,     0,   196,   197,     0,   198,
     348,     0,   199,     0,   200,     0,   201,   202,     0,     0,
     203,   349,   350,     0,     0,   204,   630,   205,   206,   207,
       0,     0,  -345,   693,     0,   665,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   355,     0,   348,   353,     0,     0,     0,
       0,     0,   348,     0,     0,     0,   349,   350,     0,     0,
       0,     0,     0,   349,   350,     0,     0,  -345,     0,     0,
       0,     0,     0,     0,  -345,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   353,     0,     0,     0,     0,     0,     0,   353,     0,
       0,     0,     0,     0,     0,     0,   356,   357,   358,   359,
     360,     0,     0,     0,     0,  -345,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,   369,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -345,     0,     0,     0,     0,     0,     0,  -345,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   356,   357,
     358,   359,   360,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   364,   365,   366,   367,   368,   369,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   356,   357,   358,   359,   360,     0,     0,
     356,   357,   358,   359,   360,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   364,   365,   366,
     367,   368,   369,     0,   364,   365,   366,   367,   368,   369
};

static const yytype_int16 yycheck[] =
{
       0,   347,   225,     1,    41,   529,   104,   347,   433,    13,
     151,   111,   234,     1,   371,    13,     1,    29,     1,   462,
      80,   464,   111,   246,   156,   371,   611,   612,   332,     0,
      17,   266,   223,   359,   113,    80,     0,   260,   104,   104,
       1,   149,    29,     0,    44,   443,   384,    19,   386,   272,
      50,   149,    37,   332,   355,   332,    17,   383,   347,   360,
     361,   284,   285,   332,   287,   288,   289,   387,   259,   260,
     178,   131,   412,   332,   347,   348,   153,   154,   332,   383,
     178,   160,   371,   149,   149,   217,   131,   371,    19,    93,
     525,   526,   677,    50,   679,   195,   318,   443,   371,   290,
     200,     1,   325,   443,   383,   462,   383,   464,   551,   332,
     384,   200,   178,   178,   383,   165,   462,    17,   464,   179,
     343,   198,   345,   183,   383,   347,    29,   384,   351,   383,
     142,   354,   223,   383,   179,   533,   359,   360,   183,    44,
      45,   364,   365,   366,   367,   368,   369,   370,   383,   371,
     215,   210,   164,   355,   443,   142,   591,    99,   360,   361,
     102,   383,   383,   598,    37,    69,   153,   154,   259,   260,
     443,   444,    13,   462,   114,   464,   383,   164,   462,   614,
     464,   616,   341,   342,   343,   344,   383,   533,   383,   462,
     227,   464,   383,   533,   551,   383,   553,   383,    99,   290,
     103,   102,   387,   251,   264,   551,   254,   553,   195,   309,
     433,   198,   376,   377,   378,   379,   314,   317,   122,   264,
     309,   443,   445,   384,   360,   448,   387,   214,   317,   627,
     384,   384,   667,   387,   387,   338,   140,   207,   762,   142,
     462,   765,   464,   121,   533,   379,   387,   301,   314,   314,
     153,   154,   156,   384,   384,   255,   387,   387,   162,   384,
     533,   164,   551,   603,   553,   277,   384,   551,   202,   553,
     116,   611,   612,   350,   351,   352,   353,   354,   551,   384,
     553,   627,   387,   187,   298,   508,   384,   627,   348,   289,
     277,   276,   237,   238,   239,   198,   122,   374,   375,   376,
     377,   378,   379,   348,   259,   260,   306,   530,   308,   346,
     347,   533,   316,   738,   140,   384,   384,   674,   387,   387,
     543,   321,   322,   323,   324,   548,   355,   338,   674,   551,
     156,   553,   339,    17,   301,    19,   162,   677,   627,   679,
     321,   322,   323,   324,   248,    29,   384,   347,   348,    69,
     384,   383,   383,   387,   627,   211,   102,   320,   356,   298,
     102,   386,   360,   350,   351,   352,   353,   354,   356,   387,
     282,   361,   360,   356,   277,   412,   384,   360,   306,    45,
     308,   383,   383,   370,   371,   372,   383,   374,   375,   376,
     377,   378,   379,   321,   322,   323,   324,   384,   156,   383,
     156,   383,   122,   383,   383,   627,   443,   383,   383,   127,
     767,   315,   412,   770,   340,   361,   301,   361,   383,   360,
     140,   767,   248,   383,   770,   383,   340,   383,   360,   383,
     340,   360,   271,   433,   153,   154,   156,   360,   355,   360,
     360,   156,   162,   443,   444,   802,   355,   350,   351,   352,
     353,   354,   674,    37,   130,   361,   802,   384,   142,   384,
     615,   461,   617,   360,   360,   688,   360,   187,   360,   153,
     154,   374,   375,   376,   377,   378,   379,   354,   360,   198,
     164,   383,   519,   299,   521,   383,   299,   355,   525,   526,
     210,   384,    32,   370,   371,   372,   533,   374,   375,   376,
     377,   378,   379,   384,    44,    45,   360,   383,   731,   384,
     384,   195,   384,   668,   198,   738,   739,   384,   673,   384,
     384,   384,   384,   360,   384,   349,   349,   360,   248,   684,
     214,   686,    37,   533,   387,   360,     1,   384,     3,    79,
     384,   384,    82,    83,   384,   767,   565,   566,   770,    14,
      50,    16,   589,   227,   591,   574,   343,   603,   577,   578,
     715,   598,   767,    28,   730,   609,   603,   519,   802,   312,
     529,   375,   380,   796,   611,   612,   330,   614,   406,   616,
     802,   402,   695,   561,    49,   444,    51,    52,   702,    -1,
     627,    56,    57,   277,    -1,   315,    -1,    -1,    -1,    64,
     553,    66,    -1,   603,    -1,   325,    -1,   147,   148,    -1,
     150,   611,   612,    -1,    -1,    -1,    81,    -1,    -1,    84,
      -1,    -1,    -1,    -1,    89,    -1,    -1,   627,    -1,    -1,
     667,    -1,    97,   652,    -1,   654,   655,   102,    -1,    -1,
     677,   106,   679,   108,    -1,    -1,   186,   112,   188,    -1,
      -1,    -1,    -1,    -1,    -1,   374,   375,   376,   377,   378,
     379,   126,    -1,   203,    -1,    -1,   350,   351,   352,   353,
     354,    -1,    -1,    -1,    -1,    -1,    -1,   677,    -1,   679,
     145,    -1,    -1,    -1,    -1,    -1,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,    -1,    -1,    -1,    -1,
      -1,   166,   167,    -1,    -1,    -1,    -1,    -1,   173,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   184,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   748,
      -1,    -1,   197,    -1,    -1,    -1,    -1,    -1,    -1,   279,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   299,
     300,    -1,    -1,    -1,    -1,   230,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   240,    -1,    -1,    -1,   244,
      -1,    -1,   247,    -1,   249,    -1,    -1,    -1,    -1,    -1,
     330,   331,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   266,    -1,    -1,    -1,    -1,   271,    -1,    -1,    -1,
     275,    -1,    -1,    -1,    -1,    -1,    -1,   282,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   310,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   318,    -1,   320,    -1,    -1,    -1,    -1,
      -1,   326,    -1,     4,     5,    -1,     7,     8,     9,    10,
      11,    12,    13,    -1,    -1,   340,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    26,    27,    -1,    -1,    -1,
     355,    -1,    33,    34,    -1,    -1,    37,    -1,    39,    40,
     365,    42,    43,    -1,    -1,    46,    47,    -1,    49,    50,
      51,    52,    -1,    54,    -1,    56,    57,    58,   383,    -1,
      61,    -1,    63,    64,    65,    -1,    67,    68,    -1,    70,
      71,    72,    73,    74,    -1,    76,    -1,    -1,    -1,    80,
      -1,    -1,    -1,    84,    -1,    -1,    87,    88,    89,    90,
      91,    -1,    93,    -1,    95,    96,    97,    98,    -1,    -1,
     101,    -1,   103,    -1,    -1,   106,    -1,    -1,   109,   110,
      -1,   112,   113,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,    -1,   123,   124,   125,    -1,    -1,   128,   129,    -1,
     131,    -1,   133,   134,    -1,    -1,    -1,   138,    -1,    -1,
     141,    -1,   143,   144,   145,   146,    -1,    -1,    -1,    -1,
      -1,   152,    -1,    -1,   155,    -1,   157,    -1,    -1,   160,
      -1,    -1,   163,    -1,    -1,    -1,    -1,   168,    -1,    -1,
      -1,   172,    -1,   174,   175,    -1,   177,    -1,   179,    -1,
      -1,    -1,   183,   184,   185,   186,    -1,    -1,    -1,   190,
     191,   192,   193,    -1,    -1,   196,   197,    -1,    -1,   200,
      -1,   202,    -1,   204,   205,    -1,    -1,   208,    -1,    -1,
      -1,   212,   213,    -1,    -1,   216,    -1,    -1,    -1,    -1,
     221,   222,    -1,   224,   225,   226,    -1,   228,   229,    -1,
      -1,   232,   233,    -1,   235,   236,    -1,   238,    -1,    -1,
     241,    -1,   243,   244,   245,   246,   247,    -1,    -1,   250,
     251,   252,   253,   254,   255,   256,   257,   258,    -1,    -1,
     261,   262,   263,   264,   265,    -1,    -1,   268,   269,    -1,
     271,    -1,   273,    -1,   275,   276,    -1,   278,    -1,    -1,
     281,    -1,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,    -1,   295,    -1,   297,    -1,    -1,    -1,
      -1,   302,    -1,   304,   305,    -1,   307,   308,    -1,   310,
      -1,   312,   313,    -1,    -1,    -1,   317,    -1,   319,   320,
     321,   322,   323,    -1,    -1,   326,   327,    -1,   329,    -1,
      -1,   332,    -1,   334,    -1,   336,   337,    -1,    -1,   340,
      -1,    -1,    -1,    -1,   345,    -1,   347,   348,   349,    -1,
      -1,    -1,    -1,    -1,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     4,     5,   376,     7,     8,     9,    10,
      11,    12,    13,   384,    -1,    -1,    -1,    18,    -1,    -1,
      -1,    22,    23,    -1,    25,    26,    27,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    -1,    37,    -1,    39,    40,
      41,    42,    43,    -1,    -1,    46,    47,    -1,    49,    50,
      51,    52,    -1,    54,    -1,    56,    57,    58,    -1,    -1,
      61,    -1,    63,    64,    65,    -1,    67,    68,    -1,    70,
      71,    72,    73,    74,    -1,    76,    -1,    -1,    -1,    80,
      -1,    -1,    -1,    84,    -1,    -1,    87,    88,    89,    90,
      91,    -1,    -1,    -1,    95,    96,    97,    98,    -1,    -1,
     101,    -1,   103,    -1,    -1,   106,   107,    -1,   109,   110,
      -1,   112,   113,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,    -1,   123,   124,   125,    -1,    -1,   128,   129,    -1,
     131,    -1,   133,   134,    -1,    -1,    -1,   138,    -1,    -1,
     141,    -1,   143,   144,   145,   146,    -1,    -1,    -1,    -1,
      -1,   152,    -1,    -1,   155,    -1,   157,    -1,    -1,   160,
      -1,    -1,   163,    -1,    -1,    -1,    -1,   168,    -1,    -1,
      -1,   172,    -1,   174,   175,    -1,   177,    -1,   179,    -1,
      -1,    -1,   183,   184,   185,   186,    -1,    -1,    -1,   190,
     191,   192,   193,    -1,   195,   196,   197,    -1,    -1,   200,
      -1,   202,    -1,   204,   205,    -1,    -1,   208,    -1,    -1,
      -1,   212,   213,    -1,    -1,   216,    -1,    -1,    -1,    -1,
     221,   222,    -1,   224,   225,   226,    -1,   228,   229,    -1,
      -1,   232,   233,    -1,   235,   236,    -1,   238,    -1,    -1,
     241,    -1,   243,   244,   245,   246,   247,    -1,    -1,   250,
     251,   252,   253,   254,   255,   256,   257,   258,    -1,    -1,
     261,   262,   263,   264,   265,    -1,    -1,   268,   269,    -1,
     271,    -1,   273,    -1,   275,   276,    -1,   278,    -1,   280,
     281,    -1,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,    -1,   295,    -1,   297,    -1,    -1,    -1,
      -1,   302,    -1,   304,   305,    -1,   307,   308,    -1,   310,
      -1,   312,   313,    -1,    -1,    -1,   317,    -1,   319,   320,
     321,   322,   323,    -1,    -1,   326,   327,    -1,   329,    -1,
      -1,   332,    -1,   334,    -1,   336,   337,    -1,    -1,   340,
      -1,    -1,    -1,    -1,   345,    -1,   347,   348,   349,    -1,
      -1,    -1,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   374,   375,    -1,    -1,   378,   379,    -1,
       4,     5,   383,     7,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    26,    27,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    -1,    37,    -1,    39,    40,    41,    42,    43,
      -1,    -1,    46,    47,    -1,    49,    50,    51,    52,    -1,
      54,    -1,    56,    57,    58,    -1,    -1,    61,    -1,    63,
      64,    65,    -1,    67,    68,    -1,    70,    71,    72,    73,
      74,    -1,    76,    -1,    -1,    -1,    80,    -1,    -1,    -1,
      84,    -1,    -1,    87,    88,    89,    90,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    -1,    -1,   101,    -1,   103,
      -1,    -1,   106,   107,    -1,   109,   110,    -1,   112,   113,
      -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,    -1,   123,
     124,   125,    -1,    -1,   128,   129,    -1,   131,    -1,   133,
     134,    -1,    -1,    -1,   138,    -1,    -1,   141,    -1,   143,
     144,   145,   146,    -1,    -1,    -1,    -1,    -1,   152,    -1,
      -1,   155,    -1,   157,    -1,    -1,   160,    -1,    -1,   163,
      -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,   172,    -1,
     174,   175,    -1,   177,    -1,   179,    -1,    -1,    -1,   183,
     184,   185,   186,    -1,    -1,    -1,   190,   191,   192,   193,
      -1,   195,   196,   197,    -1,    -1,   200,    -1,   202,    -1,
     204,   205,    -1,    -1,   208,    -1,    -1,    -1,   212,   213,
      -1,    -1,   216,    -1,    -1,    -1,    -1,   221,   222,    -1,
     224,   225,   226,    -1,   228,   229,    -1,    -1,   232,   233,
      -1,   235,   236,    -1,   238,    -1,    -1,   241,    -1,   243,
     244,   245,   246,   247,    -1,    -1,   250,   251,   252,   253,
     254,   255,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,    -1,    -1,   268,   269,    -1,   271,    -1,   273,
      -1,   275,   276,    -1,   278,    -1,    -1,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
      -1,   295,    -1,   297,    -1,    -1,    -1,    -1,   302,    -1,
     304,   305,    -1,   307,   308,    -1,   310,    -1,   312,   313,
      -1,    -1,    -1,   317,    -1,   319,   320,   321,   322,   323,
      -1,    -1,   326,   327,    -1,   329,    -1,    -1,   332,    -1,
     334,    -1,   336,   337,    -1,    -1,   340,    -1,    -1,    -1,
      -1,   345,    -1,   347,   348,   349,    -1,    -1,    -1,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     374,   375,   376,    -1,   378,   379,    -1,     4,     5,   383,
       7,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    26,
      27,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    -1,
      37,    -1,    39,    40,    41,    42,    43,    -1,    -1,    46,
      47,    -1,    49,    50,    51,    52,    -1,    54,    -1,    56,
      57,    58,    -1,    -1,    61,    -1,    63,    64,    65,    -1,
      67,    68,    -1,    70,    71,    72,    73,    74,    -1,    76,
      -1,    -1,    -1,    80,    -1,    -1,    -1,    84,    -1,    -1,
      87,    88,    89,    90,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    -1,    -1,   101,    -1,   103,    -1,    -1,   106,
     107,    -1,   109,   110,    -1,   112,   113,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,    -1,   123,   124,   125,    -1,
      -1,   128,   129,    -1,   131,    -1,   133,   134,    -1,    -1,
      -1,   138,    -1,    -1,   141,    -1,   143,   144,   145,   146,
      -1,    -1,    -1,    -1,    -1,   152,    -1,    -1,   155,    -1,
     157,    -1,    -1,   160,    -1,    -1,   163,    -1,    -1,    -1,
      -1,   168,    -1,    -1,    -1,   172,    -1,   174,   175,    -1,
     177,    -1,   179,    -1,    -1,    -1,   183,   184,   185,   186,
      -1,    -1,    -1,   190,   191,   192,   193,    -1,   195,   196,
     197,    -1,    -1,   200,    -1,   202,    -1,   204,   205,    -1,
      -1,   208,    -1,    -1,    -1,   212,   213,    -1,    -1,   216,
      -1,    -1,    -1,    -1,   221,   222,    -1,   224,   225,   226,
      -1,   228,   229,    -1,    -1,   232,   233,    -1,   235,   236,
      -1,   238,    -1,    -1,   241,    -1,   243,   244,   245,   246,
     247,    -1,    -1,   250,   251,   252,   253,   254,   255,   256,
     257,   258,    -1,    -1,   261,   262,   263,   264,   265,    -1,
      -1,   268,   269,    -1,   271,    -1,   273,    -1,   275,   276,
      -1,   278,    -1,    -1,   281,    -1,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,    -1,   295,    -1,
     297,    -1,    -1,    -1,    -1,   302,    -1,   304,   305,    -1,
     307,   308,    -1,   310,    -1,   312,   313,    -1,    -1,    -1,
     317,    -1,   319,   320,   321,   322,   323,    -1,    -1,   326,
     327,    -1,   329,    -1,    -1,   332,    -1,   334,    -1,   336,
     337,   338,    -1,   340,    -1,    -1,    -1,    -1,   345,    -1,
     347,   348,   349,    -1,    -1,    -1,    -1,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   374,   375,    -1,
      -1,   378,   379,    -1,     4,     5,   383,     7,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    26,    27,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    -1,    37,    -1,    39,
      40,    41,    42,    43,    -1,    -1,    46,    47,    -1,    49,
      50,    51,    52,    -1,    54,    -1,    56,    57,    58,    -1,
      -1,    61,    -1,    63,    64,    65,    -1,    67,    68,    -1,
      70,    71,    72,    73,    74,    -1,    76,    -1,    -1,    -1,
      80,    -1,    -1,    -1,    84,    -1,    -1,    87,    88,    89,
      90,    91,    -1,    -1,    -1,    95,    96,    97,    98,    -1,
      -1,   101,    -1,   103,    -1,    -1,   106,   107,    -1,   109,
     110,    -1,   112,   113,    -1,    -1,    -1,    -1,    -1,   119,
      -1,    -1,    -1,   123,   124,   125,    -1,    -1,   128,   129,
      -1,   131,    -1,   133,   134,    -1,    -1,    -1,   138,    -1,
      -1,   141,    -1,   143,   144,   145,   146,    -1,    -1,    -1,
      -1,    -1,   152,    -1,    -1,   155,    -1,   157,    -1,    -1,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,   168,    -1,
      -1,    -1,   172,    -1,   174,   175,    -1,   177,    -1,   179,
      -1,    -1,    -1,   183,   184,   185,   186,    -1,    -1,    -1,
     190,   191,   192,   193,    -1,   195,   196,   197,    -1,    -1,
     200,    -1,   202,    -1,   204,   205,    -1,    -1,   208,    -1,
      -1,    -1,   212,   213,    -1,    -1,   216,    -1,    -1,    -1,
      -1,   221,   222,    -1,   224,   225,   226,    -1,   228,   229,
      -1,    -1,   232,   233,    -1,   235,   236,    -1,   238,    -1,
      -1,   241,    -1,   243,   244,   245,   246,   247,    -1,    -1,
     250,   251,   252,   253,   254,   255,   256,   257,   258,    -1,
      -1,   261,   262,   263,   264,   265,   266,    -1,   268,   269,
      -1,   271,    -1,   273,    -1,   275,   276,    -1,   278,    -1,
      -1,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,    -1,   295,    -1,   297,    -1,    -1,
      -1,    -1,   302,    -1,   304,   305,    -1,   307,   308,    -1,
     310,    -1,   312,   313,    -1,    -1,    -1,   317,    -1,   319,
     320,   321,   322,   323,    -1,    -1,   326,   327,    -1,   329,
      -1,    -1,   332,    -1,   334,    -1,   336,   337,    -1,    -1,
     340,    -1,    -1,    -1,    -1,   345,    -1,   347,   348,   349,
      -1,    -1,    -1,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   374,   375,    -1,    -1,   378,   379,
      -1,     4,     5,   383,     7,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    26,    27,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    -1,    37,    -1,    39,    40,    41,    42,
      43,    -1,    -1,    46,    47,    -1,    49,    50,    51,    52,
      -1,    54,    -1,    56,    57,    58,    -1,    -1,    61,    -1,
      63,    64,    65,    -1,    67,    68,    -1,    70,    71,    72,
      73,    74,    -1,    76,    -1,    -1,    -1,    80,    -1,    -1,
      -1,    84,    -1,    -1,    87,    88,    89,    90,    91,    -1,
      -1,    -1,    95,    96,    97,    98,    -1,    -1,   101,    -1,
     103,    -1,    -1,   106,   107,    -1,   109,   110,    -1,   112,
     113,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,    -1,
     123,   124,   125,    -1,    -1,   128,   129,    -1,   131,    -1,
     133,   134,    -1,    -1,    -1,   138,    -1,    -1,   141,    -1,
     143,   144,   145,   146,    -1,    -1,    -1,    -1,    -1,   152,
      -1,    -1,   155,    -1,   157,    -1,    -1,   160,    -1,    -1,
     163,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,   172,
      -1,   174,   175,    -1,   177,    -1,   179,    -1,    -1,    -1,
     183,   184,   185,   186,    -1,    -1,    -1,   190,   191,   192,
     193,    -1,   195,   196,   197,    -1,    -1,   200,    -1,   202,
      -1,   204,   205,    -1,    -1,   208,    -1,    -1,    -1,   212,
     213,    -1,    -1,   216,    -1,    -1,    -1,    -1,   221,   222,
      -1,   224,   225,   226,    -1,   228,   229,    -1,    -1,   232,
     233,    -1,   235,   236,    -1,   238,    -1,    -1,   241,    -1,
     243,   244,   245,   246,   247,    -1,    -1,   250,   251,   252,
     253,   254,   255,   256,   257,   258,    -1,    -1,   261,   262,
     263,   264,   265,    -1,    -1,   268,   269,    -1,   271,    -1,
     273,    -1,   275,   276,    -1,   278,    -1,    -1,   281,    -1,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,    -1,   295,    -1,   297,    -1,    -1,    -1,    -1,   302,
      -1,   304,   305,    -1,   307,   308,    -1,   310,    -1,   312,
     313,    -1,    -1,    -1,   317,    -1,   319,   320,   321,   322,
     323,    -1,    -1,   326,   327,    -1,   329,    -1,    -1,   332,
      -1,   334,    -1,   336,   337,    -1,    -1,   340,    -1,    -1,
      -1,    -1,   345,    -1,   347,   348,   349,    -1,    -1,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   374,   375,    -1,    -1,   378,   379,    -1,     4,     5,
     383,     7,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      26,    27,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      -1,    37,    -1,    39,    40,    -1,    -1,    43,    -1,    -1,
      46,    47,    -1,    49,    50,    51,    52,    -1,    54,    -1,
      56,    57,    58,    -1,    -1,    61,    -1,    63,    64,    65,
      -1,    67,    68,    -1,    70,    71,    72,    73,    74,    -1,
      76,    -1,    -1,    -1,    80,    -1,    -1,    -1,    84,    -1,
      -1,    87,    88,    89,    90,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    -1,    -1,   101,    -1,   103,    -1,    -1,
     106,    -1,    -1,   109,   110,    -1,   112,   113,    -1,    -1,
      -1,    -1,    -1,   119,    -1,    -1,    -1,   123,   124,   125,
      -1,    -1,   128,   129,    -1,   131,    -1,   133,   134,    -1,
      -1,    -1,   138,    -1,    -1,   141,    -1,   143,   144,   145,
     146,    -1,    -1,    -1,    -1,    -1,   152,    -1,    -1,   155,
      -1,   157,    -1,    -1,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,   168,    -1,    -1,    -1,   172,    -1,   174,   175,
      -1,   177,    -1,   179,    -1,    -1,    -1,   183,   184,   185,
     186,    -1,    -1,    -1,   190,   191,   192,   193,    -1,    -1,
     196,   197,    -1,    -1,   200,    -1,   202,    -1,   204,   205,
      -1,    -1,   208,    -1,    -1,    -1,   212,   213,    -1,    -1,
     216,    -1,    -1,    -1,    -1,   221,   222,    -1,   224,   225,
     226,    -1,   228,   229,    -1,    -1,   232,   233,    -1,   235,
     236,    -1,   238,    -1,    -1,   241,    -1,   243,   244,   245,
     246,   247,    -1,    -1,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,    -1,   261,   262,   263,   264,   265,
      -1,    -1,   268,   269,    -1,   271,    -1,   273,    -1,   275,
     276,    -1,   278,    -1,    -1,   281,    -1,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,    -1,   295,
      -1,   297,    -1,    -1,    -1,    -1,   302,    -1,   304,   305,
      -1,   307,   308,    -1,   310,    -1,   312,   313,    -1,    -1,
      -1,   317,    -1,   319,   320,   321,   322,   323,    -1,    -1,
     326,   327,    -1,   329,    -1,    -1,   332,    -1,   334,    -1,
     336,   337,    -1,    -1,   340,    -1,    -1,    -1,    -1,   345,
      -1,   347,   348,   349,    -1,    -1,    -1,    -1,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,    -1,   364,   365,
       4,     5,    -1,     7,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   383,    22,    23,
      -1,    25,    26,    27,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    -1,    37,    -1,    39,    40,    -1,    -1,    43,
      -1,    -1,    46,    47,    -1,    49,    50,    51,    52,    -1,
      54,    -1,    56,    57,    58,    -1,    -1,    61,    -1,    63,
      64,    65,    -1,    67,    68,    -1,    70,    71,    72,    73,
      74,    -1,    76,    -1,    -1,    -1,    80,    -1,    -1,    -1,
      84,    -1,    -1,    87,    88,    89,    90,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    -1,    -1,   101,    -1,   103,
      -1,    -1,   106,    -1,    -1,   109,   110,    -1,   112,   113,
      -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,    -1,   123,
     124,   125,    -1,    -1,   128,   129,    -1,   131,    -1,   133,
     134,    -1,    -1,    -1,   138,    -1,    -1,   141,    -1,   143,
     144,   145,   146,    -1,    -1,    -1,    -1,    -1,   152,    -1,
      -1,   155,    -1,   157,    -1,    -1,   160,    -1,    -1,   163,
      -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,   172,    -1,
     174,   175,    -1,   177,    -1,   179,    -1,    -1,   182,   183,
     184,   185,   186,    -1,    -1,    -1,   190,   191,   192,   193,
      -1,    -1,   196,   197,    -1,    -1,    -1,    -1,   202,    -1,
     204,   205,    -1,    -1,   208,    -1,    -1,   211,   212,   213,
      -1,    -1,   216,    -1,    -1,    -1,    -1,   221,   222,    -1,
     224,   225,   226,    -1,   228,   229,    -1,    -1,   232,   233,
      -1,   235,   236,    -1,   238,    -1,    -1,   241,    -1,   243,
     244,   245,   246,   247,    -1,    -1,   250,   251,    -1,    -1,
     254,   255,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,    -1,    -1,   268,   269,    -1,   271,    -1,   273,
      -1,   275,   276,    -1,   278,    -1,    -1,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
      -1,   295,    -1,   297,    -1,    -1,    -1,    -1,   302,    -1,
     304,   305,    -1,   307,   308,    -1,   310,    -1,   312,   313,
      -1,    -1,    -1,   317,    -1,   319,   320,   321,   322,   323,
      -1,    -1,   326,   327,    -1,   329,    -1,    -1,   332,    -1,
     334,    -1,   336,   337,    -1,    -1,   340,    -1,    -1,    -1,
      -1,   345,    -1,   347,   348,   349,    -1,    -1,    -1,    -1,
      -1,   355,     4,     5,    -1,     7,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    -1,    -1,    -1,   383,
      -1,    33,    34,    -1,    -1,    37,    -1,    39,    40,    -1,
      42,    43,    -1,    -1,    46,    47,    -1,    49,    50,    51,
      52,    -1,    54,    -1,    56,    57,    58,    -1,    -1,    61,
      -1,    63,    64,    65,    -1,    67,    68,    -1,    70,    71,
      72,    73,    74,    -1,    76,    -1,    -1,    -1,    80,    -1,
      -1,    -1,    84,    -1,    -1,    87,    88,    89,    90,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    -1,    -1,   101,
      -1,   103,    -1,    -1,   106,    -1,    -1,   109,   110,    -1,
     112,   113,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,
      -1,   123,   124,   125,    -1,    -1,   128,   129,    -1,   131,
      -1,   133,   134,    -1,    -1,    -1,   138,    -1,    -1,   141,
      -1,   143,   144,   145,   146,    -1,    -1,    -1,    -1,    -1,
     152,    -1,    -1,   155,    -1,   157,    -1,    -1,   160,    -1,
      -1,   163,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,
     172,    -1,   174,   175,    -1,   177,    -1,   179,    -1,    -1,
      -1,   183,   184,   185,   186,    -1,    -1,    -1,   190,   191,
     192,   193,    -1,    -1,   196,   197,    -1,    -1,   200,    -1,
     202,    -1,   204,   205,    -1,    -1,   208,    -1,    -1,    -1,
     212,   213,    -1,    -1,   216,    -1,    -1,    -1,    -1,   221,
     222,    -1,   224,   225,   226,    -1,   228,   229,    -1,    -1,
     232,   233,    -1,   235,   236,    -1,   238,    -1,    -1,   241,
      -1,   243,   244,   245,   246,   247,    -1,    -1,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    -1,    -1,   261,
     262,   263,   264,   265,    -1,    -1,   268,   269,    -1,   271,
      -1,   273,    -1,   275,   276,    -1,   278,    -1,    -1,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,    -1,   295,    -1,   297,    -1,    -1,    -1,    -1,
     302,    -1,   304,   305,    -1,   307,   308,    -1,   310,    -1,
     312,   313,    -1,    -1,    -1,   317,    -1,   319,   320,   321,
     322,   323,    -1,    -1,   326,   327,    -1,   329,    -1,    -1,
     332,    -1,   334,    -1,   336,   337,    -1,    -1,   340,    -1,
      -1,    -1,    -1,   345,    -1,   347,   348,   349,    -1,    -1,
      -1,    -1,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,     1,    -1,    -1,    -1,     5,
      -1,    -1,     8,     9,   376,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    -1,
      26,    27,    -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    -1,    39,    40,    -1,    -1,    43,    -1,    -1,
      46,    -1,    -1,    49,    50,    51,    52,    -1,    -1,    -1,
      56,    57,    58,    -1,    -1,    61,    -1,    -1,    64,    -1,
      -1,    67,    68,    -1,    70,    71,    -1,    -1,    -1,    -1,
      76,    -1,    -1,    -1,    80,    -1,    -1,    -1,    84,    -1,
      -1,    87,    88,    89,    90,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    -1,    -1,   101,    -1,   103,    -1,    -1,
     106,    -1,    -1,   109,    -1,    -1,   112,   113,    -1,    -1,
      -1,    -1,    -1,   119,    -1,    -1,    -1,   123,   124,   125,
      -1,    -1,   128,   129,    -1,   131,    -1,   133,   134,    -1,
      -1,    -1,   138,    -1,    -1,   141,    -1,   143,   144,   145,
     146,    -1,    -1,    -1,    -1,    -1,   152,    -1,    -1,   155,
      -1,   157,    -1,    -1,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,   174,    -1,
      -1,    -1,    -1,   179,    -1,    -1,    -1,   183,   184,   185,
     186,    -1,    -1,    -1,   190,   191,   192,   193,    -1,    -1,
     196,   197,    -1,    -1,    -1,    -1,   202,    -1,    -1,   205,
      -1,    -1,   208,    -1,    -1,    -1,   212,   213,    -1,    -1,
     216,    -1,    -1,    -1,    -1,   221,   222,    -1,   224,   225,
     226,    -1,    -1,   229,    -1,    -1,   232,   233,    -1,   235,
     236,    -1,   238,    -1,    -1,   241,    -1,    -1,   244,   245,
     246,   247,    -1,    -1,   250,   251,    -1,    -1,   254,   255,
     256,   257,   258,    -1,    -1,   261,   262,   263,   264,   265,
      -1,    -1,   268,   269,    -1,   271,    -1,   273,    -1,   275,
     276,    -1,   278,    -1,    -1,   281,    -1,   283,   284,   285,
     286,   287,   288,   289,    -1,    -1,    -1,   293,    -1,   295,
      -1,   297,    -1,    -1,    -1,    -1,   302,    -1,    -1,   305,
      -1,   307,    -1,    -1,   310,    -1,   312,   313,    -1,    -1,
      -1,   317,    -1,   319,   320,    -1,   322,   323,    -1,    -1,
     326,   327,    -1,   329,    -1,    -1,   332,    -1,   334,    -1,
     336,   337,    -1,    -1,   340,    -1,    -1,    -1,    -1,   345,
      -1,   347,   348,   349,    -1,    -1,    -1,    -1,    -1,   355,
     356,   357,   358,    -1,     1,    -1,    -1,   363,     5,    -1,
      -1,     8,     9,    -1,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    -1,    26,
      27,    -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,    -1,
      37,    -1,    39,    40,    -1,    -1,    43,    -1,    -1,    46,
      -1,    -1,    49,    50,    51,    52,    -1,    -1,    -1,    56,
      57,    58,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,
      67,    68,    -1,    70,    71,    -1,    -1,    -1,    -1,    76,
      -1,    -1,    -1,    80,    -1,    -1,    -1,    84,    -1,    -1,
      87,    88,    89,    90,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    -1,    -1,   101,    -1,   103,    -1,    -1,   106,
      -1,    -1,   109,    -1,    -1,   112,   113,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,    -1,   123,   124,   125,    -1,
      -1,   128,   129,    -1,   131,    -1,   133,   134,    -1,    -1,
      -1,   138,    -1,    -1,   141,    -1,   143,   144,   145,   146,
      -1,    -1,    -1,    -1,    -1,   152,    -1,    -1,   155,    -1,
     157,    -1,    -1,   160,    -1,    -1,   163,    -1,    -1,    -1,
      -1,   168,    -1,    -1,    -1,    -1,    -1,   174,    -1,    -1,
      -1,    -1,   179,    -1,    -1,    -1,   183,   184,   185,   186,
      -1,    -1,    -1,   190,   191,   192,   193,    -1,    -1,   196,
     197,    -1,    -1,    -1,    -1,   202,    -1,    -1,   205,    -1,
      -1,   208,    -1,    -1,    -1,   212,   213,    -1,    -1,   216,
      -1,    -1,    -1,    -1,   221,   222,    -1,   224,   225,   226,
      -1,    -1,   229,    -1,    -1,   232,   233,    -1,   235,   236,
      -1,   238,    -1,    -1,   241,    -1,    -1,   244,   245,   246,
     247,    -1,    -1,   250,   251,    -1,    -1,   254,   255,   256,
     257,   258,    -1,    -1,   261,   262,   263,   264,   265,    -1,
      -1,   268,   269,    -1,   271,    -1,   273,    -1,   275,   276,
      -1,   278,    -1,    -1,   281,    -1,   283,   284,   285,   286,
     287,   288,   289,    -1,    -1,    -1,   293,    -1,   295,    -1,
     297,    -1,    -1,    -1,    -1,   302,    -1,    -1,   305,    -1,
     307,    -1,    -1,   310,    -1,   312,   313,    -1,    -1,    -1,
     317,    -1,   319,   320,    -1,   322,   323,    -1,    -1,   326,
     327,    -1,   329,    -1,    -1,   332,    -1,   334,    -1,   336,
     337,    -1,    -1,   340,    -1,    -1,    -1,    -1,   345,    -1,
     347,   348,   349,    -1,    -1,    -1,    -1,    -1,   355,   356,
     357,   358,    -1,     1,    -1,    -1,   363,     5,    -1,    -1,
       8,     9,    -1,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    -1,    26,    27,
      -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    46,    -1,
      -1,    49,    50,    51,    52,    -1,    -1,    -1,    56,    57,
      58,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    67,
      68,    -1,    70,    71,    -1,    -1,    -1,    -1,    76,    -1,
      -1,    -1,    80,    -1,    -1,    -1,    84,    -1,    -1,    87,
      88,    89,    90,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    -1,    -1,   101,    -1,   103,    -1,    -1,   106,    -1,
      -1,   109,    -1,    -1,   112,   113,    -1,    -1,    -1,    -1,
      -1,   119,    -1,    -1,    -1,   123,   124,   125,    -1,    -1,
     128,   129,    -1,   131,    -1,   133,   134,    -1,    -1,    -1,
     138,    -1,    -1,   141,    -1,   143,   144,   145,   146,    -1,
      -1,    -1,    -1,    -1,   152,    -1,    -1,   155,    -1,   157,
      -1,    -1,   160,    -1,    -1,   163,    -1,    -1,    -1,    -1,
     168,    -1,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,
      -1,   179,    -1,    -1,    -1,   183,   184,   185,   186,    -1,
      -1,    -1,   190,   191,   192,   193,    -1,    -1,   196,   197,
      -1,    -1,    -1,    -1,   202,    -1,    -1,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,    -1,    -1,   216,    -1,
      -1,    -1,    -1,   221,   222,    -1,   224,   225,   226,    -1,
      17,   229,    -1,    20,   232,   233,    -1,   235,   236,    -1,
     238,    -1,    29,   241,    -1,    -1,   244,   245,   246,   247,
      -1,    -1,   250,   251,    -1,    -1,   254,   255,   256,   257,
     258,    -1,    -1,   261,   262,   263,   264,   265,    -1,    -1,
     268,   269,    -1,   271,    -1,   273,    -1,   275,   276,    -1,
     278,    17,    -1,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,    -1,    29,    17,   293,    19,   295,    -1,   297,
      -1,    -1,    -1,    -1,   302,    92,    29,   305,    -1,   307,
      -1,    -1,   310,    -1,   312,   313,    -1,    -1,    -1,   317,
      -1,   319,   320,    -1,   322,   323,    -1,    -1,   326,   327,
      -1,   329,    -1,    17,   332,    19,   334,    -1,   336,   337,
      -1,    -1,   340,    -1,    -1,    29,    17,   345,    -1,   347,
     348,   349,    -1,    -1,    -1,   142,    -1,   355,    29,    -1,
      -1,    -1,    -1,    -1,    -1,   363,   153,   154,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   164,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    59,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   142,    -1,   195,    29,
      -1,   198,    -1,    -1,    -1,   202,    -1,   153,   154,   142,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   214,   164,    -1,
     153,   154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   164,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   142,   195,
      -1,    -1,   198,    -1,    -1,    -1,    -1,    -1,    -1,   153,
     154,   142,   195,    -1,    -1,   198,    -1,    -1,   214,    -1,
     164,    -1,   153,   154,    -1,    -1,    -1,    -1,    -1,    -1,
     277,   214,    -1,   164,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   195,    -1,    -1,   198,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   142,    -1,   195,    -1,    -1,   198,    -1,    -1,
     214,    -1,    -1,   153,   154,    -1,    -1,    17,   325,    -1,
      -1,   277,    -1,   214,   164,    -1,    -1,    -1,    -1,    29,
      -1,    -1,    -1,    -1,   277,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   350,   351,   352,   353,   354,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   195,    -1,    -1,   198,    -1,
      -1,    -1,    -1,   370,   371,   372,    -1,   374,   375,   376,
     377,   378,   379,   277,   214,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   338,    -1,    -1,    -1,   277,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   350,   351,   352,   353,   354,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   350,   351,   352,
     353,   354,    -1,    -1,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,    -1,    -1,    -1,   370,   371,   372,
      -1,   374,   375,   376,   377,   378,   379,   277,    -1,    -1,
      -1,    -1,   142,    -1,    -1,    -1,   350,   351,   352,   353,
     354,    -1,    -1,   153,   154,    -1,    -1,    -1,    -1,   350,
     351,   352,   353,   354,   164,    -1,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,    -1,    -1,    -1,   370,
     371,   372,    -1,   374,   375,   376,   377,   378,   379,    -1,
      -1,    -1,    -1,    -1,    -1,   195,    -1,    -1,   198,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     350,   351,   352,   353,   354,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     350,   351,   352,   353,   354,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
       5,    -1,    -1,     8,     9,    -1,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    22,    23,    -1,
      -1,    26,    27,    -1,    -1,    -1,    -1,    -1,    -1,    34,
      -1,    -1,    37,    -1,    39,    40,    -1,    -1,    43,    -1,
      -1,    46,    -1,    -1,    49,    50,    51,    52,    -1,    -1,
      -1,    56,    57,    58,    -1,    -1,    61,    -1,    -1,    64,
      -1,    -1,    67,    68,    -1,    70,    71,    -1,    -1,    -1,
      -1,    76,    -1,    -1,    -1,    80,    -1,    -1,    -1,    84,
      -1,    -1,    87,    88,    89,    90,    91,    -1,    -1,    -1,
      95,    96,    97,    98,    -1,    -1,   101,    -1,   103,    -1,
      -1,   106,    -1,    -1,   109,    -1,    -1,   112,   113,    -1,
      -1,    -1,    -1,    -1,   119,    -1,    -1,    -1,   123,   124,
     125,    -1,    -1,   128,   129,    -1,   131,    -1,   133,   134,
      -1,    -1,    -1,   138,    -1,    -1,   141,    -1,   143,   144,
     145,   146,    -1,    -1,    -1,    -1,    -1,   152,    -1,    -1,
     155,    -1,   157,    -1,    -1,   160,    -1,    -1,   163,    -1,
      -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,   174,
      -1,    -1,    -1,    -1,   179,    -1,    -1,    -1,   183,   184,
     185,   186,    -1,    -1,    -1,   190,   191,   192,   193,    -1,
      -1,   196,   197,    -1,    -1,    -1,    -1,   202,    -1,    -1,
     205,    -1,    -1,   208,    -1,    -1,    -1,   212,   213,    -1,
      -1,   216,    -1,    -1,    -1,    -1,   221,   222,    -1,   224,
     225,   226,    -1,    -1,   229,    -1,    -1,   232,   233,    -1,
     235,   236,    -1,   238,    -1,    -1,   241,    -1,    -1,   244,
     245,   246,   247,    -1,    -1,   250,   251,    -1,    -1,   254,
     255,   256,   257,   258,    -1,    -1,   261,   262,   263,   264,
     265,    -1,    -1,   268,   269,    -1,   271,    -1,   273,    -1,
     275,   276,    -1,   278,    -1,    -1,   281,    -1,   283,   284,
     285,   286,   287,   288,   289,    -1,    -1,    -1,   293,    -1,
     295,    -1,   297,    -1,    -1,    -1,    -1,   302,    -1,    -1,
     305,    -1,   307,    -1,    -1,   310,    -1,   312,   313,    -1,
      -1,    -1,   317,    -1,   319,   320,    -1,   322,   323,    -1,
      -1,   326,   327,    -1,   329,    -1,    -1,   332,    -1,   334,
      -1,   336,   337,    -1,    -1,   340,    -1,    -1,    -1,    -1,
     345,    -1,   347,   348,   349,     5,    -1,    -1,     8,     9,
     355,    11,    12,    -1,    -1,    -1,    -1,    -1,   363,    19,
      -1,    -1,    22,    23,    -1,    -1,    26,    27,    -1,    -1,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    -1,    39,
      40,    -1,    -1,    43,    -1,    -1,    46,    -1,    -1,    49,
      50,    51,    52,    -1,    -1,    -1,    56,    57,    58,    -1,
      -1,    61,    -1,    -1,    64,    -1,    -1,    67,    68,    -1,
      70,    71,    -1,    -1,    -1,    -1,    76,    -1,    -1,    -1,
      80,    -1,    -1,    -1,    84,    -1,    -1,    87,    88,    89,
      90,    91,    -1,    -1,    -1,    95,    96,    97,    98,    -1,
      -1,   101,    -1,   103,    -1,    -1,   106,    -1,    -1,   109,
      -1,    -1,   112,   113,    -1,    -1,    -1,    -1,    -1,   119,
      -1,    -1,    -1,   123,   124,   125,    -1,    -1,   128,   129,
      -1,   131,    -1,   133,   134,    -1,    -1,    -1,   138,    -1,
      -1,   141,    -1,   143,   144,   145,   146,    -1,    -1,    -1,
      -1,    -1,   152,    -1,    -1,   155,    -1,   157,    -1,    -1,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,   168,    -1,
      -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,   179,
      -1,    -1,    -1,   183,   184,   185,   186,    -1,    -1,    -1,
     190,   191,   192,   193,    -1,    -1,   196,   197,    -1,    -1,
      -1,    -1,   202,    -1,    -1,   205,    -1,    -1,   208,    -1,
      -1,    -1,   212,   213,    -1,    -1,   216,    -1,    -1,    -1,
      -1,   221,   222,    -1,   224,   225,   226,    -1,    -1,   229,
      -1,    -1,   232,   233,    -1,   235,   236,    -1,   238,    -1,
      -1,   241,    -1,    -1,   244,   245,   246,   247,    -1,    -1,
     250,   251,    -1,    -1,   254,   255,   256,   257,   258,    -1,
      -1,   261,   262,   263,   264,   265,    -1,    -1,   268,   269,
      -1,   271,    -1,   273,    -1,   275,   276,    -1,   278,    -1,
      -1,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
      -1,    -1,    -1,   293,    -1,   295,    -1,   297,    -1,    -1,
      -1,    -1,   302,    -1,    -1,   305,    -1,   307,    -1,    -1,
     310,    -1,   312,   313,    -1,    -1,    -1,   317,    -1,   319,
     320,    -1,   322,   323,    -1,    -1,   326,   327,    -1,   329,
      -1,    -1,   332,    -1,   334,    -1,   336,   337,    -1,    -1,
     340,    -1,    -1,    -1,    -1,   345,    -1,   347,   348,   349,
       5,    -1,    -1,     8,     9,   355,    11,    12,    -1,    -1,
      -1,    -1,    -1,   363,    19,    -1,    -1,    22,    23,    -1,
      -1,    26,    27,    -1,    -1,    -1,    -1,    -1,    -1,    34,
      -1,    -1,    37,    -1,    39,    40,    -1,    -1,    43,    -1,
      -1,    46,    -1,    -1,    49,    50,    51,    52,    -1,    -1,
      -1,    56,    57,    58,    -1,    -1,    61,    -1,    -1,    64,
      -1,    -1,    67,    68,    -1,    70,    71,    -1,    -1,    -1,
      -1,    76,    -1,    -1,    -1,    80,    -1,    -1,    -1,    84,
      -1,    -1,    87,    88,    89,    90,    91,    -1,    -1,    -1,
      95,    96,    97,    98,    -1,    -1,   101,    -1,   103,    -1,
      -1,   106,    -1,    -1,   109,    -1,    -1,   112,   113,    -1,
      -1,    -1,    -1,    -1,   119,    -1,    -1,    -1,   123,   124,
     125,    -1,    -1,   128,   129,    -1,   131,    -1,   133,   134,
      -1,    -1,    -1,   138,    -1,    -1,   141,    -1,   143,   144,
     145,   146,    -1,    -1,    -1,    -1,    -1,   152,    -1,    -1,
     155,    -1,   157,    -1,    -1,   160,    -1,    -1,   163,    -1,
      -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,   174,
      -1,    -1,    -1,    -1,   179,    -1,    -1,    -1,   183,   184,
     185,   186,    -1,    -1,    -1,   190,   191,   192,   193,    -1,
      -1,   196,   197,    -1,    -1,    -1,    -1,   202,    -1,    -1,
     205,    -1,    -1,   208,    -1,    -1,    -1,   212,   213,    -1,
      -1,   216,    -1,    -1,    -1,    -1,   221,   222,    -1,   224,
     225,   226,    -1,    -1,   229,    -1,    -1,   232,   233,    -1,
     235,   236,    -1,   238,    -1,    -1,   241,    -1,    -1,   244,
     245,   246,   247,    -1,    -1,   250,   251,    -1,    -1,   254,
     255,   256,   257,   258,    -1,    -1,   261,   262,   263,   264,
     265,    -1,    -1,   268,   269,    -1,   271,    -1,   273,    -1,
     275,   276,    -1,   278,    -1,    -1,   281,    -1,   283,   284,
     285,   286,   287,   288,   289,    -1,    -1,    -1,   293,    -1,
     295,    -1,   297,    -1,    -1,    -1,    -1,   302,    -1,    -1,
     305,    -1,   307,    -1,    -1,   310,    -1,   312,   313,    -1,
      -1,    -1,   317,    -1,   319,   320,    -1,   322,   323,    -1,
      -1,   326,   327,    -1,   329,    -1,    -1,   332,    -1,   334,
      -1,   336,   337,    -1,    -1,   340,    -1,    -1,    -1,    -1,
     345,    -1,   347,   348,   349,     5,    -1,    -1,     8,     9,
     355,    11,    12,    -1,    -1,    -1,    -1,    -1,   363,    19,
      -1,    -1,    22,    23,    -1,    -1,    26,    27,    -1,    -1,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    -1,    39,
      40,    -1,    -1,    43,    -1,    -1,    46,    -1,    -1,    49,
      50,    51,    52,    -1,    -1,    -1,    56,    57,    58,    -1,
      -1,    61,    -1,    -1,    64,    -1,    -1,    67,    68,    -1,
      70,    71,    -1,    -1,    -1,    -1,    76,    -1,    -1,    -1,
      80,    -1,    -1,    -1,    84,    -1,    -1,    87,    88,    89,
      90,    91,    -1,    -1,    -1,    95,    96,    97,    98,    -1,
      -1,   101,    -1,   103,    -1,    -1,   106,    -1,    -1,   109,
      -1,    -1,   112,   113,    -1,    -1,    -1,    -1,    -1,   119,
      -1,    -1,    -1,   123,   124,   125,    -1,    -1,   128,   129,
      -1,   131,    -1,   133,   134,    -1,    -1,    -1,   138,    -1,
      -1,   141,    -1,   143,   144,   145,   146,    -1,    -1,    -1,
      -1,    -1,   152,    -1,    -1,   155,    -1,   157,    -1,    -1,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,   168,    -1,
      -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,   179,
      -1,    -1,    -1,   183,   184,   185,   186,    -1,    -1,    -1,
     190,   191,   192,   193,    -1,    -1,   196,   197,    -1,    -1,
      -1,    -1,   202,    -1,    -1,   205,    -1,    -1,   208,    -1,
      -1,    -1,   212,   213,    -1,    -1,   216,    -1,    -1,    -1,
      -1,   221,   222,    -1,   224,   225,   226,    -1,    -1,   229,
      -1,    -1,   232,   233,    -1,   235,   236,    -1,   238,    -1,
      -1,   241,    -1,    -1,   244,   245,   246,   247,    -1,    -1,
     250,   251,    -1,    -1,   254,   255,   256,   257,   258,    -1,
      -1,   261,   262,   263,   264,   265,    -1,    -1,   268,   269,
      -1,   271,    -1,   273,    -1,   275,   276,    -1,   278,    -1,
      -1,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
      -1,    -1,    -1,   293,    -1,   295,    -1,   297,    -1,    -1,
      -1,    -1,   302,    -1,    -1,   305,    -1,   307,    -1,    -1,
     310,    -1,   312,   313,    -1,    -1,    -1,   317,    -1,   319,
     320,    -1,   322,   323,    -1,    -1,   326,   327,    -1,   329,
      -1,    -1,   332,    -1,   334,     5,   336,   337,     8,     9,
     340,    11,    12,    -1,    -1,   345,    -1,   347,   348,   349,
      -1,    -1,    22,    23,    -1,   355,    26,    27,    -1,    -1,
      -1,    -1,    -1,   363,    34,    -1,    -1,    37,    -1,    39,
      40,    -1,    -1,    43,    -1,    -1,    46,    -1,    -1,    49,
      50,    51,    52,    -1,    -1,    -1,    56,    57,    58,    -1,
      -1,    61,    -1,    -1,    64,    -1,    -1,    67,    68,    -1,
      70,    71,    -1,    -1,    -1,    -1,    76,    -1,    -1,    -1,
      80,    -1,    -1,    -1,    84,    -1,    -1,    87,    88,    89,
      90,    91,    -1,    -1,    -1,    95,    96,    97,    98,    -1,
      -1,   101,    -1,   103,    -1,    -1,   106,    -1,    -1,   109,
      -1,    -1,   112,   113,    -1,    -1,    -1,    -1,    -1,   119,
      -1,    -1,    -1,   123,   124,   125,    -1,    -1,   128,   129,
      -1,   131,    -1,   133,   134,    -1,    -1,    -1,   138,    -1,
      -1,   141,    -1,   143,   144,   145,   146,    -1,    -1,    -1,
      -1,    -1,   152,    -1,    -1,   155,    -1,   157,    -1,    -1,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,   168,    -1,
      -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,   179,
      -1,    -1,    -1,   183,   184,   185,   186,    -1,    -1,    -1,
     190,   191,   192,   193,    -1,    -1,   196,   197,    -1,    -1,
      -1,    -1,   202,    -1,    -1,   205,    -1,    -1,   208,    -1,
      -1,    -1,   212,   213,    -1,    -1,   216,    -1,    -1,    -1,
      -1,   221,   222,    -1,   224,   225,   226,    -1,    -1,   229,
      -1,    -1,   232,   233,    -1,   235,   236,    -1,   238,    -1,
      -1,   241,    -1,    -1,   244,   245,   246,   247,    -1,    -1,
     250,   251,    -1,    -1,   254,   255,   256,   257,   258,    -1,
      -1,   261,   262,   263,   264,   265,    -1,    -1,   268,   269,
      -1,   271,    -1,   273,    -1,   275,   276,    -1,   278,    -1,
      -1,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
      -1,    -1,    -1,   293,    -1,   295,    -1,   297,    -1,    -1,
      -1,    -1,   302,    -1,    -1,   305,    -1,   307,    -1,    -1,
     310,    -1,   312,   313,    -1,    -1,    -1,   317,    -1,   319,
     320,    -1,   322,   323,    -1,    -1,   326,   327,    -1,   329,
      -1,    -1,   332,    -1,   334,     5,   336,   337,     8,     9,
     340,    11,    12,    -1,    -1,   345,    -1,   347,   348,   349,
      -1,    -1,    22,    23,    -1,   355,    26,    27,    -1,    -1,
      -1,    -1,    -1,   363,    34,    -1,    -1,    37,    -1,    39,
      40,    -1,    -1,    43,    -1,    -1,    46,    -1,    -1,    49,
      50,    51,    52,    -1,    -1,    -1,    56,    57,    58,    -1,
      -1,    61,    -1,    -1,    64,    -1,    -1,    67,    68,    -1,
      70,    71,    -1,    -1,    -1,    -1,    76,    -1,    -1,    -1,
      80,    -1,    -1,    -1,    84,    -1,    -1,    87,    88,    89,
      90,    91,    -1,    -1,    -1,    95,    96,    97,    98,    -1,
      -1,   101,    -1,   103,    -1,    -1,   106,    -1,    -1,   109,
      -1,    -1,   112,   113,    -1,    -1,    -1,    -1,    -1,   119,
      -1,    -1,    -1,   123,   124,   125,    -1,    -1,   128,   129,
      -1,   131,    -1,   133,   134,    -1,    -1,    -1,   138,    -1,
      -1,   141,    -1,   143,   144,   145,   146,    -1,    -1,    -1,
      -1,    -1,   152,    -1,    -1,   155,    -1,   157,    -1,    -1,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,   168,    -1,
      -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,   179,
      -1,    -1,   182,   183,   184,   185,   186,    -1,    -1,    -1,
     190,   191,   192,   193,    -1,    -1,   196,   197,    -1,    -1,
      -1,    -1,   202,    -1,    -1,   205,    -1,    -1,   208,    -1,
      -1,    -1,   212,   213,    -1,    -1,   216,    -1,    -1,    -1,
      -1,   221,   222,    -1,   224,   225,   226,    -1,    -1,   229,
      -1,    -1,   232,   233,    -1,   235,   236,    -1,   238,    -1,
      -1,   241,    -1,    -1,   244,   245,   246,   247,    -1,    -1,
     250,   251,    -1,    -1,   254,   255,   256,   257,   258,    -1,
      -1,   261,   262,   263,   264,   265,    -1,    -1,   268,   269,
      -1,   271,    -1,   273,    -1,   275,   276,    -1,   278,    -1,
      -1,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
      -1,    -1,    -1,   293,    -1,   295,    -1,   297,    -1,    -1,
      -1,    -1,   302,    -1,    -1,   305,    -1,   307,    -1,    -1,
     310,    -1,   312,   313,    -1,    -1,    -1,   317,    -1,   319,
     320,    -1,   322,   323,    -1,    -1,   326,   327,    -1,   329,
      -1,    -1,   332,    -1,   334,     5,   336,   337,     8,     9,
     340,    11,    12,    -1,    -1,   345,    -1,   347,   348,   349,
      -1,    -1,    22,    23,    -1,   355,    26,    27,    -1,    -1,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    -1,    39,
      40,    -1,    -1,    43,    -1,    -1,    46,    -1,    -1,    49,
      50,    51,    52,    -1,    -1,    -1,    56,    57,    58,    -1,
      -1,    61,    -1,    -1,    64,    -1,    -1,    67,    68,    -1,
      70,    71,    -1,    -1,    -1,    -1,    76,    -1,    -1,    -1,
      80,    -1,    -1,    -1,    84,    -1,    -1,    87,    88,    89,
      90,    91,    -1,    -1,    -1,    95,    96,    97,    98,    -1,
      -1,   101,    -1,   103,    -1,    -1,   106,    -1,    -1,   109,
      -1,    -1,   112,   113,    -1,    -1,    -1,    -1,    -1,   119,
      -1,    -1,    -1,   123,   124,   125,    -1,    -1,   128,   129,
      -1,   131,    -1,   133,   134,    -1,    -1,    -1,   138,    -1,
      -1,   141,    -1,   143,   144,   145,   146,    -1,    -1,    -1,
      -1,    -1,   152,    -1,    -1,   155,    -1,   157,    -1,    -1,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,   168,    -1,
      -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,   179,
      -1,    -1,    -1,   183,   184,   185,   186,    -1,    -1,    -1,
     190,   191,   192,   193,    -1,    -1,   196,   197,    -1,    -1,
      -1,    -1,   202,    -1,    -1,   205,    -1,    -1,   208,    -1,
      -1,    -1,   212,   213,    -1,    -1,   216,    -1,    -1,    -1,
      -1,   221,   222,    -1,   224,   225,   226,    -1,    -1,   229,
      -1,    -1,   232,   233,    -1,   235,   236,    -1,   238,    -1,
      -1,   241,    -1,    -1,   244,   245,   246,   247,    -1,    -1,
     250,   251,    -1,    -1,   254,   255,   256,   257,   258,    -1,
      -1,   261,   262,   263,   264,   265,    -1,    -1,   268,   269,
      -1,   271,    -1,   273,    -1,   275,   276,    -1,   278,    -1,
      -1,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
      -1,    -1,    -1,   293,    -1,   295,    -1,   297,    -1,    -1,
      -1,    -1,   302,    -1,    -1,   305,    -1,   307,    -1,    -1,
     310,    -1,   312,   313,    -1,    -1,    -1,   317,    -1,   319,
     320,    -1,   322,   323,    -1,    -1,   326,   327,    -1,   329,
      -1,    -1,   332,    -1,   334,     5,   336,   337,     8,     9,
     340,    11,    12,    -1,    -1,   345,    -1,   347,   348,   349,
      -1,    -1,    22,    23,    -1,   355,    26,    27,    -1,    -1,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    37,    -1,    39,
      40,    -1,    -1,    43,    -1,    -1,    46,    -1,    -1,    49,
      50,    51,    52,    -1,    -1,    -1,    56,    57,    58,    -1,
      -1,    61,    -1,    -1,    64,    -1,    -1,    67,    68,    -1,
      70,    71,    -1,    -1,    -1,    -1,    76,    -1,    -1,    -1,
      80,    -1,    -1,    -1,    84,    -1,    -1,    87,    88,    89,
      90,    91,    -1,    -1,    -1,    95,    96,    97,    98,    -1,
      -1,   101,    -1,   103,    -1,    -1,   106,    -1,    -1,   109,
      -1,    -1,   112,   113,    -1,    -1,    -1,    -1,    -1,   119,
      -1,    -1,    -1,   123,   124,   125,    -1,    -1,   128,   129,
      -1,   131,    -1,   133,   134,    29,    -1,    -1,   138,    -1,
      -1,   141,    -1,   143,   144,   145,   146,    -1,    -1,    -1,
      -1,    -1,   152,    -1,    -1,   155,    -1,   157,    -1,    -1,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,   168,    -1,
      -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,   179,
      -1,    -1,    -1,   183,   184,   185,   186,    -1,    -1,    -1,
     190,   191,   192,   193,    -1,    -1,   196,   197,    -1,    -1,
      -1,    -1,   202,    -1,    -1,   205,    -1,    -1,   208,    -1,
      -1,    -1,   212,   213,    -1,    -1,   216,    29,    -1,    -1,
      -1,   221,   222,    -1,   224,   225,   226,    -1,    -1,   229,
      -1,    -1,   232,   233,    -1,   235,   236,    -1,   238,    -1,
      -1,   241,    -1,    -1,   244,   245,   246,   247,   142,    -1,
     250,   251,    -1,    -1,   254,   255,   256,   257,   258,   153,
     154,   261,   262,   263,   264,   265,    -1,    -1,   268,   269,
     164,   271,    29,   273,    -1,   275,   276,    -1,   278,    29,
      -1,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
      -1,   103,    -1,   293,    -1,   295,    -1,   297,    -1,    -1,
      -1,   195,   302,    -1,   198,   305,    -1,   307,    -1,    -1,
     310,    -1,   312,   313,    -1,    -1,    -1,   317,    -1,   319,
     320,    -1,   322,   323,    -1,    -1,   326,   327,    -1,   329,
     142,    -1,   332,    -1,   334,    -1,   336,   337,    -1,    -1,
     340,   153,   154,    -1,    -1,   345,   103,   347,   348,   349,
      -1,    -1,   164,   103,    -1,   355,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   277,    -1,   142,   198,    -1,    -1,    -1,
      -1,    -1,   142,    -1,    -1,    -1,   153,   154,    -1,    -1,
      -1,    -1,    -1,   153,   154,    -1,    -1,   164,    -1,    -1,
      -1,    -1,    -1,    -1,   164,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   198,    -1,    -1,    -1,    -1,    -1,    -1,   198,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   350,   351,   352,   353,
     354,    -1,    -1,    -1,    -1,   277,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     277,    -1,    -1,    -1,    -1,    -1,    -1,   277,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   350,   351,
     352,   353,   354,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   374,   375,   376,   377,   378,   379,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   350,   351,   352,   353,   354,    -1,    -1,
     350,   351,   352,   353,   354,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   374,   375,   376,
     377,   378,   379,    -1,   374,   375,   376,   377,   378,   379
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,     3,    14,    16,    28,    49,    51,    52,    56,
      57,    64,    66,    81,    84,    89,    97,   102,   106,   108,
     112,   126,   145,   166,   167,   173,   184,   197,   230,   240,
     244,   247,   249,   266,   271,   275,   282,   310,   318,   320,
     326,   340,   355,   365,   383,   389,   390,   391,   392,   393,
     399,   404,   487,   394,     5,     8,     9,    11,    12,    22,
      23,    26,    27,    34,    37,    39,    40,    43,    46,    49,
      50,    51,    52,    56,    57,    58,    61,    64,    67,    68,
      70,    71,    76,    80,    84,    87,    88,    89,    90,    91,
      95,    96,    97,    98,   101,   103,   106,   109,   112,   113,
     119,   123,   124,   125,   128,   129,   131,   133,   134,   138,
     141,   143,   144,   145,   146,   152,   155,   157,   160,   163,
     168,   174,   179,   183,   184,   185,   186,   190,   191,   192,
     193,   196,   197,   202,   205,   208,   212,   213,   216,   221,
     222,   224,   225,   226,   229,   232,   233,   235,   236,   238,
     241,   244,   245,   246,   247,   250,   251,   254,   255,   256,
     257,   258,   261,   262,   263,   264,   265,   268,   269,   271,
     273,   275,   276,   278,   281,   283,   284,   285,   286,   287,
     288,   289,   293,   295,   297,   302,   305,   307,   310,   312,
     313,   317,   319,   320,   322,   323,   326,   327,   329,   332,
     334,   336,   337,   340,   345,   347,   348,   349,   355,   400,
     401,   477,   391,   392,     0,   215,   430,   390,   104,   149,
     178,   314,    13,    93,   316,   402,    19,   387,    19,   384,
     384,     1,    37,   276,   165,   435,   396,   397,   398,   395,
     210,     4,     7,    10,    25,    33,    41,    42,    47,    54,
      63,    65,    72,    73,    74,   107,   110,   172,   175,   177,
     195,   200,   204,   228,   243,   252,   253,   291,   292,   304,
     308,   321,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   374,   375,   376,   378,   379,   383,
     391,   405,   406,   443,   444,   445,   446,   447,   448,   449,
     477,   479,   480,   481,   482,   483,   383,   401,   383,   431,
     432,   443,    37,     1,    13,   360,   436,   481,   114,   438,
      13,   403,   403,   403,   403,   383,   338,   443,   450,   451,
     454,   455,   383,   391,   443,   443,   443,   443,   443,   443,
     391,   443,   151,   387,   407,    17,    19,    29,   142,   153,
     154,   164,   195,   198,   214,   277,   350,   351,   352,   353,
     354,   370,   371,   372,   374,   375,   376,   377,   378,   379,
     486,   383,   391,   393,   393,   387,    20,    92,   202,   325,
     433,   434,   431,   207,     1,   360,   439,   481,   341,   342,
     343,   344,   441,   393,   404,   404,   404,   404,   443,   460,
     360,   338,   452,   453,    99,   102,    99,   102,   455,   443,
     384,   406,   121,   408,   443,     1,   355,   363,   477,   200,
     252,   253,   355,   360,   361,   391,   446,   459,   477,   479,
     480,   481,   483,   383,   391,   458,   480,   111,   195,   200,
     309,   317,   443,    29,   142,   164,   277,   443,   301,   443,
     443,   443,   443,   443,   443,   443,   443,    13,    18,   280,
     443,   478,    13,    42,    93,   200,   252,   253,   360,   361,
     376,   384,   447,   461,   462,   479,   480,   481,   482,   483,
     384,   384,   432,   113,   160,   354,   370,   371,   372,   374,
     375,   376,   377,   378,   379,   484,   485,   434,     1,   360,
     437,   481,   251,   254,   440,   116,   442,   384,   387,   298,
     355,   453,   355,   360,   361,   456,   456,    19,   182,   211,
     355,   391,   409,   410,   411,   412,   415,   420,   446,   477,
     339,   426,     1,    17,   460,   111,   200,   309,   317,   103,
     459,   458,   443,   301,   443,   391,   376,   461,   383,   461,
     384,   383,   384,   387,   211,   320,   443,   355,   360,   361,
     457,   298,   102,   102,    32,    44,    45,    79,    82,    83,
     147,   148,   150,   186,   188,   203,   279,   299,   300,   330,
     331,   463,   464,   465,   466,   467,   468,   469,   470,   386,
     355,   412,   223,   259,   260,   290,   413,   414,    19,   355,
     363,   416,   477,   387,    69,   122,   140,   156,   162,   187,
     248,   315,   421,   422,    19,   416,    19,   416,   413,   414,
     443,   282,   427,   459,   384,   361,     1,    17,   103,   443,
     103,   384,   443,   384,   461,   462,   457,   332,   383,   476,
     332,   476,   332,   476,    80,   131,   179,   183,   264,   348,
     471,   472,   473,   475,    44,    45,   332,   476,   476,   476,
     383,   383,   384,    45,   383,   355,   477,    19,   416,   383,
     383,   383,   383,   416,   383,   417,   410,   156,   156,   421,
     411,   411,   156,   217,   416,   417,   416,   417,   340,   127,
     428,   459,   361,   103,   361,    19,   384,   383,   360,   383,
     383,   383,   301,   476,   332,   476,   332,   476,   383,   340,
     340,   360,   360,   271,   360,   416,   417,   355,   360,   360,
     355,   417,     1,   355,   418,   419,   479,   481,   482,   411,
     411,   210,   325,   423,   156,   417,   417,   443,    37,   130,
     429,   361,   463,   360,   384,   360,   360,   360,   264,   473,
     474,   383,   383,   360,   299,   299,   384,   384,   355,   384,
     386,   417,   384,   384,   384,   384,   384,   387,   423,   443,
     383,    59,   460,   443,   384,   384,   384,   384,   384,   387,
     476,   360,   360,   384,   349,   349,   360,   413,   413,   419,
       1,   424,   425,   479,   481,   482,    37,   360,   384,   384,
     384,   384,   387,   443,   384,   425
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   388,   389,   389,   389,   389,   389,   389,   390,   390,
     391,   391,   392,   394,   393,   395,   393,   396,   393,   397,
     393,   398,   393,   399,   400,   400,   401,   401,   402,   402,
     402,   402,   402,   403,   403,   404,   404,   405,   405,   406,
     406,   406,   406,   406,   406,   407,   407,   408,   408,   409,
     409,   410,   411,   411,   411,   411,   411,   411,   411,   411,
     411,   411,   411,   411,   412,   412,   412,   412,   412,   412,
     412,   412,   413,   413,   414,   414,   414,   414,   415,   416,
     416,   416,   417,   417,   418,   418,   419,   419,   419,   419,
     420,   420,   420,   420,   421,   421,   421,   421,   422,   422,
     422,   423,   423,   424,   424,   425,   425,   425,   425,   426,
     426,   427,   427,   427,   428,   428,   429,   429,   430,   430,
     430,   430,   431,   431,   432,   432,   432,   432,   433,   433,
     433,   434,   434,   435,   435,   436,   436,   436,   436,   437,
     437,   437,   438,   438,   439,   439,   439,   440,   440,   441,
     441,   441,   441,   441,   442,   442,   443,   443,   443,   443,
     443,   443,   443,   443,   443,   443,   443,   443,   443,   443,
     443,   443,   443,   443,   443,   443,   444,   444,   444,   444,
     444,   444,   444,   444,   444,   444,   444,   444,   444,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   446,   446,   446,   446,
     446,   447,   447,   448,   448,   448,   448,   448,   448,   448,
     448,   448,   448,   448,   448,   448,   448,   448,   448,   448,
     448,   448,   448,   448,   448,   448,   448,   449,   449,   449,
     449,   450,   451,   452,   452,   453,   454,   454,   455,   456,
     456,   456,   457,   457,   457,   458,   458,   458,   459,   459,
     459,   459,   459,   459,   459,   459,   459,   459,   459,   459,
     459,   460,   460,   461,   461,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   463,   463,
     463,   463,   463,   463,   463,   464,   464,   464,   464,   464,
     464,   465,   465,   465,   465,   465,   465,   466,   466,   467,
     467,   467,   467,   467,   467,   468,   468,   468,   469,   469,
     469,   469,   469,   470,   471,   471,   472,   473,   473,   473,
     473,   473,   474,   474,   475,   475,   475,   475,   476,   476,
     477,   477,   477,   477,   477,   477,   477,   477,   477,   477,
     477,   477,   477,   477,   477,   477,   477,   477,   477,   477,
     477,   477,   477,   477,   477,   477,   477,   477,   477,   477,
     477,   477,   477,   477,   477,   477,   477,   477,   477,   477,
     477,   477,   477,   477,   477,   477,   477,   477,   477,   477,
     477,   477,   477,   477,   477,   477,   477,   477,   477,   477,
     477,   477,   477,   477,   477,   477,   477,   477,   477,   477,
     477,   477,   477,   477,   477,   477,   477,   477,   477,   477,
     477,   477,   477,   477,   477,   477,   477,   477,   477,   477,
     477,   477,   477,   477,   477,   477,   477,   477,   477,   477,
     477,   477,   477,   477,   477,   477,   477,   477,   477,   477,
     477,   477,   477,   477,   477,   477,   477,   477,   477,   477,
     477,   477,   477,   477,   477,   477,   477,   477,   477,   477,
     477,   477,   477,   477,   477,   477,   477,   477,   477,   477,
     477,   477,   477,   477,   477,   477,   477,   477,   477,   477,
     477,   477,   477,   477,   478,   478,   478,   479,   479,   480,
     481,   482,   482,   482,   483,   483,   483,   484,   484,   485,
     485,   485,   485,   485,   485,   485,   485,   485,   486,   486,
     486,   486,   486,   486,   487,   487,   487,   487,   487,   487,
     487,   487,   487,   487,   487,   487,   487,   487,   487,   487,
     487,   487,   487,   487,   487,   487,   487,   487,   487,   487,
     487,   487,   487,   487,   487,   487,   487,   487,   487,   487,
     487,   487
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       3,     3,     6,     0,    10,     0,     5,     0,     5,     0,
       5,     0,     5,     2,     1,     3,     5,     5,     1,     1,
       1,     5,     0,     1,     0,     1,     1,     1,     3,     1,
       3,     3,     3,     3,     1,     1,     0,     2,     0,     1,
       3,     1,     1,     3,     4,     2,     4,     5,     1,     3,
       4,     3,     4,     1,     1,     1,     2,     2,     2,     2,
       3,     3,     4,     4,     4,     4,     5,     5,     1,     1,
       1,     1,     3,     0,     1,     3,     1,     1,     1,     1,
       4,     3,     4,     5,     1,     2,     2,     3,     1,     1,
       1,     2,     4,     1,     3,     1,     1,     1,     1,     2,
       0,     3,     6,     0,     3,     0,     2,     0,     3,     4,
       2,     0,     1,     3,     1,     2,     2,     3,     1,     1,
       2,     2,     2,     4,     0,     1,     1,     1,     1,     1,
       1,     1,     4,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     2,     0,     1,     1,     1,     1,
       3,     4,     3,     4,     5,     6,     4,     5,     3,     5,
       4,     6,     4,     6,     5,     7,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     6,     1,     3,
       2,     2,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     3,     2,     3,     2,     4,     2,
       3,     4,     3,     4,     3,     4,     3,     4,     4,     5,
       5,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     5,     3,
       5,     2,     1,     1,     2,     4,     1,     2,     4,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     4,     6,     1,     1,     4,
       1,     1,     1,     1,     1,     2,     2,     5,     5,     4,
       4,     3,     3,     2,     6,     6,     5,     2,     5,     1,
       4,     6,     1,     1,     1,     1,     1,     1,     1,     2,
       5,     2,     5,     2,     3,     1,     2,     1,     1,     1,
       1,     1,     1,     2,     2,     1,     4,     6,     3,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (p_ctx, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, p_ctx); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, divy_sql_parser_ctx *p_ctx)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (p_ctx);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, divy_sql_parser_ctx *p_ctx)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, p_ctx);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, divy_sql_parser_ctx *p_ctx)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              , p_ctx);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, p_ctx); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, divy_sql_parser_ctx *p_ctx)
{
  YYUSE (yyvaluep);
  YYUSE (p_ctx);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (divy_sql_parser_ctx *p_ctx)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, p_ctx);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 328 "sqlparser.y" /* yacc.c:1646  */
    {
				P_CTX->sqlenode = (yyvsp[0].node);
			}
#line 4386 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 3:
#line 332 "sqlparser.y" /* yacc.c:1646  */
    {
				P_CTX->sqlenode = _appendExpr((yyvsp[-1].node), (yyvsp[0].node));
			}
#line 4394 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 4:
#line 336 "sqlparser.y" /* yacc.c:1646  */
    {
				/* 禁止された構文(DDL, 更新DML, DCL) が指定された */
				ERRLOG0(POOL, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
					"Could not use DDL or update-DML or DCL sentence");
				SET_ERRCD(DIVY_SQLP_ST_FOUND_UPDATESTMT);
				YYABORT;
			}
#line 4406 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 5:
#line 344 "sqlparser.y" /* yacc.c:1646  */
    {
				/* 先頭が有効な開始識別子(SELECT句)ではなかった */
				ERRLOG1(POOL, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
					"The first keyword must be \"SELECT\" or \"WITH\"."
					"(keyword = %s)", (yyvsp[0].str));
				SET_ERRCD(DIVY_SQLP_ST_NONSELECT);
				YYABORT;
			}
#line 4419 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 6:
#line 353 "sqlparser.y" /* yacc.c:1646  */
    {
				/* コメントが正しく閉じられていなかった */
				ERRLOG0(POOL, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
					"The c-style comment is not closed.");
				SET_ERRCD(DIVY_SQLP_ST_UNQUOTED_CTSTR);
				YYABORT;
			}
#line 4431 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 7:
#line 361 "sqlparser.y" /* yacc.c:1646  */
    {
				/* 解析に失敗した */
				ERRLOG0(POOL, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
					"Could not understand this sentence.");
				SET_ERRCD(DIVY_SQLP_ST_UNKNOWN_STMT);
				YYABORT;
			}
#line 4443 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 8:
#line 377 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 4449 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 9:
#line 379 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 4455 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 10:
#line 385 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 4461 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 11:
#line 386 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 4467 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 12:
#line 393 "sqlparser.y" /* yacc.c:1646  */
    {
				/* SELECT 文を表すノードの生成 */
				(yyval.node) = _makeNode(P_CTX, DIVY_NT_SELECT, "SELECT");
				(yyval.node)->first_child = _appendExpr((yyvsp[-5].node), (yyvsp[-4].node));
				(yyval.node)->first_child = _appendExpr((yyval.node)->first_child, (yyvsp[-3].node));
				(yyval.node)->first_child = _appendExpr((yyval.node)->first_child, (yyvsp[-2].node));
			}
#line 4479 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 13:
#line 405 "sqlparser.y" /* yacc.c:1646  */
    { P_CTX->select_id++; }
#line 4485 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 14:
#line 408 "sqlparser.y" /* yacc.c:1646  */
    {
				/* reduceされるのでSELECT句識別IDを1つ前に戻す */
				P_CTX->select_id--;

				(yyval.node) = _appendExpr((yyvsp[-6].node), (yyvsp[-4].node));	/* $2 はSELECTのアクション */
				(yyval.node) = _appendExpr((yyval.node), (yyvsp[-3].node));
				(yyval.node) = _appendExpr((yyval.node), (yyvsp[-2].node));
				(yyval.node) = _appendExpr((yyval.node), (yyvsp[-1].node));
			}
#line 4499 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 15:
#line 417 "sqlparser.y" /* yacc.c:1646  */
    { _resetSelectColCnt(p_ctx); }
#line 4505 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 16:
#line 419 "sqlparser.y" /* yacc.c:1646  */
    {
				(yyval.node) = _appendExpr((yyvsp[-4].node), (yyvsp[0].node));
			}
#line 4513 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 17:
#line 422 "sqlparser.y" /* yacc.c:1646  */
    { _resetSelectColCnt(p_ctx); }
#line 4519 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 18:
#line 424 "sqlparser.y" /* yacc.c:1646  */
    {
				(yyval.node) = _appendExpr((yyvsp[-4].node), (yyvsp[0].node));
			}
#line 4527 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 19:
#line 427 "sqlparser.y" /* yacc.c:1646  */
    { _resetSelectColCnt(p_ctx); }
#line 4533 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 20:
#line 429 "sqlparser.y" /* yacc.c:1646  */
    {
				(yyval.node) = _appendExpr((yyvsp[-4].node), (yyvsp[0].node));
			}
#line 4541 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 21:
#line 432 "sqlparser.y" /* yacc.c:1646  */
    { _resetSelectColCnt(p_ctx); }
#line 4547 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 22:
#line 434 "sqlparser.y" /* yacc.c:1646  */
    {
				(yyval.node) = _appendExpr((yyvsp[-4].node), (yyvsp[0].node));
			}
#line 4555 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 23:
#line 445 "sqlparser.y" /* yacc.c:1646  */
    {
				(yyval.node) = (yyvsp[0].node);

				/* 副問い合わせファクタリングにおける
						カウント数は使用しない */
				_resetSelectColCnt(p_ctx);
				_resetMaxSelectColCnt(p_ctx);
			}
#line 4568 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 24:
#line 456 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 4574 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 25:
#line 458 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node)); }
#line 4580 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 26:
#line 462 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 4586 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 27:
#line 464 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 4592 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 28:
#line 469 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 4598 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 29:
#line 470 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 4604 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 30:
#line 471 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 4610 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 31:
#line 472 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 4616 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 32:
#line 473 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 4622 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 34:
#line 479 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.keyword) = NULL; }
#line 4628 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 35:
#line 487 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 4634 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 36:
#line 488 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 4640 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 37:
#line 495 "sqlparser.y" /* yacc.c:1646  */
    {
				(yyval.node) = (yyvsp[0].node);
				/* SELECT句カラムのカウント */
				_incrementSelectColCnt(p_ctx);
			}
#line 4650 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 38:
#line 501 "sqlparser.y" /* yacc.c:1646  */
    {
				(yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node));	

				/* SELECT句カラムのカウント */
				_incrementSelectColCnt(p_ctx);
			}
#line 4661 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 39:
#line 510 "sqlparser.y" /* yacc.c:1646  */
    {
				(yyval.node) = (yyvsp[0].node);
				if ((yyval.node)) (yyval.node)->belong_nodetype = DIVY_NT_SELECT_CLAUSE;
			}
#line 4670 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 40:
#line 515 "sqlparser.y" /* yacc.c:1646  */
    {
				/* エイリアス名をカラム名にする */
				(yyval.node) = _makeNode(P_CTX, DIVY_NT_COLUMN, (yyvsp[0].str));
				if ((yyval.node)) (yyval.node)->belong_nodetype = DIVY_NT_SELECT_CLAUSE;
			}
#line 4680 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 41:
#line 521 "sqlparser.y" /* yacc.c:1646  */
    {
				/* エイリアス名をカラム名にする */
				(yyval.node) = _makeNode(P_CTX, DIVY_NT_COLUMN, (yyvsp[0].str));
				if ((yyval.node)) (yyval.node)->belong_nodetype = DIVY_NT_SELECT_CLAUSE;
			}
#line 4690 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 42:
#line 527 "sqlparser.y" /* yacc.c:1646  */
    {
				/* エイリアス名をカラム名にする */
				(yyval.node) = _makeNode(P_CTX, DIVY_NT_COLUMN, (yyvsp[0].keyword));
				if ((yyval.node)) (yyval.node)->belong_nodetype = DIVY_NT_SELECT_CLAUSE;
			}
#line 4700 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 43:
#line 533 "sqlparser.y" /* yacc.c:1646  */
    {
				/* 正しくないエイリアスが指定された */
				ERRLOG0(POOL, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
					"The wrong column alias name is specified.");
				SET_ERRCD(DIVY_SQLP_ST_INVALID);
				YYABORT;
			}
#line 4712 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 44:
#line 541 "sqlparser.y" /* yacc.c:1646  */
    {
				/* SELECT 句に'*'を指定することは出来ない */
				ERRLOG0(POOL, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
					"Could not use '*' column in \"SELECT\" clause.");
				SET_ERRCD(DIVY_SQLP_ST_FOUND_ASTERISK);
				YYABORT;
			}
#line 4724 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 45:
#line 554 "sqlparser.y" /* yacc.c:1646  */
    {
				/* SELECT ... INTO 句は使用できない */
				ERRLOG0(POOL, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
					"Could not use \"SELECT ... INTO\" sentence.");
				SET_ERRCD(DIVY_SQLP_ST_FOUND_UPDATESTMT);
				YYABORT;
			}
#line 4736 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 46:
#line 561 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.keyword) = NULL; }
#line 4742 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 47:
#line 568 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 4748 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 48:
#line 569 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 4754 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 49:
#line 572 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 4760 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 50:
#line 574 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node)); }
#line 4766 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 51:
#line 577 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 4772 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 52:
#line 583 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 4778 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 53:
#line 585 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 4784 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 54:
#line 587 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 4790 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 55:
#line 588 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 4796 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 56:
#line 590 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 4802 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 57:
#line 592 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 4808 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 58:
#line 593 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 4814 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 59:
#line 595 "sqlparser.y" /* yacc.c:1646  */
    {
				(yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node));	/* PostgreSQL方言 */
			}
#line 4822 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 60:
#line 599 "sqlparser.y" /* yacc.c:1646  */
    {
				(yyval.node) = _appendExpr((yyvsp[-3].node), (yyvsp[0].node));	/* PostgreSQL方言 */
			}
#line 4830 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 61:
#line 603 "sqlparser.y" /* yacc.c:1646  */
    {
				(yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node));
			}
#line 4838 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 62:
#line 607 "sqlparser.y" /* yacc.c:1646  */
    {
				(yyval.node) = _appendExpr((yyvsp[-3].node), (yyvsp[0].node));
			}
#line 4846 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 63:
#line 610 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 4852 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 65:
#line 615 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 4858 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 66:
#line 616 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 4864 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 67:
#line 618 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 4870 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 68:
#line 620 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 4876 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 69:
#line 622 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 4882 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 70:
#line 623 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 4888 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 71:
#line 625 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 4894 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 72:
#line 629 "sqlparser.y" /* yacc.c:1646  */
    {
				/* SAMPLE_DAは、SAMPLEというトークンが
				   tablenameと衝突するのを防止する目的で導入したもの。
				   括弧の対応が取れていないのは意図的です。*/
					(yyval.node) = NULL;
			}
#line 4905 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 73:
#line 636 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 4911 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 74:
#line 639 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 4917 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 75:
#line 641 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 4923 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 76:
#line 643 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 4929 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 77:
#line 645 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 4935 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 78:
#line 648 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 4941 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 81:
#line 653 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 4947 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 82:
#line 656 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 4953 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 83:
#line 657 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 4959 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 84:
#line 660 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 4965 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 85:
#line 662 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node)); }
#line 4971 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 86:
#line 665 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 4977 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 87:
#line 666 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 4983 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 88:
#line 667 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 4989 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 89:
#line 669 "sqlparser.y" /* yacc.c:1646  */
    {
				/* 多分持てない。。 */
				ERRLOG0(POOL, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
					"Could not have this value for column_alias.");
				SET_ERRCD(DIVY_SQLP_ST_INVALID);
				YYABORT;
			}
#line 5001 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 90:
#line 679 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-3].node), (yyvsp[0].node)); }
#line 5007 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 91:
#line 681 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node)); }
#line 5013 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 92:
#line 683 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-3].node), (yyvsp[0].node)); }
#line 5019 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 93:
#line 685 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-4].node), (yyvsp[0].node)); }
#line 5025 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 101:
#line 699 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5031 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 102:
#line 701 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 5037 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 103:
#line 704 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5043 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 104:
#line 706 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node)); }
#line 5049 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 105:
#line 709 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 5055 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 106:
#line 710 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5061 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 107:
#line 711 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5067 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 108:
#line 713 "sqlparser.y" /* yacc.c:1646  */
    {
				/* 多分持てない。。 */
				ERRLOG0(POOL, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
					"Could not have this value for join_column_list.");
				SET_ERRCD(DIVY_SQLP_ST_INVALID);
				YYABORT;
			}
#line 5079 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 109:
#line 726 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5085 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 110:
#line 727 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 5091 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 111:
#line 733 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5097 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 112:
#line 735 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-3].node), (yyvsp[0].node)); }
#line 5103 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 113:
#line 736 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 5109 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 114:
#line 743 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5115 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 115:
#line 744 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 5121 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 116:
#line 751 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5127 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 117:
#line 752 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 5133 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 118:
#line 759 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5139 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 119:
#line 761 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5145 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 120:
#line 763 "sqlparser.y" /* yacc.c:1646  */
    {
				/* 構文に誤り発見 */
				ERRLOG0(POOL, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
					"The syntax of \"ORDER BY\" is wrong.");
				SET_ERRCD(DIVY_SQLP_ST_INVALID);
				YYABORT;
			}
#line 5157 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 121:
#line 770 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 5163 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 122:
#line 773 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5169 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 123:
#line 775 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node)); }
#line 5175 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 124:
#line 778 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5181 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 125:
#line 779 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 5187 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 126:
#line 781 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 5193 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 127:
#line 783 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-2].node); }
#line 5199 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 133:
#line 800 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node)); }
#line 5205 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 134:
#line 801 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 5211 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 135:
#line 804 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 5217 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 136:
#line 805 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5223 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 137:
#line 806 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 5229 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 138:
#line 808 "sqlparser.y" /* yacc.c:1646  */
    {
				/* LIMITの後ろには数値か"ALL"だけ */
				ERRLOG0(POOL, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
					"Could not have this value for \"LIMIT\" clause.");
				SET_ERRCD(DIVY_SQLP_ST_INVALID);
				YYABORT;
			}
#line 5241 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 139:
#line 817 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 5247 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 140:
#line 818 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5253 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 141:
#line 820 "sqlparser.y" /* yacc.c:1646  */
    {
				/* 数値以外はNG */
				ERRLOG0(POOL, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
					"Could not have this value for \"OFFSET\" clause.");
				SET_ERRCD(DIVY_SQLP_ST_INVALID);
				YYABORT;
			}
#line 5265 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 142:
#line 833 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-2].node); }
#line 5271 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 143:
#line 834 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 5277 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 144:
#line 837 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 5283 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 145:
#line 839 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5289 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 146:
#line 840 "sqlparser.y" /* yacc.c:1646  */
    {
				/* 数値以外はNG */
				ERRLOG0(POOL, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
					"Could not have this value for \"FETCH FIRST\" clause.");
				SET_ERRCD(DIVY_SQLP_ST_INVALID);
				YYABORT;
			}
#line 5301 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 149:
#line 856 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 5307 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 150:
#line 857 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 5313 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 151:
#line 858 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 5319 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 152:
#line 859 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 5325 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 153:
#line 860 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 5331 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 154:
#line 868 "sqlparser.y" /* yacc.c:1646  */
    {
				/* 禁止された構文(更新DML, DCL) が指定された */
				ERRLOG0(POOL, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
					"Could not use \"SELECT ... FOR UPDATE\" sentence");
				SET_ERRCD(DIVY_SQLP_ST_FOUND_UPDATESTMT);
				YYABORT;
			}
#line 5343 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 155:
#line 875 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 5349 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 156:
#line 882 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5355 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 157:
#line 883 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5361 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 158:
#line 884 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5367 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 159:
#line 885 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5373 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 160:
#line 887 "sqlparser.y" /* yacc.c:1646  */
    {
				/* 左辺値のチェック */
				if (_validate_lval(POOL, (yyvsp[-1].str), (yyvsp[-2].node))) {
					SET_ERRCD(DIVY_SQLP_ST_WRONG_LVAL);
					YYABORT;
				}

				/* $$SMxxx が IN句以外の演算子の右辺値 */
				if ((yyvsp[0].node) && (yyvsp[0].node)->nodetype == DIVY_NT_M_REQUIREDSQL) {
					ERRLOG3(POOL, APLOG_WARNING,
						DIVY_FST_CERR + DIVY_SST_SYNTAX,
						"The RequiredSQL \"%s\" was specified "
						"as rvalue operand of \"%s\" operator."
						"(lvalue = %s)", (yyvsp[0].node)->name, (yyvsp[-1].str), (yyvsp[-2].node)->name);
					SET_ERRCD(DIVY_SQLP_ST_WRONG_M_PREF);
					YYABORT;
				}

				if (_enable_making_expr((yyvsp[-1].str), (yyvsp[-2].node), (yyvsp[0].node))) {
					(yyval.node) = _makeExpr(P_CTX, DIVY_NT_OPERATOR, (yyvsp[-1].str), (yyvsp[-2].node), (yyvsp[0].node));
				}
				else {
					(yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node));
				}
			}
#line 5403 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 161:
#line 913 "sqlparser.y" /* yacc.c:1646  */
    {
				/* 左辺値のチェック */
				if (_validate_lval(POOL, (yyvsp[-2].str), (yyvsp[-3].node))) {
					SET_ERRCD(DIVY_SQLP_ST_WRONG_LVAL);
					YYABORT;
				}

				(yyval.node) = _appendExpr((yyvsp[-3].node), (yyvsp[0].node));
			}
#line 5417 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 162:
#line 923 "sqlparser.y" /* yacc.c:1646  */
    {
				/* 左辺値のチェック */
				if (_validate_lval(POOL, (yyvsp[-1].keyword), (yyvsp[-2].node))) {
					SET_ERRCD(DIVY_SQLP_ST_WRONG_LVAL);
					YYABORT;
				}

				if (_enable_making_expr((yyvsp[-1].keyword),(yyvsp[-2].node),(yyvsp[0].node))) {
					(yyval.node) = _makeExpr(P_CTX, DIVY_NT_OPERATOR, (yyvsp[-1].keyword), (yyvsp[-2].node), (yyvsp[0].node));
				}
				else {
					(yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node));
				}
			}
#line 5436 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 163:
#line 938 "sqlparser.y" /* yacc.c:1646  */
    {
				/* 左辺値のチェック */
				if (_validate_lval(POOL, "not in", (yyvsp[-3].node))) {
					SET_ERRCD(DIVY_SQLP_ST_WRONG_LVAL);
					YYABORT;
				}

				if (_enable_making_expr((yyvsp[-2].keyword), (yyvsp[-3].node), (yyvsp[0].node))) {
					(yyval.node) = _makeExpr(P_CTX, DIVY_NT_OPERATOR, "not in", (yyvsp[-3].node), (yyvsp[0].node));
				}
				else {
					(yyval.node) = _appendExpr((yyvsp[-3].node), (yyvsp[0].node));
				}
			}
#line 5455 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 164:
#line 953 "sqlparser.y" /* yacc.c:1646  */
    {
				/* 左辺値のチェック */
				if (_validate_lval(POOL, (yyvsp[-3].keyword), (yyvsp[-4].node))) {
					SET_ERRCD(DIVY_SQLP_ST_WRONG_LVAL);
					YYABORT;
				}
				/* ANDの前の式にANDの後ろの式を連結する */
				(yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node));

				if ((yyval.node) && _enable_making_expr((yyvsp[-3].keyword), (yyvsp[-4].node), (yyval.node))) {
					/* BETWEEN 式の生成 */
					(yyval.node) = _makeExpr(P_CTX, DIVY_NT_OPERATOR, (yyvsp[-3].keyword), (yyvsp[-4].node), (yyval.node));
				}
				else {
					(yyval.node) = _appendExpr((yyvsp[-4].node), (yyval.node));
				}
			}
#line 5477 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 165:
#line 971 "sqlparser.y" /* yacc.c:1646  */
    {
				/* 左辺値のチェック */
				if (_validate_lval(POOL, "not between", (yyvsp[-5].node))) {
					SET_ERRCD(DIVY_SQLP_ST_WRONG_LVAL);
					YYABORT;
				}
				/* ANDの前の式にANDの後ろの式を連結する */
				(yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node));
				if ((yyval.node) && _enable_making_expr((yyvsp[-4].keyword),(yyvsp[-5].node),(yyval.node))) {
					(yyval.node) = _makeExpr(P_CTX, DIVY_NT_OPERATOR, "not in", (yyvsp[-5].node), (yyval.node));	
				}
				else {
					(yyval.node) = _appendExpr((yyvsp[-5].node), (yyval.node));
				}
			}
#line 5497 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 166:
#line 987 "sqlparser.y" /* yacc.c:1646  */
    {
				/* 構文エラー */
				ERRLOG0(POOL, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
					"Unsupported sql statement.(\"BETWEEN\" operator)");
				SET_ERRCD(DIVY_SQLP_ST_INVALID);
				YYABORT;
			}
#line 5509 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 167:
#line 995 "sqlparser.y" /* yacc.c:1646  */
    {
				/* 構文エラー */
				ERRLOG0(POOL, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
					"Unsupported sql statement.(\"NOT BETWEEN\" operator)");
				SET_ERRCD(DIVY_SQLP_ST_INVALID);
				YYABORT;
			}
#line 5521 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1003 "sqlparser.y" /* yacc.c:1646  */
    { 
				if (_validate_lval(POOL, (yyvsp[-1].keyword), (yyvsp[-2].node))) {
					SET_ERRCD(DIVY_SQLP_ST_WRONG_LVAL);
					YYABORT;
				}

				/* $$SMxxx が IN句以外の演算子の右辺値 */
				if ((yyvsp[0].node) && (yyvsp[0].node)->nodetype == DIVY_NT_M_REQUIREDSQL) {
					ERRLOG3(POOL, APLOG_WARNING,
						DIVY_FST_CERR + DIVY_SST_SYNTAX,
						"The RequiredSQL \"%s\" was specified "
						"as rvalue operand of \"%s\" operator."
						"(lvalue = %s)", (yyvsp[0].node)->name, (yyvsp[-1].keyword), (yyvsp[-2].node)->name);
					SET_ERRCD(DIVY_SQLP_ST_WRONG_M_PREF);
					YYABORT;
				}

				if (_enable_making_expr((yyvsp[-1].keyword), (yyvsp[-2].node), (yyvsp[0].node))) {
					(yyval.node) = _makeExpr(P_CTX, DIVY_NT_OPERATOR, (yyvsp[-1].keyword), (yyvsp[-2].node), (yyvsp[0].node));	
				}
				else {
					(yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node));
				}
			}
#line 5550 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1028 "sqlparser.y" /* yacc.c:1646  */
    {
				/* 左辺値のチェック */
				if (_validate_lval(POOL, (yyvsp[-3].keyword), (yyvsp[-4].node))) {
					SET_ERRCD(DIVY_SQLP_ST_WRONG_LVAL);
					YYABORT;
				}

				/* $$SMxxx が IN句以外の演算子の右辺値 */
				if ((yyvsp[-2].node) && (yyvsp[-2].node)->nodetype == DIVY_NT_M_REQUIREDSQL) {
					ERRLOG3(POOL, APLOG_WARNING,
						DIVY_FST_CERR + DIVY_SST_SYNTAX,
						"The RequiredSQL \"%s\" was specified "
						"as rvalue operand of \"%s\" operator."
						"(lvalue = %s)", (yyvsp[-2].node)->name, (yyvsp[-3].keyword), (yyvsp[-4].node)->name);
					SET_ERRCD(DIVY_SQLP_ST_WRONG_M_PREF);
					YYABORT;
				}

				if (_enable_making_expr((yyvsp[-3].keyword),(yyvsp[-4].node),(yyvsp[-2].node))) {
					(yyval.node) = _makeExpr(P_CTX, DIVY_NT_OPERATOR, (yyvsp[-3].keyword), (yyvsp[-4].node), (yyvsp[-2].node));	
				}
				else {
					(yyval.node) = _appendExpr((yyvsp[-4].node), (yyvsp[-2].node));
				}
			}
#line 5580 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1054 "sqlparser.y" /* yacc.c:1646  */
    {
				/* 左辺値のチェック */
				if (_validate_lval(POOL, "not like", (yyvsp[-3].node))) {
					SET_ERRCD(DIVY_SQLP_ST_WRONG_LVAL);
					YYABORT;
				}

				/* $$SMxxx が IN句以外の演算子の右辺値 */
				if ((yyvsp[0].node) && (yyvsp[0].node)->nodetype == DIVY_NT_M_REQUIREDSQL) {
					ERRLOG3(POOL, APLOG_WARNING,
						DIVY_FST_CERR + DIVY_SST_SYNTAX,
						"The RequiredSQL \"%s\" was specified "
						"as rvalue operand of \"%s\" operator."
						"(lvalue = %s)", (yyvsp[0].node)->name, "not like", (yyvsp[-3].node)->name);
					SET_ERRCD(DIVY_SQLP_ST_WRONG_M_PREF);
					YYABORT;
				}

				if (_enable_making_expr("not like",(yyvsp[-3].node),(yyvsp[0].node))) {
					(yyval.node) = _makeExpr(P_CTX, DIVY_NT_OPERATOR,
									"not like", (yyvsp[-3].node), (yyvsp[0].node));	
				}
				else {
					(yyval.node) = _appendExpr((yyvsp[-3].node), (yyvsp[0].node));
				}
			}
#line 5611 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1081 "sqlparser.y" /* yacc.c:1646  */
    {
				/* 左辺値のチェック */
				if (_validate_lval(POOL, "not like", (yyvsp[-5].node))) {
					SET_ERRCD(DIVY_SQLP_ST_WRONG_LVAL);
					YYABORT;
				}

				/* $$SMxxx が IN句以外の演算子の右辺値 */
				if ((yyvsp[-2].node) && (yyvsp[-2].node)->nodetype == DIVY_NT_M_REQUIREDSQL) {
					ERRLOG3(POOL, APLOG_WARNING,
						DIVY_FST_CERR + DIVY_SST_SYNTAX,
						"The RequiredSQL \"%s\" was specified "
						"as rvalue operand of \"%s\" operator."
						"(lvalue = %s)", (yyvsp[-2].node)->name, "not like", (yyvsp[-5].node)->name);
					SET_ERRCD(DIVY_SQLP_ST_WRONG_M_PREF);
					YYABORT;
				}

				if (_enable_making_expr("not like",(yyvsp[-5].node),(yyvsp[-2].node))) {
					(yyval.node) = _makeExpr(P_CTX, DIVY_NT_OPERATOR,
									"not like", (yyvsp[-5].node), (yyvsp[-2].node));	
				}
				else {
					(yyval.node) = _appendExpr((yyvsp[-5].node), (yyvsp[-2].node));
				}
			}
#line 5642 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1108 "sqlparser.y" /* yacc.c:1646  */
    {
				if (_validate_lval(POOL, (yyvsp[-2].keyword), (yyvsp[-3].node))) {
					SET_ERRCD(DIVY_SQLP_ST_WRONG_LVAL);
					YYABORT;
				}

				/* $$SMxxx が IN句以外の演算子の右辺値 */
				if ((yyvsp[0].node) && (yyvsp[0].node)->nodetype == DIVY_NT_M_REQUIREDSQL) {
					ERRLOG3(POOL, APLOG_WARNING,
						DIVY_FST_CERR + DIVY_SST_SYNTAX,
						"The RequiredSQL \"%s\" was specified "
						"as rvalue operand of \"%s\" operator."
						"(lvalue = %s)", (yyvsp[0].node)->name, (yyvsp[-2].keyword), (yyvsp[-3].node)->name);
					SET_ERRCD(DIVY_SQLP_ST_WRONG_M_PREF);
					YYABORT;
				}

				if (_enable_making_expr((yyvsp[-2].keyword), (yyvsp[-3].node), (yyvsp[0].node))) {
					(yyval.node) = _makeExpr(P_CTX, DIVY_NT_OPERATOR, (yyvsp[-2].keyword), (yyvsp[-3].node), (yyvsp[0].node));	
				}
				else {
					(yyval.node) = _appendExpr((yyvsp[-3].node), (yyvsp[0].node));
				}
			}
#line 5671 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1133 "sqlparser.y" /* yacc.c:1646  */
    {
				if (_validate_lval(POOL, (yyvsp[-4].keyword), (yyvsp[-5].node))) {
					SET_ERRCD(DIVY_SQLP_ST_WRONG_LVAL);
					YYABORT;
				}

				/* $$SMxxx が IN句以外の演算子の右辺値 */
				if ((yyvsp[-2].node) && (yyvsp[-2].node)->nodetype == DIVY_NT_M_REQUIREDSQL) {
					ERRLOG3(POOL, APLOG_WARNING,
						DIVY_FST_CERR + DIVY_SST_SYNTAX,
						"The RequiredSQL \"%s\" was specified "
						"as rvalue operand of \"%s\" operator."
						"(lvalue = %s)", (yyvsp[-2].node)->name, (yyvsp[-4].keyword), (yyvsp[-5].node)->name);
					SET_ERRCD(DIVY_SQLP_ST_WRONG_M_PREF);
					YYABORT;
				}

				if (_enable_making_expr((yyvsp[-4].keyword), (yyvsp[-5].node), (yyvsp[-2].node))) {
					(yyval.node) = _makeExpr(P_CTX, DIVY_NT_OPERATOR, (yyvsp[-4].keyword), (yyvsp[-5].node), (yyvsp[-2].node));	
				}
				else {
					(yyval.node) = _appendExpr((yyvsp[-5].node), (yyvsp[-2].node));
				}
			}
#line 5700 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1158 "sqlparser.y" /* yacc.c:1646  */
    {
				if (_validate_lval(POOL, "not similar to", (yyvsp[-4].node))) {
					SET_ERRCD(DIVY_SQLP_ST_WRONG_LVAL);
					YYABORT;
				}

				/* $$SMxxx が IN句以外の演算子の右辺値 */
				if ((yyvsp[0].node) && (yyvsp[0].node)->nodetype == DIVY_NT_M_REQUIREDSQL) {
					ERRLOG3(POOL, APLOG_WARNING,
						DIVY_FST_CERR + DIVY_SST_SYNTAX,
						"The RequiredSQL \"%s\" was specified "
						"as rvalue operand of \"%s\" operator."
						"(lvalue = %s)", (yyvsp[0].node)->name, "not similar to",
						(yyvsp[-4].node)->name);
					SET_ERRCD(DIVY_SQLP_ST_WRONG_M_PREF);
					YYABORT;
				}

				if (_enable_making_expr((yyvsp[-3].keyword), (yyvsp[-4].node), (yyvsp[0].node))) {
					(yyval.node) = _makeExpr(P_CTX, DIVY_NT_OPERATOR, (yyvsp[-3].keyword), (yyvsp[-4].node), (yyvsp[0].node));	
				}
				else {
					(yyval.node) = _appendExpr((yyvsp[-4].node), (yyvsp[0].node));
				}
			}
#line 5730 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1184 "sqlparser.y" /* yacc.c:1646  */
    {
				if (_validate_lval(POOL, "not similar to", (yyvsp[-6].node))) {
					SET_ERRCD(DIVY_SQLP_ST_WRONG_LVAL);
					YYABORT;
				}

				/* $$SMxxx が IN句以外の演算子の右辺値 */
				if ((yyvsp[-2].node) && (yyvsp[-2].node)->nodetype == DIVY_NT_M_REQUIREDSQL) {
					ERRLOG3(POOL, APLOG_WARNING,
						DIVY_FST_CERR + DIVY_SST_SYNTAX,
						"The RequiredSQL \"%s\" was specified "
						"as rvalue operand of \"%s\" operator."
						"(lvalue = %s)", (yyvsp[-2].node)->name, "not similar to",
						(yyvsp[-6].node)->name);
					SET_ERRCD(DIVY_SQLP_ST_WRONG_M_PREF);
					YYABORT;
				}

				if (_enable_making_expr((yyvsp[-5].keyword), (yyvsp[-6].node), (yyvsp[-2].node))) {
					(yyval.node) = _makeExpr(P_CTX, DIVY_NT_OPERATOR, (yyvsp[-5].keyword), (yyvsp[-6].node), (yyvsp[-2].node));	
				}
				else {
					(yyval.node) = _appendExpr((yyvsp[-6].node), (yyvsp[-2].node));
				}
			}
#line 5760 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1214 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5766 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1215 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _makeNode(P_CTX, DIVY_NT_COLUMN, (yyvsp[0].str)); }
#line 5772 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1216 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _makeNode(P_CTX, DIVY_NT_COLUMN, (yyvsp[0].str)); }
#line 5778 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1217 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _makeNode(P_CTX, DIVY_NT_COLUMN, (yyvsp[0].keyword)); }
#line 5784 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1218 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _makeNode(P_CTX, DIVY_NT_COLUMN, (yyvsp[0].keyword)); }
#line 5790 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1219 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _makeNode(P_CTX, DIVY_NT_COLUMN, (yyvsp[0].keyword)); }
#line 5796 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1220 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5802 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1221 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5808 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1222 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5814 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1224 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5820 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1225 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5826 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1227 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-3].node); }
#line 5832 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1228 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 5838 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1234 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 5844 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1236 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5850 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1238 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5856 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1239 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5862 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1240 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5868 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1241 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node)); }
#line 5874 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1242 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node)); }
#line 5880 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1243 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node)); }
#line 5886 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1244 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node)); }
#line 5892 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1245 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node)); }
#line 5898 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1246 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node)); }
#line 5904 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1248 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node)); }
#line 5910 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1249 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node)); }
#line 5916 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1250 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node)); }
#line 5922 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1251 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5928 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1253 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node)); }
#line 5934 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1255 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 5940 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1256 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-2].node); }
#line 5946 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1257 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 5952 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1258 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-3].node); }
#line 5958 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1259 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 5964 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1260 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-2].node); }
#line 5970 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1261 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-3].node); }
#line 5976 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1262 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-2].node); }
#line 5982 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1263 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-3].node); }
#line 5988 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1264 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-2].node); }
#line 5994 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1265 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-3].node); }
#line 6000 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1272 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6006 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1273 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6012 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1275 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 6018 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1277 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 6024 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1279 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 6030 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1284 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 6036 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1285 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].keyword); }
#line 6042 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1320 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 6048 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1322 "sqlparser.y" /* yacc.c:1646  */
    {
				(yyval.node) = _appendExpr((yyvsp[-3].node), (yyvsp[-1].node));
			}
#line 6056 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1325 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 6062 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1327 "sqlparser.y" /* yacc.c:1646  */
    {
				(yyval.node) = _appendExpr((yyvsp[-3].node), (yyvsp[-1].node));
			}
#line 6070 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1332 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 6076 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1335 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 6082 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1338 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 6088 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1340 "sqlparser.y" /* yacc.c:1646  */
    {
				(yyval.node) = _appendExpr((yyvsp[-1].node), (yyvsp[0].node));
			}
#line 6096 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1346 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6102 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1350 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 6108 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1352 "sqlparser.y" /* yacc.c:1646  */
    {
				(yyval.node) = _appendExpr((yyvsp[-1].node), (yyvsp[0].node));
			}
#line 6116 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1357 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6122 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1361 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6128 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1362 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6134 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1363 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6140 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1367 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6146 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1368 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6152 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1369 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6158 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1376 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 6164 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1377 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 6170 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1378 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 6176 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1385 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6182 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1386 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6188 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1387 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6194 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1389 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6200 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1390 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6206 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1391 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6212 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1392 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6218 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1393 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 6224 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1394 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 6230 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1396 "sqlparser.y" /* yacc.c:1646  */
    {	/* $$SMxxx がBETWEEN 演算子と共に使用された */
				ERRLOG1(POOL, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
					"The RequiredSQL \"%s\" was specified "
					"as BETWEEN parameter." , (yyvsp[0].node)->name);
				SET_ERRCD(DIVY_SQLP_ST_WRONG_M_PREF);
				YYABORT;
			}
#line 6242 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1403 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 6248 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1404 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 6254 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1405 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6260 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1411 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 6266 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1412 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node)); }
#line 6272 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1419 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 6278 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1421 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _appendExpr((yyvsp[-2].node), (yyvsp[0].node)); }
#line 6284 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1424 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6290 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1425 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6296 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1426 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6302 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1427 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6308 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1428 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6314 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1429 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6320 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1430 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6326 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1431 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 6332 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1432 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 6338 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1434 "sqlparser.y" /* yacc.c:1646  */
    { /* $$SMxxx が関数の中に指定された場合 */
				ERRLOG1(POOL, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
					"The RequiredSQL \"%s\" was specified "
					"as function parameter.", (yyvsp[0].node)->name);
				SET_ERRCD(DIVY_SQLP_ST_WRONG_M_PREF);
				YYABORT;
			}
#line 6350 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1442 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 6356 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1444 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-3].node); }
#line 6362 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1445 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6368 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1452 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6374 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1454 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6380 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1456 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6386 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1457 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6392 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1458 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6398 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1459 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6404 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1460 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 6410 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1530 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.keyword) = NULL; }
#line 6416 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1531 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.keyword) = NULL; }
#line 6422 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 507:
#line 1707 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _makeNode(P_CTX, DIVY_NT_NAMEDBIND,     (yyvsp[0].str)); }
#line 6428 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 508:
#line 1708 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _makeNode(P_CTX, DIVY_NT_S_REQUIREDSQL, (yyvsp[0].str)); }
#line 6434 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 509:
#line 1714 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _makeNode(P_CTX, DIVY_NT_M_REQUIREDSQL, (yyvsp[0].str)); }
#line 6440 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 510:
#line 1720 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _makeNode(P_CTX, DIVY_NT_BIND, (yyvsp[0].str)); }
#line 6446 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 511:
#line 1727 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _makeNode(P_CTX, DIVY_NT_COLUMN, (yyvsp[0].str)); }
#line 6452 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 512:
#line 1728 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _makeNode(P_CTX, DIVY_NT_COLUMN, (yyvsp[0].str)); }
#line 6458 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 513:
#line 1730 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.node) = _makeNode(P_CTX, DIVY_NT_COLUMN, (yyvsp[0].keyword)); }
#line 6464 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 514:
#line 1738 "sqlparser.y" /* yacc.c:1646  */
    {
				/* シングルクオートが正しく閉じられていなかった */
				ERRLOG0(POOL, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
					"The single-quote is not closed.");
				SET_ERRCD(DIVY_SQLP_ST_UNQUOTED_STR);
				YYABORT;
			}
#line 6476 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 515:
#line 1746 "sqlparser.y" /* yacc.c:1646  */
    {
				/* ダブルクオートが正しく閉じられていなかった */
				ERRLOG0(POOL, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
					"The dobule-quote is not closed.");
				SET_ERRCD(DIVY_SQLP_ST_UNQUOTED_DQSTR);
				YYABORT;
			}
#line 6488 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 516:
#line 1754 "sqlparser.y" /* yacc.c:1646  */
    {
				/* コメントが正しく閉じられていなかった */
				ERRLOG0(POOL, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
					"The c-style comment is not closed.");
				SET_ERRCD(DIVY_SQLP_ST_UNQUOTED_CTSTR);
				YYABORT;
			}
#line 6500 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 517:
#line 1770 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 6506 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 518:
#line 1771 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 6512 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 519:
#line 1777 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = "+"; }
#line 6518 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 520:
#line 1778 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = "-"; }
#line 6524 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 521:
#line 1779 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = "*"; }
#line 6530 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 522:
#line 1780 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = "/"; }
#line 6536 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 523:
#line 1781 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = "%"; }
#line 6542 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 524:
#line 1782 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = "^"; }
#line 6548 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 525:
#line 1783 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = "<"; }
#line 6554 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 526:
#line 1784 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = ">"; }
#line 6560 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 527:
#line 1785 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = "="; }
#line 6566 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 528:
#line 1793 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str);  }
#line 6572 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 529:
#line 1794 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str);  }
#line 6578 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 530:
#line 1795 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str);  }
#line 6584 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 531:
#line 1796 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = "<"; }
#line 6590 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 532:
#line 1797 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = ">"; }
#line 6596 "sqlparser.c" /* yacc.c:1646  */
    break;

  case 533:
#line 1798 "sqlparser.y" /* yacc.c:1646  */
    { (yyval.str) = "="; }
#line 6602 "sqlparser.c" /* yacc.c:1646  */
    break;


#line 6606 "sqlparser.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (p_ctx, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (p_ctx, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, p_ctx);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, p_ctx);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (p_ctx, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, p_ctx);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, p_ctx);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1849 "sqlparser.y" /* yacc.c:1906  */


/**
 * パーサで発生したエラーを報告する。
 * (note)
 *	構文解析パーサが自動的に呼び出すエラーハンドラです。
 * (note)
 *	構文解析パーサは、error構文によって予め逃がしていたエラーに対しても
 *	容赦なくエラーログ関数yyerror を出力してしまいます。
 *	ただ、重要なメッセージもあるため、informationという形で出力
 *	することにします。そのためにも、_REMOVE_ERR_MSG_PART で定義された
 *	エラーを匂わすメッセージを切り取ります。
 *
 * @param str const char *
 */
void yyerror(divy_sql_parser_ctx *p_ctx, const char *str)
{
	const char *errmsg;

	/*
	 * エラーを匂わすエラーメッセージ文字列を削り取る
	 */
	if (str && (errmsg = divy_strstr_c((char *)str, _REMOVE_ERR_MSG_PART)) != NULL &&
							str == errmsg) {
		/* _REMOVE_ERR_MSG_PART 以降の文字列を取り出す */
		errmsg = (const char *) &str[_REMOVE_ERR_MSG_PART_EN];
	}
	else {
		errmsg = str;
	}

	/*
	 * メッセージの出力
	 */
	ERRLOG1(NULL, APLOG_NOTICE, DIVY_FST_INFO + DIVY_SST_SYNTAX,
		"[sqlparser report]: %s.", errmsg);
	return;
}

/**
 * typeとvalue を持つdivy_sql_elemnode を生成して返却する.
 *
 * @param p_ctx divy_sql_parser_ctx * パーサコンテキスト
 * @param type divy_sql_nodetype
 * @param value char *
 * @return divy_sql_elemnode * 生成したノード
 */
static divy_sql_elemnode * _makeNode(divy_sql_parser_ctx *p_ctx,
					divy_sql_nodetype type, char *value)
{
	divy_sql_elemnode *node = apr_palloc(p_ctx->p, sizeof(divy_sql_elemnode));

	node->nodetype    = type;
	node->name        = apr_pstrdup(p_ctx->p, value);	/* 名前に割り当てる */
	node->next        = NULL;
	node->first_child = NULL;
	node->belong_nodetype = DIVY_NT_UNKNOWN;	/* 初期値 */
	node->pos         = p_ctx->sqlposition;

	return node;
}

/**
 * 式を表すノードを生成する
 *
 * @param p_ctx divy_sql_parser_ctx * パーサコンテキスト
 * @param type divy_sql_nodetype
 * @param op char * 演算子を表す文字列
 * @param lnode divy_sql_elemnode * 左辺値 (Lvalue)
 * @param rnode divy_sql_elemnode * 右辺値 (Rvalue)
 * @return divy_sql_elemnode * 生成したノード
 */
static divy_sql_elemnode * _makeExpr(divy_sql_parser_ctx *p_ctx,
					divy_sql_nodetype type,
					char *op,
					divy_sql_elemnode *lnode,
					divy_sql_elemnode *rnode)
{
	divy_sql_elemnode *node = apr_palloc(p_ctx->p, sizeof(divy_sql_elemnode));

	node->nodetype  = type;
	node->name      = apr_pstrdup(p_ctx->p, op);	/* 名前に割り当てる */
	node->next      = NULL;
	node->belong_nodetype = DIVY_NT_UNKNOWN;	/* 初期値 */

	node->first_child = lnode;
	if (node->first_child) {
		node->first_child->next = rnode;
	}
	else {
		/* op が単項演算子の場合 */
		node->first_child = rnode;
	}

	return node;
}

/**
 * l1 の末尾にl2を繋げる
 * (note)
 * 	l1がNULLならば、l2を返却します
 *	l2がNULLならば、l1をそのまま返却します
 *
 * @param l1 divy_sql_elemnode * 連結先SQLノード
 * @param l2 divy_sql_elemnode * 連結SQLノード
 * @return divy_sql_elemnode * 連結したSQLノード
 */
static divy_sql_elemnode * _appendExpr(divy_sql_elemnode *l1,
						divy_sql_elemnode *l2)
{
	divy_sql_elemnode *list;

	if (l1 == NULL) return l2;
	if (l2 == NULL) return l1;

	for (list = l1; list->next; list = list->next);
	list->next = l2;

	return l1;
}

/**
 * SELECT句が持つカラム数のカウンターをインクリメントする
 * (note)
 *	最初のSELECT句に現れるカラムの個数だけを数える
 *	(例)
 *		SELECT id,id2, (SELECT id3 FROM bbb
 *				WHERE id = (SELECT id4 FROM c)) as A FROM ...
 *		--> カウンタは３. id3,id4 は数えない
 */
static void _incrementSelectColCnt(divy_sql_parser_ctx *p_ctx)
{
	/* 最初に現れるカラムだけ対象 */
	if (p_ctx->select_id == 1) {
		p_ctx->select_colcnt++;

		/* 大きい方の値を持っておく */
		if (p_ctx->select_colcnt > p_ctx->max_select_colcnt) {
			p_ctx->max_select_colcnt = p_ctx->select_colcnt;
		}
	}
}

/**
 * SELECT句カラム数カウンタをクリアする
 */
static void _resetSelectColCnt(divy_sql_parser_ctx *p_ctx)
{
	p_ctx->select_colcnt = 0;
}

static void _resetMaxSelectColCnt(divy_sql_parser_ctx *p_ctx)
{
	p_ctx->max_select_colcnt = 0;
}

/**
 * lnode がop の左辺値として指定可能かどうかチェックする
 *
 * @param p apr_pool_t *
 * @param lnode divy_sql_elemnode * 左辺値
 * @return int (1: 指定できない / 0: 指定できる)
 */
static int _validate_lval(apr_pool_t *p, char *op, divy_sql_elemnode *lnode)
{
	if (lnode == NULL) return 0;

	/* RequiredSQL($$SS, $$SM)、名前付きバインド変数($$B) は
	   左辺値になれない */
	if (lnode->nodetype == DIVY_NT_NAMEDBIND ||
	    lnode->nodetype == DIVY_NT_S_REQUIREDSQL ||
	    lnode->nodetype == DIVY_NT_M_REQUIREDSQL) {

		ERRLOG2(p, APLOG_WARNING, DIVY_FST_CERR + DIVY_SST_SYNTAX,
			"The variable \"%s\" was specified "
			"as left value operand of \"%s\" operator.",
			REPLACE_NULL(lnode->name), REPLACE_NULL(op));
		return 1;
	}

	return 0;
}

/**
 * 指定されたオペレータop でlnodeを左辺値にrnodeを右辺値とする
 * 式と表現してよいかどうかを判定する。
 *
 * (note) 作成可能な条件
 *	これはSQL文の仕様ではなく、TeamFileの画面表示仕様を満たす
 *	目的で実施するチェックです。
 *	左辺値がDBカラムまたは通常バインド変数の時のみ作成可能と
 *	判断します。
 *
 * @param op char * オペレータ
 * @param lnode divy_sql_elemnode * 左辺値
 * @param rnode divy_sql_elemnode * 右辺値
 * @return int (0: 作成できない / 1: 作成できる)
 */
static int _enable_making_expr(char *op, divy_sql_elemnode *lnode,
				divy_sql_elemnode *rnode)
{
	/* (note) op は予約された引数。今は使っていません */
	if (lnode == NULL || rnode == NULL) return 0;

	/* 左辺値がDBカラム、通常バインド変数ならOK */
	if (lnode->nodetype == DIVY_NT_COLUMN ||
	    lnode->nodetype == DIVY_NT_BIND) {
		return 1;
	}

	return 0;
}

